function [check_RR] = Russian_rules_func_LNG(zp_stiff_eff,Girders,Webframe_ID,Webframe_YZ_start,Webframe_YZ_end,Isklasse,B,L,Strakes,Csec_size,Delta,ey_stiff_eff);


if B <= 20 %[m]
    h1 = [0.5 0.5 0.5 0.60 0.75 0.75 0.75 0.75 0.75]; %[m]       
else
    h1 = [0.5 (0.5*B+8)/36 (0.5*B+8)/36 (0.5*B+8)/30 (0.5*B+8)/24 (0.5*B+8)/24 (0.5*B+8)/24 (0.5*B+8)/24 (0.5*B+8)/24]; %[m]
end

%Ice class parameters%
h2 = [0.2 0.2 0.2 0.6 0.8 0.8 1.4 1.4 1.4]; %[m]
h3 = [1 1 1.1 1.2 1.35 1.35 1.6 1.6 1.6].*h1; %[m]
L2 = L*[0 0.02 0.02 0.05 0.1 0.1 0.15 0.15 0.15]; %[m]
L3 = L*[0.02 0.02 0.04 0.045 0.05 0.05 0.06 0.06 0.06]; %[m]
k1 = [0 0.5 0.53 0.55 0.69 0.69 0.84 0.84 0.84]; %[m]
a3 = [0 0.22 0.33 0.5 0.78 1.2 1.84 3.7 5.6]; %[-]
aB2 = [0 0 0 0.4 0.5 0.5 0.5 0.55 0.55];
aB3 = [0 0 0 0 0.4 0.45 0.45 0.45 0.45];
aB4 = [0 0 0 0 0 0 0 0.25 0.3];
C3 = [0 0.27 0.3 0.34 0.4 0.47 0.5 0.5 0.5];
u = [0.21 0.21 0.21 0.26 0.28 0.3 0.3 0.3 0.3];
k1_plate = [1.3 1.3 1.3 1.3 1.3 1.2 1.1 1 1];

if Isklasse == 1
    h1 = h1(1,1); 
    h2 = h2(1,1);
    h3 = h3(1,1);
    L2 = L2(1,1);
    L3 = L3(1,1);
    k1 = k1(1,1);
    a3 = a3(1,1);
    aB2 = aB2(1,1);
    aB3 = aB3(1,1);
    aB4 = aB4(1,1);
    C3 = C3(1,1);
    u = u(1,1);
    k1_plate = k1_plate(1,1);
%     Sl = Sl(1,1);
%     Sb = Sb(1,1);
elseif Isklasse == 2
    h1 = h1(1,2);
    h2 = h2(1,2);
    h3 = h3(1,2);
    L2 = L2(1,2);
    L3 = L3(1,2);
    k1 = k1(1,2);
    a3 = a3(1,2);
    aB2 = aB2(1,2);
    aB3 = aB3(1,2);
    aB4 = aB4(1,2);
    C3 = C3(1,2);
    u = u(1,2);
    k1_plate = k1_plate(1,2);
%     Sl = Sl(1,2);
%     Sb = Sb(1,2);
elseif Isklasse == 3
    h1 = h1(1,3);
    h2 = h2(1,3);
    h3 = h3(1,3);
    L2 = L2(1,3);
    L3 = L3(1,3);
    k1 = k1(1,3);
    a3 = a3(1,3);
    aB2 = aB2(1,3);
    aB3 = aB3(1,3);
    aB4 = aB4(1,3);
    C3 = C3(1,3);
    u = u(1,3);
    k1_plate = k1_plate(1,3);
%     Sl = Sl(1,3);
%     Sb = Sb(1,3);
elseif Isklasse == 4
    h1 = h1(1,4) ; 
    h2 = h2(1,4);
    h3 = h3(1,4);
    L2 = L2(1,4);
    L3 = L3(1,4);
    k1 = k1(1,4);
    a3 = a3(1,4);
    aB2 = aB2(1,4);
    aB3 = aB3(1,4);
    aB4 = aB4(1,4);
    C3 = C3(1,4);
    u = u(1,4);
    k1_plate = k1_plate(1,4);
%     Sl = Sl(1,4);
%     Sb = Sb(1,4);
elseif  Isklasse == 5
    h1 = h1(1,5);
    h2 = h2(1,5);
    h3 = h3(1,5);
    L2 = L2(1,5);
    L3 = L3(1,5);
    k1 = k1(1,5);
    a3 = a3(1,5);
    aB2 = aB2(1,5);
    aB3 = aB3(1,5);
    aB4 = aB4(1,5);
    C3 = C3(1,5);
    u = u(1,5);
    k1_plate = k1_plate(1,5);
%     Sl = Sl(1,5);
%     Sb = Sb(1,5);
elseif   Isklasse == 6
    h1 = h1(1,6);
    h2 = h2(1,6);
    h3 = h3(1,6);
    L2 = L2(1,6);
    L3 = L3(1,6);
    k1 = k1(1,6);
    a3 = a3(1,6);
    aB2 = aB2(1,6);
    aB3 = aB3(1,6);
    aB4 = aB4(1,6);
    C3 = C3(1,6);
    u = u(1,6);
    k1_plate = k1_plate(1,6);
%     Sl = Sl(1,6);
%     Sb = Sb(1,6);
elseif   Isklasse == 7
    h1 = h1(1,7);
    h2 = h2(1,7);
    h3 = h3(1,7);
    L2 = L2(1,7);
    L3 = L3(1,7);
    k1 = k1(1,7);
    a3 = a3(1,7);
    aB2 = aB2(1,7);
    aB3 = aB3(1,7);
    aB4 = aB4(1,7);
    C3 = C3(1,7);
    u = u(1,7);
    k1_plate = k1_plate(1,7);
%     Sl = Sl(1,7);
%     Sb = Sb(1,7);
elseif   Isklasse == 8
    h1 = h1(1,8);
    h2 = h2(1,8);
    h3 = h3(1,8);
    L2 = L2(1,8);
    L3 = L3(1,8);
    k1 = k1(1,8);
    a3 = a3(1,8);
    aB2 = aB2(1,8);
    aB3 = aB3(1,8);
    aB4 = aB4(1,8);
    C3 = C3(1,8);
    u = u(1,8);
    k1_plate = k1_plate(1,8);
%     Sl = Sl(1,8);
%     Sb = Sb(1,8);
elseif   Isklasse == 9
    h1 = h1(1,9);
    h2 = h2(1,9);
    h3 = h3(1,9);
    L2 = L2(1,9);
    L3 = L3(1,9);
    k1 = k1(1,9);
    a3 = a3(1,9);
    aB2 = aB2(1,9);
    aB3 = aB3(1,9);
    aB4 = aB4(1,9);
    C3 = C3(1,9);
    u = u(1,9);
    k1_plate = k1_plate(1,9);
%     Sl = Sl(1,9);
%     Sb = Sb(1,9);
end



%MAXIMUM SPACING OF STIFFENERS (Longitudinally stiffened)%
if Isklasse == 9 || Isklasse == 8 || Isklasse == 7 || Isklasse == 6
    for i=1:Csec_size/2
        
        %Spacing in region I,II,III,IV (Not including floors and center girder%
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            s(i,1) = 0.6; %[m]
        end
    end
end

if Isklasse == 5
    for i=1:Csec_size/2
        
        %Spacing in region I%
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7
            s(i,1) = 0.8; %[m]
            
        %Spacing in region I,II,III%
        elseif Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            s(i,1) = 0.6; %[m]
        end
    end
end

if Isklasse == 4
    for i=1:Csec_size/2
        
        %Spacing in region I%
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            s(i,1) = 0.8; %[m]
        end
    end
end



%ICE PRESSURE%
%Ice pressure region I, for midship - B%
pBI = 1200*a3*nthroot(Delta/1000,6);        %[kPa]

for i=1:Csec_size/2
    if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
        pB(i,1) = pBI;                      %[kPa]
    end
end

%Ice pressure region II, for midship - B%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 7
        pB(i,1) = aB2*pBI;                  %[kPa]
    end
end

%Ice pressure region III, for midship - B%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6
        pB(i,1) = aB3*pBI;                  %[kPa]
    end
end

%Ice pressure region IV, for midship - B %
for i=1:Csec_size/2
    if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 ||Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 ||Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 ||Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 ||Strakes(1,1,i) == 20
        pB(i,1) = aB4*pBI;                  %[kPa]
    end
end



%VERTICAL DISTRIBUTION OF ICE PRESSURE%
k_delta = nthroot(Delta/1000,3);

if k_delta > 3.5
    k_delta = 3.5;
end

C4 = 1;                                     %Only required to have a slope at Arc 8 and 9

%Vertical distribution of ice pressure, for midship - B%
if Isklasse == 9 || Isklasse == 8
    for i=1:Csec_size/2
        
        %Vertical distribution for strakes within region I,II.III and IV%
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            bB(i,1) = C3*C4*k_delta; %[m]
        end
    end
end

if Isklasse == 5 || Isklasse == 6 || Isklasse == 7
    for i=1:Csec_size/2
        
        %Vertical distribution for strakes within region I,II and III%
        if  Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            bB(i,1) = C3*C4*k_delta; %[m]
        end
    end
end

if Isklasse == 4
    for i=1:Csec_size/2
        
        %Vertical distribution for strakes within region I and II%
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            bB(i,1) = C3*C4*k_delta; %[m]
        end
    end
end

if Isklasse == 2 || Isklasse == 3
    for i=1:Csec_size/2
        
        %Vertical distribution for strakes within region I%
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            bB(i,1) = C3*C4*k_delta; %[m]
        end
    end
end


%HORISONTAL DISTRIBUTION OF ICE PRESSURE, for midship - B%
for i=1:size(bB,1)
        lpB(i,1) = 6*bB(i,1); %[m]
        
        if lpB(i,1) == 0
            lpB(i,1) = lpB(i,1);            
        elseif  lpB(i,1) < 3*sqrt(k_delta);
            lpB(i,1) = 3*sqrt(k_delta);
        end
end


%SHELL PLATING THICKNESS (Longitudinally stiffened%

T = 20;                         %Planned ship life, in years
ReH = 355;                      %Upper yield stress [MPa]

Delta_Ssp0 = 0.75*T*u;

for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 ||Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
            
            Ssp(i,1) = Ssp0(i,1) + Delta_Ssp0;                              %mm
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
            
            Ssp(i,1) = Ssp0(i,1) + Delta_Ssp0;                              %mm 
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
            
            Ssp(i,1) = Ssp0(i,1) + Delta_Ssp0;                              %mm
        end
    elseif Isklasse == 2 || Isklasse == 3
        if Strakes(1,1,i) == 8
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
            
            Ssp(i,1) = Ssp0(i,1) + Delta_Ssp0;                              %mm
        end
    end
end

%Determening the actual value of the ultimate section modulus of longitudinals%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            bef(i,1) =  Strakes(1,4,i)*10^2;                                                        %Effective flange breadth in cm, to be adopted equal to:
                                                                                                    %Conventional frame spacing for conventional and deep frames where transverse framing is used;
                                                                                                    %Longitudinal spacing,for longitudinals where longitudinal framing is used;
                                                                                                    %1/6 of deep frame span between decks or platforms, or of frame spacing, whichever is less,for deed frames where longitudinal framing is used;
                                                                                                    %1/6 frame spaceing, for stringers where web framing is used;
                                                                                                    %Half the sum of spacings of two adjacent girders of the same direction or 1/6 of girder span, whichever is less, in all other cases.

            tfp(i,1) = 1.5*Strakes(1,13,i)*10;                                                                           %tfp = 1.5*Strakes(1,13,i)*10 for bulb profiles                                                    %Face plate thickness in mm
            
            tef(i,1) = Strakes(1,3,i)*10;                                                           %Effective flange thickness in mm
            
            fef(i,1) = 0.1*bef(i,1)*tef(i,1);                                                       %Effective flange area of shell plating in cm2
            
            h(i,1) = (Strakes(1,3,i)/2)+Strakes(1,14,i)*10^-1;                                           %h(i,1) = (Strakes(1,15,i)*10^-1) for hp profiles;
            
            fw(i,1) = 0.1*(h(i,1)-0.05*(tfp(i,1)+tef(i,1)))*Strakes(1,13,i)*10;                          %[cm2]
            
            fsec(i,1) = Strakes(1,9,i);                                                             %[cm2]
            
            if fef(i,1) >= fsec(i,1)
                C(i,1) = 0;
            elseif fef(i,1) < fsec(i,1)
                C(i,1) = ((fsec(i,1)-fef(i,1))^2)/(4*fw(i,1));
            end

            if fef(i,1) >= fsec(i,1)
                Wa(i,1) = fsec(i,1)*(ey_stiff_eff(i,1)+0.05*tef(i,1));                              %[cm3]
            else
                Wa(i,1) = h(i,1)*(fsec(i,1) - 0.5*fw(i,1) - C(i,1));               %[cm3]
            end
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            bef(i,1) =  Strakes(1,4,i)*10^2;                                                        %Effective flange breadth in cm, to be adopted equal to:
                                                                                                    %Conventional frame spacing for conventional and deep frames where transverse framing is used;
                                                                                                    %Longitudinal spacing,for longitudinals where longitudinal framing is used;
                                                                                                    %1/6 of deep frame span between decks or platforms, or of frame spacing, whichever is less,for deed frames where longitudinal framing is used;
                                                                                                    %1/6 frame spaceing, for stringers where web framing is used;
                                                                                                    %Half the sum of spacings of two adjacent girders of the same direction or 1/6 of girder span, whichever is less, in all other cases.

            tfp(i,1) = 0;                                                                           %tfp = 1.5*Strakes(1,13,i)*10 for bulb profiles                                                    %Face plate thickness in mm
            
            tef(i,1) =  Strakes(1,3,i)*10;                                                           %Effective flange thickness in mm
                
            fef(i,1) = 0.1*bef(i,1)*tef(i,1);                                                       %Effective flange area of shell plating in cm2
            
            h(i,1) = (Strakes(1,3,i)/2)+Strakes(1,14,i)*10^-1;                                           %h(i,1) = (Strakes(1,15,i)*10^-1) for hp profiles;
            
            fw(i,1) = 0.1*(h(i,1)-0.05*(tfp(i,1)+tef(i,1)))*Strakes(1,13,i)*10;                          %[cm2]
            
            fsec(i,1) = Strakes(1,9,i);                                                             %[cm2]
            
            if fef(i,1) >= fsec(i,1)
                C(i,1) = 0;
            elseif fef(i,1) < fsec(i,1)
                C(i,1) = ((fsec(i,1)-fef(i,1))^2)/(4*fw(i,1));
            end
            
            if fef(i,1) >= fsec(i,1)
                Wa(i,1) = fsec(i,1)*(ey_stiff_eff(i,1)+0.05*tef(i,1));                              %[cm3]
            else
                Wa(i,1) = h(i,1)*(fsec(i,1) - 0.5*fw(i,1) - C(i,1));               %[cm3]
            end
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            bef(i,1) =  Strakes(1,4,i)*10^2;                                                        %Effective flange breadth in cm, to be adopted equal to:
                                                                                                    %Conventional frame spacing for conventional and deep frames where transverse framing is used;
                                                                                                    %Longitudinal spacing,for longitudinals where longitudinal framing is used;
                                                                                                    %1/6 of deep frame span between decks or platforms, or of frame spacing, whichever is less,for deed frames where longitudinal framing is used;
                                                                                                    %1/6 frame spaceing, for stringers where web framing is used;
                                                                                                    %Half the sum of spacings of two adjacent girders of the same direction or 1/6 of girder span, whichever is less, in all other cases.

            tfp(i,1) = 0;                                                                           %tfp = 1.5*Strakes(1,13,i)*10 for bulb profiles                                                    %Face plate thickness in mm
            
            tef(i,1) = Strakes(1,3,i)*10;                                                           %Effective flange thickness in mm
                
            fef(i,1) = 0.1*bef(i,1)*tef(i,1);                                                       %Effective flange area of shell plating in cm2
            
            h(i,1) = (Strakes(1,3,i)/2)+Strakes(1,14,i)*10^-1;                                           %h(i,1) = (Strakes(1,15,i)*10^-1) for hp profiles;
            
            fw(i,1) = 0.1*(h(i,1)-0.05*(tfp(i,1)+tef(i,1)))*Strakes(1,13,i)*10;                          %[cm2]
            
            fsec(i,1) = Strakes(1,9,i);                                                             %[cm2]
            
            if fef(i,1) >= fsec(i,1)
                C(i,1) = 0;
            elseif fef(i,1) < fsec(i,1)
                C(i,1) = ((fsec(i,1)-fef(i,1))^2)/(4*fw(i,1));
            end
            
            if fef(i,1) >= fsec(i,1)
                Wa(i,1) = fsec(i,1)*(ey_stiff_eff(i,1)+0.05*tef(i,1));                              %[cm3]
            else
                Wa(i,1) = h(i,1)*(fsec(i,1) - 0.5*fw(i,1) - C(i,1));               %[cm3]
            end
        end
    elseif Isklasse == 2 || Isklasse == 3
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            bef(i,1) =  Strakes(1,4,i)*10^2;                                                        %Effective flange breadth in cm, to be adopted equal to:
                                                                                                    %Conventional frame spacing for conventional and deep frames where transverse framing is used;
                                                                                                    %Longitudinal spacing,for longitudinals where longitudinal framing is used;
                                                                                                    %1/6 of deep frame span between decks or platforms, or of frame spacing, whichever is less,for deed frames where longitudinal framing is used;
                                                                                                    %1/6 frame spaceing, for stringers where web framing is used;
                                                                                                    %Half the sum of spacings of two adjacent girders of the same direction or 1/6 of girder span, whichever is less, in all other cases.

            tfp(i,1) = 0;                                                                           %tfp = 1.5*Strakes(1,13,i)*10 for bulb profiles                                                    %Face plate thickness in mm
            
            tef(i,1) = Strakes(1,3,i)*10;                                                           %Effective flange thickness in mm
                
            fef(i,1) = 0.1*bef(i,1)*tef(i,1);                                                       %Effective flange area of shell plating in cm2
            
            h(i,1) = (Strakes(1,3,i)/2)+Strakes(1,14,i)*10^-1;                                           %h(i,1) = (Strakes(1,15,i)*10^-1) for hp profiles;
            
            fw(i,1) = 0.1*(h(i,1)-0.05*(tfp(i,1)+tef(i,1)))*Strakes(1,13,i)*10;                          %[cm2]
            
            fsec(i,1) = Strakes(1,9,i);                                                             %[cm2]
            
            if fef(i,1) >= fsec(i,1)
                C(i,1) = 0;
            elseif fef(i,1) < fsec(i,1)
                C(i,1) = ((fsec(i,1)-fef(i,1))^2)/(4*fw(i,1));
            end

            if fef(i,1) >= fsec(i,1)
                Wa(i,1) = fsec(i,1)*(ey_stiff_eff(i,1)+0.05*tef(i,1));                              %[cm3]
            else
                Wa(i,1) = h(i,1)*(fsec(i,1) - 0.5*fw(i,1) - C(i,1));               %[cm3]
            end
        end
    end
end

%Determening the actual value of the web area of longitudinal%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Aa(i,1) = (Strakes(1,3,i)+Strakes(1,11,i))*Strakes(1,13,i);
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Aa(i,1) = (Strakes(1,3,i)+Strakes(1,11,i))*Strakes(1,13,i);
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Aa(i,1) = (Strakes(1,3,i)+Strakes(1,11,i))*Strakes(1,13,i);
        end
    elseif Isklasse == 2 || Isklasse == 3
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Aa(i,1) = (Strakes(1,3,i)+Strakes(1,11,i))*Strakes(1,13,i);
        end
    end
end



%Side and bottom longitudinals as part of longitudinal framing%

for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            if bB(i,1)<Strakes(1,2,i)/100
                b_avrg(i,1) = bB(i,1)./Strakes(1,4,i);
            else
                b_avrg(i,1) = (Strakes(1,2,i)/100)./Strakes(1,4,i);
            end
            
            k0(i,1) = 1-(0.3/b_avrg(i,1));
            
            if b_avrg(i,1) >= 2
                b2(i,1) = Strakes(1,4,i);
            else
                b2(i,1) = bB(i,1)*(1-0.25*b_avrg(i,1));
            end
            
            b1(i,1) = k0(i,1)*b2(i,1);
            
            c = 1;                                                                                  %c = 1, for bottom longitudinals and for side longitudinals where no panting frames are fitted
            
            Delta_s = u*(T-12);
            
            kl_A(i,1) = 0.8;
            
            if kl_A(i,1) > 1/(1+0.76*(a0(i,1)/(Strakes(1,2,i)/100)));
                kl_A(i,1) = 0.8;
            else
                kl_A(i,1) = 1/(1+0.76*(a0(i,1)/(Strakes(1,2,i)/100)));
            end
            
            %The web area requirement, in cm2, of a longitudinal%
            Al(i,1) = (8.7/ReH)*pB(i,1)*b1(i,1)*(Strakes(1,2,i)/100)*c*kl_A(i,1) + 0.1*(Strakes(1,14,i)*10^-1)*Delta_s;
            
            
            kc = 0.9;                                                                               %kc = 0.9 for rolled profiles and 0.85 for welded profiles
            
            ks = 1;                                                                                 %ks = 1 for plate sections, ks = 0.8 in other cases
            
            omega_l(i,1) = 1.15;                                                                    %omega_l = 1.15 for the purpose of simplified calculations in accordance with 3.10.4.2.4
            
            gamma_l(i,1) = Al(i,1)/Aa(i,1);
            
            if gamma_l(i,1) > 1
                gamma_l(i,1) = 1;
            end
            
            kl(i,1) = 1/(1+sqrt(1-ks*(gamma_l(i,1).^2)));
            
            Wl0(i,1) = (125/ReH)*pB(i,1)*b1(i,1)*(Strakes(1,2,i)/100)*((Strakes(1,2,i)/100)-0.5*Strakes(1,4,i))*(c^2)*omega_l(i,1);
            
            %The ultimate section modulus requirements of longitudinals%
            Wl(i,1) = Wl0(i,1)*kl(i,1);
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            b_avrg(i,1) = bB(i,1)./Strakes(1,4,i);
            
            k0(i,1) = 1-(0.3/b_avrg(i,1));
            
            if b_avrg(i,1) >= 2
                b2(i,1) = Strakes(1,4,i);
            else
                b2(i,1) = bB(i,1)*(1-0.25*b_avrg(i,1));
            end
            
            b1(i,1) = k0(i,1)*b2(i,1);
            
            c = 1;                                                                                  %c = 1, for bottom longitudinals and for side longitudinals where no panting frames are fitted
            
            Delta_s = u*(T-12);
            
            kl_A(i,1) = 0.8;
            
            if kl_A(i,1) > 1/(1+0.76*(a0(i,1)/(Strakes(1,2,i)/100)));
                kl_A(i,1) = 0.8;
            else
                kl_A(i,1) = 1/(1+0.76*(a0(i,1)/(Strakes(1,2,i)/100)));
            end
            
            %The web area requirement, in cm2, of a longitudinal%
            Al(i,1) = (8.7/ReH)*pB(i,1)*b1(i,1)*(Strakes(1,2,i)/100)*c*kl_A(i,1) + 0.1*(Strakes(1,14,i)*10^-1)*Delta_s;
            
            
            kc = 0.85;                                                                               %kc = 0.9 for rolled profiles and 0.85 for welded profiles
            
            ks = 1;                                                                                 %ks = 1 for plate sections, ks = 0.8 in other cases
            
            omega_l(i,1) = 1.15;                                                                   %omega_l = 1.15 for the purpose of simplified calculations in accordance with 3.10.4.2.4
            
            gamma_l(i,1) = Al(i,1)/Aa(i,1);
            
            if gamma_l(i,1) > 1
                gamma_l(i,1) = 1;
            end
            
            kl(i,1) = 1/(1+sqrt(1-ks*(gamma_l(i,1).^2)));
            
            Wl0(i,1) = (125/ReH)*pB(i,1)*b1(i,1)*(Strakes(1,2,i)/100)*((Strakes(1,2,i)/100)-0.5*Strakes(1,4,i))*(c^2)*omega_l(i,1);
            
            %The ultimate section modulus requirements of longitudinals%
            Wl(i,1) = Wl0(i,1)*kl(i,1);
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            b_avrg(i,1) = bB(i,1)./Strakes(1,4,i);
            
            k0(i,1) = 1-(0.3/b_avrg(i,1));
            
            if b_avrg(i,1) >= 2
                b2(i,1) = Strakes(1,4,i);
            else
                b2(i,1) = bB(i,1)*(1-0.25*b_avrg(i,1));
            end
            
            b1(i,1) = k0(i,1)*b2(i,1);
            
            c = 1;                                                                                  %c = 1, for bottom longitudinals and for side longitudinals where no panting frames are fitted
            
            Delta_s = u*(T-12);
            
            kl_A(i,1) = 0.8;
            
            if kl_A(i,1) > 1/(1+0.76*(a0(i,1)/(Strakes(1,2,i)/100)));
                kl_A(i,1) = 0.8;
            else
                kl_A(i,1) = 1/(1+0.76*(a0(i,1)/(Strakes(1,2,i)/100)));
            end
            
            %The web area requirement, in cm2, of a longitudinal%
            Al(i,1) = (8.7/ReH)*pB(i,1)*b1(i,1)*(Strakes(1,2,i)/100)*c*kl_A(i,1) + 0.1*(Strakes(1,14,i)*10^-1)*Delta_s;
            
            
            kc = 0.85;                                                                               %kc = 0.9 for rolled profiles and 0.85 for welded profiles
            
            ks = 1;                                                                                 %ks = 1 for plate sections, ks = 0.8 in other cases
            
            omega_l(i,1) = 1.15;                                                               %omega_l = 1.15 for the purpose of simplified calculations in accordance with 3.10.4.2.4
            
            gamma_l(i,1) = Al(i,1)/Aa(i,1);
            
            if gamma_l(i,1) > 1
                gamma_l(i,1) = 1;
            end
            
            kl(i,1) = 1/(1+sqrt(1-ks*(gamma_l(i,1).^2)));
            
            Wl0(i,1) = (125/ReH)*pB(i,1)*b1(i,1)*(Strakes(1,2,i)/100)*((Strakes(1,2,i)/100)-0.5*Strakes(1,4,i))*(c^2)*omega_l(i,1);
            
            %The ultimate section modulus requirements of longitudinals%
            Wl(i,1) = Wl0(i,1)*kl(i,1);
        end
    elseif Isklasse == 2 || Isklasse == 3
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            b_avrg(i,1) = bB(i,1)./Strakes(1,4,i);
            
            k0(i,1) = 1-(0.3/b_avrg(i,1));
            
            if b_avrg(i,1) >= 2
                b2(i,1) = Strakes(1,4,i);
            else
                b2(i,1) = bB(i,1)*(1-0.25*b_avrg(i,1));
            end
            
            b1(i,1) = k0(i,1)*b2(i,1);
            
            c = 1;                                                                                  %c = 1, for bottom longitudinals and for side longitudinals where no panting frames are fitted
            
            Delta_s = u*(T-12);
            
            kl_A(i,1) = 0.8;
            
            if kl_A(i,1) > 1/(1+0.76*(a0(i,1)/(Strakes(1,2,i)/100)));
                kl_A(i,1) = 0.8;
            else
                kl_A(i,1) = 1/(1+0.76*(a0(i,1)/(Strakes(1,2,i)/100)));
            end
            
            %The web area requirement, in cm2, of a longitudinal%
            Al(i,1) = (8.7/ReH)*pB(i,1)*b1(i,1)*(Strakes(1,2,i)/100)*c*kl_A(i,1) + 0.1*(Strakes(1,14,i)*10^-1)*Delta_s;
            
            
            kc = 0.85;                                                                               %kc = 0.9 for rolled profiles and 0.85 for welded profiles
            
            ks = 1;                                                                                 %ks = 1 for plate sections, ks = 0.8 in other cases
            
            omega_l(i,1) = 1.15;                                                                       %omega_l = 1.15 for the purpose of simplified calculations in accordance with 3.10.4.2.4
            
            gamma_l(i,1) = Al(i,1)/Aa(i,1);
            
            if gamma_l(i,1) > 1
                gamma_l(i,1) = 1;
            end
            
            kl(i,1) = 1/(1+sqrt(1-ks*(gamma_l(i,1).^2)));
            
            Wl0(i,1) = (125/ReH)*pB(i,1)*b1(i,1)*(Strakes(1,2,i)/100)*((Strakes(1,2,i)/100)-0.5*Strakes(1,4,i))*(c^2)*omega_l(i,1);
            
            %The ultimate section modulus requirements of longitudinals%
            Wl(i,1) = Wl0(i,1)*kl(i,1);
        end
    end
end


%The web thickness requirements of longitudinals [mm]%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            ks_area(i,1) = 1.4*(Wl(i,1)/Wa(i,1));
            
            if ks_area(i,1) < 1
                ks_area(i,1) = 1;
            end
            
            
            sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
            
            if sl(i,1) > (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
                sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
            else
                
                sl(i,1) = (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
            end            
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            ks_area(i,1) = 1.4*(Wl(i,1)/Wa(i,1));
            
            if ks_area(i,1) < 1
                ks_area(i,1) = 1;
            end
            
            
            sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
            
            if sl(i,1) > (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
                sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
            else
                
                sl(i,1) = (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
            end            
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            ks_area(i,1) = 1.4*(Wl(i,1)/Wa(i,1));
            
            if ks_area(i,1) < 1
                ks_area(i,1) = 1;
            end
            
            
            sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
            
            if sl(i,1) > (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
                sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
            else
                
                sl(i,1) = (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
            end            
        end
    elseif Isklasse == 2 || Isklasse == 3
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            ks_area(i,1) = 1.4*(Wl(i,1)/Wa(i,1));
            
            if ks_area(i,1) < 1
                ks_area(i,1) = 1;
            end
            
            
            sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
            
            if sl(i,1) > (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
                sl(i,1) = (ks_area(i,1)/ReH)*pB(i,1)*b1(i,1) + Delta_s;
            else
                
                sl(i,1) = (0.013*(Strakes(1,14,i)*10^-1)*sqrt(ReH)) + Delta_s;
            end            
        end
    end
end

%The face plate breadth requirements of hp or t-bar stiffeners[mm]%
% for i=1:Csec_size/2
%     if Isklasse == 8 || Isklasse == 9
%         if Strakes(1,1,i) == 1 ||Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
%             alpha(i,1) = (((Strakes(1,13,i)*10)/(Strakes(1,3,i)*10))^2)+((0.01*(Strakes(1,14,i)*10^-1)*(Strakes(1,3,i)*10))/(Strakes(1,4,i)*(Strakes(1,13,i)*10)));
%             
%             if alpha(i,1)<1
%                 alpha(i,1) = 1;
%             end
%             
%             beta(i,1) = ((2-alpha(i,1))*Strakes(1,20,i))/(alpha(i,1)*(Strakes(1,14,i)*10^-1));
%             
%             if beta(i,1)<0.055
%                 beta(i,1) = 0.055;
%             end
%             
%             
%             cl(i,1) = 0.0145*ReH*(Wl(i,1)/Wa(i,1))*sqrt(tfp(i,1)*Strakes(1,13,i)*10)*((Strakes(1,14,i)*10^-1)/(Strakes(1,13,i)*10)-0.98);
%             
%             if cl(i,1)<2.5*tfp(i,1)
%                 cl(i,1) = 2.5*tfp(i,1);
%             elseif cl(i,1) < 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029))
%                 cl(i,1) = 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029));
%             end
%         end
%     elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
%         if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
%             alpha(i,1) = (((Strakes(1,13,i)*10)/(Strakes(1,3,i)*10))^2)+((0.01*(Strakes(1,14,i)*10^-1)*(Strakes(1,3,i)*10))/(Strakes(1,4,i)*(Strakes(1,13,i)*10)));
%             
%             if alpha(i,1)<1
%                 alpha(i,1) = 1;
%             end
%             
%             beta(i,1) = ((2-alpha(i,1))*Strakes(1,20,i))/(alpha(i,1)*(Strakes(1,14,i)*10^-1));
%             
%             if beta(i,1)<0.055
%                 beta(i,1) = 0.055;
%             end
%             
%             
%             cl(i,1) = 0.0145*ReH*(Wl(i,1)/Wa(i,1))*sqrt(tfp(i,1)*Strakes(1,13,i)*10)*((Strakes(1,14,i)*10^-1)/(Strakes(1,13,i)*10)-0.98);
%             
%             if cl(i,1)<2.5*tfp(i,1)
%                 cl(i,1) = 2.5*tfp(i,1);
%             elseif cl(i,1) < 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029))
%                 cl(i,1) = 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029));
%             end
%         end
%     elseif Isklasse == 4
%         if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
%             alpha(i,1) = (((Strakes(1,13,i)*10)/(Strakes(1,3,i)*10))^2)+((0.01*(Strakes(1,14,i)*10^-1)*(Strakes(1,3,i)*10))/(Strakes(1,4,i)*(Strakes(1,13,i)*10)));
%             
%             if alpha(i,1)<1
%                 alpha(i,1) = 1;
%             end
%             
%             beta(i,1) = ((2-alpha(i,1))*Strakes(1,20,i))/(alpha(i,1)*(Strakes(1,14,i)*10^-1));
%             
%             if beta(i,1)<0.055
%                 beta(i,1) = 0.055;
%             end
%             
%             
%             cl(i,1) = 0.0145*ReH*(Wl(i,1)/Wa(i,1))*sqrt(tfp(i,1)*Strakes(1,13,i)*10)*((Strakes(1,14,i)*10^-1)/(Strakes(1,13,i)*10)-0.98);
%             
%             if cl(i,1)<2.5*tfp(i,1)
%                 cl(i,1) = 2.5*tfp(i,1);
%             elseif cl(i,1) < 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029))
%                 cl(i,1) = 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029));
%             end
%         end
%     else
%         if Strakes(1,1,i) == 8
%             alpha(i,1) = (((Strakes(1,13,i)*10)/(Strakes(1,3,i)*10))^2)+((0.01*(Strakes(1,14,i)*10^-1)*(Strakes(1,3,i)*10))/(Strakes(1,4,i)*(Strakes(1,13,i)*10)));
%             
%             if alpha(i,1)<1
%                 alpha(i,1) = 1;
%             end
%             
%             beta(i,1) = ((2-alpha(i,1))*Strakes(1,20,i))/(alpha(i,1)*(Strakes(1,14,i)*10^-1));
%             
%             if beta(i,1)<0.055
%                 beta(i,1) = 0.055;
%             end
%             
%             
%             cl(i,1) = 0.0145*ReH*(Wl(i,1)/Wa(i,1))*sqrt(tfp(i,1)*Strakes(1,13,i)*10)*((Strakes(1,14,i)*10^-1)/(Strakes(1,13,i)*10)-0.98);
%             
%             if cl(i,1)<2.5*tfp(i,1)
%                 cl(i,1) = 2.5*tfp(i,1);
%             elseif cl(i,1) < 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029))
%                 cl(i,1) = 69.6*(Strakes(1,13,i)*10)*sqrt(((Strakes(1,14,i)*10^-1)/tfp(i,1))*(beta(i,1)^2-0.0029));
%             end
%         end
%     end
% end


%The requirements intertia moment of stiffeners on shell plating%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 ||Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            I(i,1) = 0.01*ReH*(Strakes(1,20,i)^2)*((10*Strakes(1,3,i)*10*Strakes(1,4,i))+Strakes(1,9,i));
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            I(i,1) = 0.01*ReH*(Strakes(1,20,i)^2)*((10*Strakes(1,3,i)*10*Strakes(1,4,i))+Strakes(1,9,i));
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            I(i,1) = 0.01*ReH*(Strakes(1,20,i)^2)*((10*Strakes(1,3,i)*10*Strakes(1,4,i))+Strakes(1,9,i));
        end
    elseif Isklasse == 2 || Isklasse == 3
        if Strakes(1,1,i) == 8
            I(i,1) = 0.01*ReH*(Strakes(1,20,i)^2)*((10*Strakes(1,3,i)*10*Strakes(1,4,i))+Strakes(1,9,i));
        end
    end
end


%The plate structure thickness of decks and platforms, as well as of double bottom stringers and centre girder%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 16 ||Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Csp(i,1) = Strakes(1,4,i);                      %[m]
            
            Delta_s = u*(T-12);                             %[mm]
            
            kp = 1;
            
            kT = 0.17*(Delta^(1/6));
            
            if kT < 1
                kT = 1;
            end
            
            k2_plate = kT*sqrt(kp);
            
            pBl(i,1) = k1_plate*pB(i,1);
            
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
            
            Sps01(i,1) = bB(i,1)*(0.8*(pBl(i,1)/ReH)-0.0045*k2_plate*(1+4*((Csp(i,1)/(k2_plate*bB(i,1))^2)))*((Ssp0(i,1)/(10*Csp(i,1)))^3.5));
            
            Sps1(i,1) = Sps01(i,1) + Delta_s;               %[mm]
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Csp(i,1) = Strakes(1,4,i);                      %[m]
            
            Delta_s = u*(T-12);                             %[mm]
            
            kp = 1;
            
            kT = 0.17*(Delta^(1/6));
            
            if kT < 1
                kT = 1;
            end
            
            k2_plate = kT*sqrt(kp);
            
            pBl(i,1) = k1_plate*pB(i,1);
            
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
            
            Sps01(i,1) = bB(i,1)*(0.8*(pBl(i,1)/ReH)-0.0045*k2_plate*(1+4*((Csp(i,1)/(k2_plate*bB(i,1))^2)))*((Ssp0(i,1)/(10*Csp(i,1)))^3.5));
            
            Sps1(i,1) = Sps01(i,1) + Delta_s;               %[mm]
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Csp(i,1) = Strakes(1,4,i);                      %[m]
            
            Delta_s = u*(T-12);                             %[mm]
            
            kp = 1;
            
            kT = 0.17*(Delta^(1/6));
            
            if kT < 1
                kT = 1;
            end
            
            k2_plate = kT*sqrt(kp);
            
            pBl(i,1) = k1_plate*pB(i,1);
            
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
            
            Sps01(i,1) = bB(i,1)*(0.8*(pBl(i,1)/ReH)-0.0045*k2_plate*(1+4*((Csp(i,1)/(k2_plate*bB(i,1))^2)))*((Ssp0(i,1)/(10*Csp(i,1)))^3.5));
            
            Sps1(i,1) = Sps01(i,1) + Delta_s;               %[mm]
        end
    elseif Isklasse == 2 || Isklasse == 3
        if Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Csp(i,1) = Strakes(1,4,i);                      %[m]
            
            Delta_s = u*(T-12);                             %[mm]
            
            kp = 1;
            
            kT = 0.17*(Delta^(1/6));
            
            if kT < 1
                kT = 1;
            end
            
            k2_plate = kT*sqrt(kp);
            
            pBl(i,1) = k1_plate*pB(i,1);
            
            a0(i,1) = Strakes(1,4,i)./(1+0.5*(Strakes(1,4,i)./(Strakes(1,2,i)/100)));
            
            Ssp0(i,1) = 15.8*a0(i,1)*sqrt(pB(i,1)./ReH);
            
            Sps01(i,1) = bB(i,1)*(0.8*(pBl(i,1)/ReH)-0.0045*k2_plate*(1+4*((Csp(i,1)/(k2_plate*bB(i,1))^2)))*((Ssp0(i,1)/(10*Csp(i,1)))^3.5));
            
            Sps1(i,1) = Sps01(i,1) + Delta_s;               %[mm]
        end
    end
end

%The plate thickness general requirement of decks and platforms, as well as of double bottom stringers and centre girder%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 16 ||Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            
            if Strakes(1,4,i) < Strakes(1,20,i)  
                c1(i,1) = Strakes(1,4,i);
                c2(i,1) = Strakes(1,20,i);
                n1(i,1) = (1+((c1(i,1)/c2(i,1))^2))^2;
            elseif Strakes(1,4,i) > Strakes(1,20,i)
                c1(i,1) = Strakes(1,20,i);
                c2(i,1) = Strakes(1,4,i);
                n1(i,1) = 4;                
            end
            
            n(i,1) = (0.294*n1(i,1))/(Strakes(1,4,i)^2);
            
            q(i,1) = 0.6*pBl(i,1)*bB(i,1)*(1-((0.1*bB(i,1)*k2_plate)/(Strakes(1,2,i)/100)));
            
            q1(i,1) = 0.353*sqrt((ReH^3)/n(i,1));
            
            q2(i,1) = 4.9*q1(i,1);
            
            if q(i,1) <= q1(i,1)
                Sps0(i,1) = nthroot(q(i,1)/n(i,1),3);
            elseif q(i,1) > q1(i,1) && q(i,1) < q2(i,1)
                Sps0(i,1) = 0.455*((q(i,1)/ReH)+sqrt(((q(i,1)/ReH)^2)+((1.32*ReH)/n(i,1))));
            elseif q(i,1) >= q2(i,1)
                Sps0(i,1) = 1.73*sqrt(ReH/n(i,1));
            end
            
            Sps(i,1) = Sps0(i,1) + Delta_s;                 %[mm]
            
            if Sps(i,1) > Sps1(i,1)
                Sps(i,1) = Sps(i,1);
            else
                Sps(i,1) = Sps1(i,1);
            end
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if  Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            
            if Strakes(1,4,i) < Strakes(1,20,i)  
                c1(i,1) = Strakes(1,4,i);
                c2(i,1) = Strakes(1,20,i);
                n1(i,1) = (1+((c1(i,1)/c2(i,1))^2))^2;
            elseif Strakes(1,4,i) > Strakes(1,20,i)
                c1(i,1) = Strakes(1,20,i);
                c2(i,1) = Strakes(1,4,i);
                n1(i,1) = 4;                
            end
            
            n(i,1) = (0.294*n1(i,1))/(Strakes(1,4,i)^2);
            
            q(i,1) = 0.6*pBl(i,1)*bB(i,1)*(1-((0.1*bB(i,1)*k2_plate)/(Strakes(1,2,i)/100)));
            
            q1(i,1) = 0.353*sqrt((ReH^3)/n(i,1));
            
            q2(i,1) = 4.9*q1(i,1);
            
            if q(i,1) <= q1(i,1)
                Sps0(i,1) = nthroot(q(i,1)/n(i,1),3);
            elseif q(i,1) > q1(i,1) && q(i,1) < q2(i,1)
                Sps0(i,1) = 0.455*((q(i,1)/ReH)+sqrt(((q(i,1)/ReH)^2)+((1.32*ReH)/n(i,1))));
            elseif q(i,1) >= q2(i,1)
                Sps0(i,1) = 1.73*sqrt(ReH/n(i,1));
            end
            
            Sps(i,1) = Sps0(i,1) + Delta_s;                 %[mm]
            
            if Sps(i,1) > Sps1(i,1)
                Sps(i,1) = Sps(i,1);
            else
                Sps(i,1) = Sps1(i,1);
            end
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            
            if Strakes(1,4,i) < Strakes(1,20,i)  
                c1(i,1) = Strakes(1,4,i);
                c2(i,1) = Strakes(1,20,i);
                n1(i,1) = (1+((c1(i,1)/c2(i,1))^2))^2;
            elseif Strakes(1,4,i) > Strakes(1,20,i)
                c1(i,1) = Strakes(1,20,i);
                c2(i,1) = Strakes(1,4,i);
                n1(i,1) = 4;                
            end
            
            
            n(i,1) = (0.294*n1(i,1))/(Strakes(1,4,i)^2);
            
            q(i,1) = 0.6*pBl(i,1)*bB(i,1)*(1-((0.1*bB(i,1)*k2_plate)/(Strakes(1,2,i)/100)));
            
            q1(i,1) = 0.353*sqrt((ReH^3)/n(i,1));
            
            q2(i,1) = 4.9*q1(i,1);
            
            if q(i,1) <= q1(i,1)
                Sps0(i,1) = nthroot(q(i,1)/n(i,1),3);
            elseif q(i,1) > q1(i,1) && q(i,1) < q2(i,1)
                Sps0(i,1) = 0.455*((q(i,1)/ReH)+sqrt(((q(i,1)/ReH)^2)+((1.32*ReH)/n(i,1))));
            elseif q(i,1) >= q2(i,1)
                Sps0(i,1) = 1.73*sqrt(ReH/n(i,1));
            end
            
            Sps(i,1) = Sps0(i,1) + Delta_s;                 %[mm]
            
            if Sps(i,1) > Sps1(i,1)
                Sps(i,1) = Sps(i,1);
            else
                Sps(i,1) = Sps1(i,1);
            end
        end
    elseif Isklasse == 3 || Isklasse == 2 || Isklasse == 1
        if Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            
            if Strakes(1,4,i) < Strakes(1,20,i)  
                c1(i,1) = Strakes(1,4,i);
                c2(i,1) = Strakes(1,20,i);
                n1(i,1) = (1+((c1(i,1)/c2(i,1))^2))^2;
            elseif Strakes(1,4,i) > Strakes(1,20,i)
                c1(i,1) = Strakes(1,20,i);
                c2(i,1) = Strakes(1,4,i);
                n1(i,1) = 4;                
            end
            
            n(i,1) = (0.294*n1(i,1))/(Strakes(1,4,i)^2);
            
            q(i,1) = 0.6*pBl(i,1)*bB(i,1)*(1-((0.1*bB(i,1)*k2_plate)/(Strakes(1,2,i)/100)));
            
            q1(i,1) = 0.353*sqrt((ReH^3)/n(i,1));
            
            q2(i,1) = 4.9*q1(i,1);
            
            if q(i,1) <= q1(i,1)
                Sps0(i,1) = nthroot(q(i,1)/n(i,1),3);
            elseif q(i,1) > q1(i,1) && q(i,1) < q2(i,1)
                Sps0(i,1) = 0.455*((q(i,1)/ReH)+sqrt(((q(i,1)/ReH)^2)+((1.32*ReH)/n(i,1))));
            elseif q(i,1) >= q2(i,1)
                Sps0(i,1) = 1.73*sqrt(ReH/n(i,1));
            end
            
            Sps(i,1) = Sps0(i,1) + Delta_s;                 %[mm]
            
            if Sps(i,1) > Sps1(i,1)
                Sps(i,1) = Sps(i,1);
            else
                Sps(i,1) = Sps1(i,1);
            end
        end
    end
end




%WEBFRAMES%

if Isklasse == 8 || Isklasse == 9
    for j = 1:Csec_size/2
        if Strakes(1,1,j) == 1 ||Strakes(1,1,j) == 2 || Strakes(1,1,j) == 3 || Strakes(1,1,j) == 4 || Strakes(1,1,j) == 6 || Strakes(1,1,j) == 8
            if Webframe_ID(j,1) == 1 || Webframe_ID(j,1) == 2 || Webframe_ID(j,1) == 3 || Webframe_ID(j,1) == 4 || Webframe_ID(j,1) == 5 || Webframe_ID(j,1) == 6
                
                %The required ultimate section modulus of webframes%
                if lpB(j,1)>= 2*Strakes(1,20,j)
                    kp_wf(Webframe_ID(j,1),1) = 0.82*(1-(Strakes(1,20,j)/lpB(j,1)));
                    
                    if kp_wf(Webframe_ID(j,1),1)<0.6
                        kp_wf(Webframe_ID(j,1),1) = 0.6;
                    end
                elseif lpB(j,1) < 2*Strakes(1,20,j)
                    kp_wf(Webframe_ID(j,1),1) = 0.41*((Strakes(1,20,j)/lpB(j,1))-1);
                    
                    if kp_wf(Webframe_ID(j,1),1)<0.3*(lpB(j,1)/Strakes(1,20,j))
                        kp_wf(Webframe_ID(j,1),1) = 0.3*(lpB(j,1)/Strakes(1,20,j));
                    end
                end
                
                C2_2 = 0.11;
                
                C6_2 = 0.358;
                
                Q(Webframe_ID(j,1),1) = C6_2 + C2_2*(bB(j,1)/lpB(j,1));
                
                Qm(Webframe_ID(j,1),1) = Q(Webframe_ID(j,1),1);
                
                n_wf = 1;                                               %Number of frames fitted between two adjecent webframes
                
                G(Webframe_ID(j,1),1) = n_wf*Qm(Webframe_ID(j,1),1);
                
                k_wf = 0.63;
                
                km = 1.33;
                
                omega_wf = 1.15;
                
                W_wf0(Webframe_ID(j,1),1) = (250/ReH)*kp_wf(Webframe_ID(j,1),1)*pB(j,1)*Strakes(1,20,j)*bB(j,1)*(Girders(1,7,Webframe_ID(j,1))*10^-2)*(1-(0.5*bB(j,1)/(Girders(1,7,Webframe_ID(j,1))*10^-2))+km*G(Webframe_ID(j,1),1))*omega_wf;
                
                W_wf(Webframe_ID(j,1),1) = W_wf0(Webframe_ID(j,1),1)*k_wf;
                
                Wa_wf(Webframe_ID(j,1),1) = Girders(1,4,Webframe_ID(j,1));                                                                         %For simplified calculations
                
                %The required web area of webframes%
                m = 2;                                                                                          %Number of side stringers in a grillage
                
                A_wf(Webframe_ID(j,1),1) = ((8.7*pB(j,1)*Strakes(1,20,j)*bB(j,1)*kp_wf(Webframe_ID(j,1),1))/ReH)*(1+m/G(Webframe_ID(j,1),1))+0.1*Girders(1,2,Webframe_ID(j,1))*Delta_s;
                
                
                %The actual ultimate section modulus of webframes%
                Af(Webframe_ID(j,1),1) = 0.9*Girders(1,6,Webframe_ID(j,1));
                
                
                %The required web thickness of webframes%
                if Girders(1,2,Webframe_ID(j,1))<Girders(1,7,Webframe_ID(j,1))
                    c1_wf(Webframe_ID(j,1),1) = Girders(1,2,Webframe_ID(j,1))*10^-2;
                    c2_wf(Webframe_ID(j,1),1) = Girders(1,7,Webframe_ID(j,1))*10^-2;
                else
                    c1_wf(Webframe_ID(j,1),1) = Girders(1,7,Webframe_ID(j,1))*10^-2;
                    c2_wf(Webframe_ID(j,1),1) = Girders(1,2,Webframe_ID(j,1))*10^-2;
                end
                
                gamma_wf(Webframe_ID(j,1),1) = A_wf(Webframe_ID(j,1),1)/Af(Webframe_ID(j,1),1);
                
                ks_wf(Webframe_ID(j,1),1) = 1/(1.25*(Wa_wf(Webframe_ID(j,1),1)/W_wf(Webframe_ID(j,1),1))-0.75);
                
                sp(Webframe_ID(j,1),1) = 2.63*c1_wf(Webframe_ID(j,1),1)*sqrt(gamma_wf(Webframe_ID(j,1),1)*ReH/(5.35+4*((c1_wf(Webframe_ID(j,1),1)/c2_wf(Webframe_ID(j,1),1))^2)))+Delta_s;
                
                s_wf(Webframe_ID(j,1),1) = (ks_wf(Webframe_ID(j,1),1)/ReH)*pB(j,1)*Strakes(1,20,j)+Delta_s;
                
                if sp(Webframe_ID(j,1),1)>s_wf(Webframe_ID(j,1),1)
                    s_wf(Webframe_ID(j,1),1) = sp(Webframe_ID(j,1),1);
                else
                    s_wf(Webframe_ID(j,1),1) = s_wf(Webframe_ID(j,1),1);
                end    
            end
        end
    end
elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
    for j = 1:Csec_size/2
        if Strakes(1,1,j) == 6 || Strakes(1,1,j) == 8
            if Webframe_ID(j,1) == 5 || Webframe_ID(j,1) == 6
                
                %The required ultimate section modulus of webframes%
                if lpB(j,1)>= 2*Strakes(1,20,j)
                    kp_wf(Webframe_ID(j,1),1) = 0.82*(1-(Strakes(1,20,j)/lpB(j,1)));
                    
                    if kp_wf(Webframe_ID(j,1),1)<0.6
                        kp_wf(Webframe_ID(j,1),1) = 0.6;
                    end
                elseif lpB(j,1) < 2*Strakes(1,20,j)
                    kp_wf(Webframe_ID(j,1),1) = 0.41*((Strakes(1,20,j)/lpB(j,1))-1);
                    
                    if kp_wf(Webframe_ID(j,1),1)<0.3*(lpB(j,1)/Strakes(1,20,j))
                        kp_wf(Webframe_ID(j,1),1) = 0.3*(lpB(j,1)/Strakes(1,20,j));
                    end
                end
                
                C2_2 = 0.11;
                
                C6_2 = 0.358;
                
                Q(Webframe_ID(j,1),1) = C6_2 + C2_2*(bB(j,1)/lpB(j,1));
                
                Qm(Webframe_ID(j,1),1) = Q(Webframe_ID(j,1),1);
                
                n_wf = 1;                                               %Number of frames fitted between two adjecent webframes
                
                G(Webframe_ID(j,1),1) = n_wf*Qm(Webframe_ID(j,1),1);
                
                k_wf = 0.63;
                
                km = 1.33;
                
                omega_wf = 1.15;
                
                W_wf0(Webframe_ID(j,1),1) = (250/ReH)*kp_wf(Webframe_ID(j,1),1)*pB(j,1)*Strakes(1,4,j)*bB(j,1)*(Girders(1,7,Webframe_ID(j,1))*10^-2)*(1-(0.5*bB(j,1)/(Girders(1,7,Webframe_ID(j,1))*10^-2))+km*G(Webframe_ID(j,1),1))*omega_wf;
                
                W_wf(Webframe_ID(j,1),1) = W_wf0(Webframe_ID(j,1),1)*k_wf;
                
                Wa_wf(Webframe_ID(j,1),1) = Girders(1,4,Webframe_ID(j,1));                                                                         %For simplified calculations
                
                %The required web area of webframes%
                m = 2;                                                                                          %Number of side stringers in a grillage
                
                A_wf(Webframe_ID(j,1),1) = ((8.7*pB(j,1)*Strakes(1,4,j)*bB(j,1)*kp_wf(Webframe_ID(j,1),1))/ReH)*(1+m/G(Webframe_ID(j,1),1))+0.1*Girders(1,2,Webframe_ID(j,1))*Delta_s;
                
                
                %The actual ultimate section modulus of webframes%
                Af(Webframe_ID(j,1),1) = 0.9*Girders(1,6,Webframe_ID(j,1));
                
                
                %The required web thickness of webframes%
                if Girders(1,2,Webframe_ID(j,1))<Girders(1,7,Webframe_ID(j,1))
                    c1_wf(Webframe_ID(j,1),1) = Girders(1,2,Webframe_ID(j,1))*10^-2;
                    c2_wf(Webframe_ID(j,1),1) = Girders(1,7,Webframe_ID(j,1))*10^-2;
                else
                    c1_wf(Webframe_ID(j,1),1) = Girders(1,7,Webframe_ID(j,1))*10^-2;
                    c2_wf(Webframe_ID(j,1),1) = Girders(1,2,Webframe_ID(j,1))*10^-2;
                end
                
                gamma_wf(Webframe_ID(j,1),1) = A_wf(Webframe_ID(j,1),1)/Af(Webframe_ID(j,1),1);
                
                ks_wf(Webframe_ID(j,1),1) = 1/(1.25*(Wa_wf(Webframe_ID(j,1),1)/W_wf(Webframe_ID(j,1),1))-0.75);
                
                sp(Webframe_ID(j,1),1) = 2.63*c1_wf(Webframe_ID(j,1),1)*sqrt(gamma_wf(Webframe_ID(j,1),1)*ReH/(5.35+4*((c1_wf(Webframe_ID(j,1),1)/c2_wf(Webframe_ID(j,1),1))^2)))+Delta_s;
                
                s_wf(Webframe_ID(j,1),1) = (ks_wf(Webframe_ID(j,1),1)/ReH)*pB(j,1)*Strakes(1,4,j)+Delta_s;
                
                if sp(Webframe_ID(j,1),1)>s_wf(Webframe_ID(j,1),1)
                    s_wf(Webframe_ID(j,1),1) = sp(Webframe_ID(j,1),1);
                else
                    s_wf(Webframe_ID(j,1),1) = s_wf(Webframe_ID(j,1),1);
                end     
            end
        end
    end
elseif Isklasse == 4
    for j = 1:Csec_size/2
        if Strakes(1,1,j) == 8
            if Webframe_ID(j,1) == 6
                
                %The required ultimate section modulus of webframes%
                if lpB(j,1)>= 2*Strakes(1,20,j)
                    kp_wf(Webframe_ID(j,1),1) = 0.82*(1-(Strakes(1,20,j)/lpB(j,1)));
                    
                    if kp_wf(Webframe_ID(j,1),1)<0.6
                        kp_wf(Webframe_ID(j,1),1) = 0.6;
                    end
                elseif lpB(j,1) < 2*Strakes(1,20,j)
                    kp_wf(Webframe_ID(j,1),1) = 0.41*((Strakes(1,20,j)/lpB(j,1))-1);
                    
                    if kp_wf(Webframe_ID(j,1),1)<0.3*(lpB(j,1)/Strakes(1,20,j))
                        kp_wf(Webframe_ID(j,1),1) = 0.3*(lpB(j,1)/Strakes(1,20,j));
                    end
                end
                
                C2_2 = 0.11;
                
                C6_2 = 0.358;
                
                Q(Webframe_ID(j,1),1) = C6_2 + C2_2*(bB(j,1)/lpB(j,1));
                
                Qm(Webframe_ID(j,1),1) = Q(Webframe_ID(j,1),1);
                
                n_wf = 1;                                               %Number of frames fitted between two adjecent webframes
                
                G(Webframe_ID(j,1),1) = n_wf*Qm(Webframe_ID(j,1),1);
                
                k_wf = 0.63;
                
                km = 1.33;
                
                omega_wf = 1.15;
                
                W_wf0(Webframe_ID(j,1),1) = (250/ReH)*kp_wf(Webframe_ID(j,1),1)*pB(j,1)*Strakes(1,20,j)*bB(j,1)*(Girders(1,7,Webframe_ID(j,1))*10^-2)*(1-(0.5*bB(j,1)/(Girders(1,7,Webframe_ID(j,1))*10^-2))+km*G(Webframe_ID(j,1),1))*omega_wf;
                
                W_wf(Webframe_ID(j,1),1) = W_wf0(Webframe_ID(j,1),1)*k_wf;
                
                Wa_wf(Webframe_ID(j,1),1) = Girders(1,4,Webframe_ID(j,1));                                                                         %For simplified calculations
                
                %The required web area of webframes%
                m = 2;                                                                                          %Number of side stringers in a grillage
                
                A_wf(Webframe_ID(j,1),1) = ((8.7*pB(j,1)*Strakes(1,4,j)*bB(j,1)*kp_wf(Webframe_ID(j,1),1))/ReH)*(1+m/G(Webframe_ID(j,1),1))+0.1*Girders(1,2,Webframe_ID(j,1))*Delta_s;
                
                
                %The actual ultimate section modulus of webframes%
                Af(Webframe_ID(j,1),1) = 0.9*Girders(1,6,Webframe_ID(j,1));
                
                
                %The required web thickness of webframes%
                if Girders(1,2,Webframe_ID(j,1))<Girders(1,7,Webframe_ID(j,1))
                    c1_wf(Webframe_ID(j,1),1) = Girders(1,2,Webframe_ID(j,1))*10^-2;
                    c2_wf(Webframe_ID(j,1),1) = Girders(1,7,Webframe_ID(j,1))*10^-2;
                else
                    c1_wf(Webframe_ID(j,1),1) = Girders(1,7,Webframe_ID(j,1))*10^-2;
                    c2_wf(Webframe_ID(j,1),1) = Girders(1,2,Webframe_ID(j,1))*10^-2;
                end
                
                gamma_wf(Webframe_ID(j,1),1) = A_wf(Webframe_ID(j,1),1)/Af(Webframe_ID(j,1),1);
                
                ks_wf(Webframe_ID(j,1),1) = 1/(1.25*(Wa_wf(Webframe_ID(j,1),1)/W_wf(Webframe_ID(j,1),1))-0.75);
                
                sp(Webframe_ID(j,1),1) = 2.63*c1_wf(Webframe_ID(j,1),1)*sqrt(gamma_wf(Webframe_ID(j,1),1)*ReH/(5.35+4*((c1_wf(Webframe_ID(j,1),1)/c2_wf(Webframe_ID(j,1),1))^2)))+Delta_s;
                
                s_wf(Webframe_ID(j,1),1) = (ks_wf(Webframe_ID(j,1),1)/ReH)*pB(j,1)*Strakes(1,20,j)+Delta_s;
                
                if sp(Webframe_ID(j,1),1)>s_wf(Webframe_ID(j,1),1)
                    s_wf(Webframe_ID(j,1),1) = sp(Webframe_ID(j,1),1);
                else
                    s_wf(Webframe_ID(j,1),1) = s_wf(Webframe_ID(j,1),1);
                end
            end
        end
    end
end

if Isklasse == 8 || Isklasse == 9
    for j = 1:size(s_wf,1)     
        if isnan(s_wf(Webframe_ID(j,1),1))
            s_wf(j,1) = (s_wf(j-1,1)+s_wf(j+1,1))/2;
        end
    end
elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
    for j = 1:size(s_wf,1)
        if isnan(s_wf(Webframe_ID(j,1),1))
            s_wf(j,1) = s_wf(j+1,1);
        end
    end
elseif Isklasse == 4
    for j = 1:size(s_wf,1)
        if isnan(s_wf(Webframe_ID(j,1),1))
            s_wf(j,1) = s_wf(j+1,1);
        end
    end    
end


%CHECK VALUES FOR THE RUSSIAN REGISTER ICE RULES%

%Check value of webframe web thickness%
if Isklasse == 8 || Isklasse == 9
    for j = 1:Csec_size/2
        if Strakes(1,1,j) == 1 ||Strakes(1,1,j) == 2 || Strakes(1,1,j) == 3 || Strakes(1,1,j) == 4 || Strakes(1,1,j) == 6 || Strakes(1,1,j) == 8
            if Webframe_ID(j,1) == 1 || Webframe_ID(j,1) == 2 || Webframe_ID(j,1) == 3 || Webframe_ID(j,1) == 4 || Webframe_ID(j,1) == 5 || Webframe_ID(j,1) == 6
                W_wf_check(Webframe_ID(j,1),1) = (W_wf(Webframe_ID(j,1),1)-Wa_wf(Webframe_ID(j,1),1))/(W_wf(Webframe_ID(j,1),1)+Wa_wf(Webframe_ID(j,1),1));
                A_wf_check(Webframe_ID(j,1),1) = (A_wf(Webframe_ID(j,1),1)-Af(Webframe_ID(j,1),1))/(A_wf(Webframe_ID(j,1),1)+Af(Webframe_ID(j,1),1));
                s_wf_check(Webframe_ID(j,1),1) = (s_wf(Webframe_ID(j,1),1)-(Girders(1,3,Webframe_ID(j,1))*10))/(s_wf(Webframe_ID(j,1),1)+(Girders(1,3,Webframe_ID(j,1))*10));
            end
        end
    end
elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
    for j = 1:Csec_size/2
        if Strakes(1,1,j) == 6 || Strakes(1,1,j) == 8
            if Webframe_ID(j,1) == 5 || Webframe_ID(j,1) == 6
                W_wf_check(Webframe_ID(j,1),1) = (W_wf(Webframe_ID(j,1),1)-Wa_wf(Webframe_ID(j,1),1))/(W_wf(Webframe_ID(j,1),1)+Wa_wf(Webframe_ID(j,1),1));                
                A_wf_check(Webframe_ID(j,1),1) = (A_wf(Webframe_ID(j,1),1)-Af(Webframe_ID(j,1),1))/(A_wf(Webframe_ID(j,1),1)+Af(Webframe_ID(j,1),1));                
                s_wf_check(Webframe_ID(j,1),1) = (s_wf(Webframe_ID(j,1),1)-(Girders(1,3,Webframe_ID(j,1))*10))/(s_wf(Webframe_ID(j,1),1)+(Girders(1,3,Webframe_ID(j,1))*10));
            end
        end
    end
elseif Isklasse == 4
    for j = 1:Csec_size/2
        if Strakes(1,1,j) == 8
            if Webframe_ID(j,1) == 6
                W_wf_check(Webframe_ID(j,1),1) = (W_wf(Webframe_ID(j,1),1)-Wa_wf(Webframe_ID(j,1),1))/(W_wf(Webframe_ID(j,1),1)+Wa_wf(Webframe_ID(j,1),1));                
                A_wf_check(Webframe_ID(j,1),1) = (A_wf(Webframe_ID(j,1),1)-Af(Webframe_ID(j,1),1))/(A_wf(Webframe_ID(j,1),1)+Af(Webframe_ID(j,1),1));                
                s_wf_check(Webframe_ID(j,1),1) = (s_wf(Webframe_ID(j,1),1)-(Girders(1,3,Webframe_ID(j,1))*10))/(s_wf(Webframe_ID(j,1),1)+(Girders(1,3,Webframe_ID(j,1))*10));
            end
        end
    end
end

%Check value of shell plating thickness%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 ||Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            Ssp_check(i,1) = (Ssp(i,1)-(Strakes(1,3,i)*10))./(Ssp(i,1)+(Strakes(1,3,i)*10));
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            Ssp_check(i,1) = (Ssp(i,1)-(Strakes(1,3,i)*10))./(Ssp(i,1)+(Strakes(1,3,i)*10));
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            Ssp_check(i,1) = (Ssp(i,1)-(Strakes(1,3,i)*10))./(Ssp(i,1)+(Strakes(1,3,i)*10));
        end
    else
        if Strakes(1,1,i) == 8
            Ssp_check(i,1) = (Ssp(i,1)-(Strakes(1,3,i)*10))./(Ssp(i,1)+(Strakes(1,3,i)*10));
        end
    end
end


%Check values shell of intertia moment of stiffeners%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 ||Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            I_check(i,1) = (I(i,1)-Strakes(1,5,i))./(I(i,1)+Strakes(1,5,i));
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            I_check(i,1) = (I(i,1)-Strakes(1,5,i))./(I(i,1)+Strakes(1,5,i));
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
            I_check(i,1) = (I(i,1)-Strakes(1,5,i))./(I(i,1)+Strakes(1,5,i));
        end
    else
        if Strakes(1,1,i) == 8
            I_check(i,1) = (I(i,1)-Strakes(1,5,i))./(I(i,1)+Strakes(1,5,i));
        end
    end
end


%Check values of face plate breadth of a longitudinal (side and bottom)%
% for i=1:Csec_size/2
%     if Isklasse == 8 || Isklasse == 9
%         if Strakes(1,1,i) == 1 ||Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
%             cl_check(i,1) = (cl(i,1)-Strakes(1,18,i))./(cl(i,1)+Strakes(1,18,i));
%         end
%     elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
%         if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
%             cl_check(i,1) = (cl(i,1)-Strakes(1,18,i))./(cl(i,1)+Strakes(1,18,i));
%         end
%     elseif Isklasse == 4
%         if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
%             cl_check(i,1) = (cl(i,1)-Strakes(1,18,i))./(cl(i,1)+Strakes(1,18,i));
%         end
%     else
%         if Strakes(1,1,i) == 8
%             cl_check(i,1) = (cl(i,1)-Strakes(1,18,i))./(cl(i,1)+Strakes(1,18,i));
%         end
%     end
% end


%Check values of web thickness of a longitudinal (side and bottom)%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            sl_check(i,1) = (sl(i,1)-(Strakes(1,13,i)*10))./(sl(i,1)+(Strakes(1,13,i)*10));
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            sl_check(i,1) = (sl(i,1)-(Strakes(1,13,i)*10))./(sl(i,1)+(Strakes(1,13,i)*10));
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            sl_check(i,1) = (sl(i,1)-(Strakes(1,13,i)*10))./(sl(i,1)+(Strakes(1,13,i)*10));
        end
    else
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            sl_check(i,1) = (sl(i,1)-(Strakes(1,13,i)*10))./(sl(i,1)+(Strakes(1,13,i)*10));
        end
    end
end


%Check values of ultimate section modulus of a longitudinal (side and bottom)%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Wl_check(i,1) = (Wl(i,1)-Wa(i,1))./(Wl(i,1)+Wa(i,1));
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Wl_check(i,1) = (Wl(i,1)-Wa(i,1))./(Wl(i,1)+Wa(i,1));
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Wl_check(i,1) = (Wl(i,1)-Wa(i,1))./(Wl(i,1)+Wa(i,1));
        end
    else
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Wl_check(i,1) = (Wl(i,1)-Wa(i,1))./(Wl(i,1)+Wa(i,1));
        end
    end
end


%Check values of web area of a longitudinal (side and bottom)%
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Al_check(i,1) = (Al(i,1)-Aa(i,1))./(Al(i,1)+Aa(i,1));
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Al_check(i,1) = (Al(i,1)-Aa(i,1))./(Al(i,1)+Aa(i,1));
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Al_check(i,1) = (Al(i,1)-Aa(i,1))./(Al(i,1)+Aa(i,1));
        end
    else
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Al_check(i,1) = (Al(i,1)-Aa(i,1))./(Al(i,1)+Aa(i,1));
        end
    end
end


%Check values of plate thickness of bottom strigers and centre girder%
Sps_check = -1;
for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        if Strakes(1,1,i) == 16 ||Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Sps_check(i,1) = (Sps(i,1)-(Strakes(1,3,i)*10))./(Sps(i,1)+(Strakes(1,3,i)*10));
        end
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        if Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Sps_check(i,1) = (Sps(i,1)-(Strakes(1,3,i)*10))./(Sps(i,1)+(Strakes(1,3,i)*10));
        end
    elseif Isklasse == 4
        if Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Sps_check(i,1) = (Sps(i,1)-(Strakes(1,3,i)*10))./(Sps(i,1)+(Strakes(1,3,i)*10));
        end
    elseif Isklasse == 3 || Isklasse == 2 || Isklasse == 1
        if Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            Sps_check(i,1) = (Sps(i,1)-(Strakes(1,3,i)*10))./(Sps(i,1)+(Strakes(1,3,i)*10));
        end
    end
end


for i=1:Csec_size/2
    if Isklasse == 8 || Isklasse == 9
        Sps_check(Sps==0)=[];
        Sps(Sps==0)=[];        
    elseif Isklasse == 5 || Isklasse == 6 || Isklasse == 7
        Sps_check(Sps==0)=[];
        Sps(Sps==0)=[];        
    elseif Isklasse == 4
        Sps_check(Sps==0)=[];
        Sps(Sps==0)=[];        
    elseif Isklasse == 3 || Isklasse == 2 || Isklasse == 1
        Sps_check(Sps==0)=[];
        Sps(Sps==0)=[];
    end
end



s_check = -1;                                                                   %Defined as feasible if lower ice classes are checked%

if Isklasse == 9 || Isklasse == 8 || Isklasse == 7 || Isklasse == 6
    for i=1:Csec_size/2
        if Strakes(1,1,i) == 1 || Strakes(1,1,i) == 2 || Strakes(1,1,i) == 3 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 16 || Strakes(1,1,i) == 17 || Strakes(1,1,i) == 18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            s_check(i,1) = (Strakes(1,4,i)-s(i,1))./(Strakes(1,4,i)+s(i,1));
        end
    end
end

if Isklasse == 5
    for i=1:Csec_size/2
        if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6 || Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            s_check(i,1) = (Strakes(1,4,i)-s(i,1))./(Strakes(1,4,i)+s(i,1));
        end
    end
end

if Isklasse == 4
    for i=1:Csec_size/2
        if Strakes(1,1,i) == 8 || Strakes(1,1,i) == 21 || Strakes(1,1,i) == 22
            s_check(i,1) = (Strakes(1,4,i)-s(i,1))./(Strakes(1,4,i)+s(i,1));
        end
    end
end

if Isklasse == 4 || Isklasse == 5 || Isklasse == 6 || Isklasse == 7 || Isklasse == 8 || Isklasse == 9
    s_check(s==0)=[];
    s(s==0)=[];
end

W_wf_check(W_wf==0)=[];
W_wf_check(isnan(W_wf_check))=[];
A_wf_check(A_wf==0)=[];
s_wf_check(s_wf==0)=[];

for i=1:size(A_wf_check,1)
    if A_wf_check(i,1)<=0
        A_wf_check(i,1) = -1;
    else
        A_wf_check(i,1) = 1;
    end
end


Ssp_check(Ssp==0)=[];
Ssp(Ssp==0)=[];

Al_check(Al==0)=[];
Al(Al==0)=[];

Wl_check(Wl==0)=[];
Wl(Wl==0)=[];

sl_check(sl==0)=[];
sl(sl==0)=[];

% cl_check(cl==0)=[];
% cl(cl==0)=[];

I_check(I==0)=[];
I(I==0)=[];




check_RR = [max(s_wf_check) max(A_wf_check) max(W_wf_check) max(s_check) max(Sps_check) max(Al_check) max(Wl_check) max(sl_check) max(I_check) max(Ssp_check)]; %max(cl_check)


test = 1;

