function StructOpt

% How to get initial population?
% 1 = random or 2 = read from file.
source = 2;   %source

% Number of continous variables
continous_variables = 0;

% Upper and lower bound for continous variables
LowerB = [];
UpperB = [];

% PSO parameters.
Algorithm = [125 -1 250 1.4 0.8 3 2 1];

% PSO-parameter
% swarm_size = 5;             
% feasibles_initial_population = -1;             % Feasible designs in intial population (-1 dont want to use).
% generations = 10;                              % Calculation rounds.
% inertia = 1.4;                                 % Intertia at start.
% beta = 0.8;                                    % Factor for dynamic inertia reduction 
% beta_k = 3;                                    % Number of rounds when it should improve, otherwise make inertia smaller
% penalty_factor = 2;                            % Penalty factor for violated constraints
% print_results = 1;                             % 0 not printed, 1 is printed (results)



% Set of discrete variables
%Feasible_Set=[];

 nvariables=125;
 Feasible_Set=inf(nvariables,55); 

 
 %Strake 1 
 Feasible_Set(1,1:26) = [10:1:35]; %Thickness
 Feasible_Set(2,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(3,1:8) = [5:1:12]; %Number of stiffeners on strake
  
 
 %Strake 2 
 Feasible_Set(4,1:26) = [10:1:35]; %Thickness
 Feasible_Set(5,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(6,1:13) = [7:1:19]; %Number of stiffeners on strake
 
 %Strake 3 
 Feasible_Set(7,1:26) = [10:1:35]; %Thickness
 Feasible_Set(8,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(9,1:11) = [7:1:17]; %Number of stiffeners on strake
 
 %Strake 4 
 Feasible_Set(10,1:26) = [10:1:35]; %Thickness
 Feasible_Set(11,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(12,1:20) = [11:1:30]; %Number of stiffeners on strake
  
 
 %Strake 5 
 Feasible_Set(13,1:21) = [10:1:30]; %Thickness
 Feasible_Set(14,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(15,1:7) = [1:1:7]; %Number of stiffeners on strake
 
 %Strake 6 
 Feasible_Set(16,1:21) = [10:1:30]; %Thickness
 Feasible_Set(17,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(18,1:19) = [7:1:25]; %Number of stiffeners on strake
  
 %Strake 7 
 Feasible_Set(19,1:21) = [10:1:30]; %Thickness
 Feasible_Set(20,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(21,1:8) = [3:1:10]; %Number of stiffeners on strake
  
 %Strake 8
 Feasible_Set(22,1:16) = [25:1:40]; %Thickness
 Feasible_Set(23,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(24,1:26) = [30:1:55]; %Number of stiffeners on strake
 
 %Strake 9
 Feasible_Set(25,1:21) = [10:1:30]; %Thickness
 Feasible_Set(26,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(27,1:24) = [7:1:30]; %Number of stiffeners on strake
 
 %Strake 10
 Feasible_Set(28,1:21) = [10:1:30]; %Thickness
 Feasible_Set(29,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(30,1:16) = [2:1:17]; %Number of stiffeners on strake
  
 
 %Strake 11
 Feasible_Set(31,1:21) = [10:1:30]; %Thickness
 Feasible_Set(32,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(33,1:12) = [2:1:13]; %Number of stiffeners on strake
 
 %Strake 12 
 Feasible_Set(34,1:21) = [10:1:30]; %Thickness
 Feasible_Set(35,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(36,1:23) = [8:1:30]; %Number of stiffeners on strake
  
 %Strake 13
 Feasible_Set(37,1:21) = [10:1:30]; %Thickness
 Feasible_Set(38,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(39,1:13) = [2:1:14]; %Number of stiffeners on strake
  
 
 %Strake 14
 Feasible_Set(40,1:21) = [10:1:30]; %Thickness
 Feasible_Set(41,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(42,1:24) = [7:1:30]; %Number of stiffeners on strake
 
 %Strake 15
 Feasible_Set(43,1:21) = [10:1:30]; %Thickness
 Feasible_Set(44,1:15) = [8:1:22]; %Stiffener type 
 Feasible_Set(45,1:12) = [1:1:12]; %Number of stiffeners on strake
 
 %Strake 16
 Feasible_Set(46,1:21) = [10:1:30]; %Thickness
 Feasible_Set(47,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(48,1:13) = [3:1:15]; %Number of stiffeners on strake
  
 %Strake 17 
 Feasible_Set(49,1:21) = [10:1:30]; %Thickness
 Feasible_Set(50,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(51,1:13) = [3:1:15]; %Number of stiffeners on strake
 
 %Strake 18 
 Feasible_Set(52,1:21) = [10:1:30]; %Thickness
 Feasible_Set(53,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(54,1:13) = [3:1:15]; %Number of stiffeners on strake
 
 %Strake 19 
 Feasible_Set(55,1:21) = [10:1:30]; %Thickness
 Feasible_Set(56,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(57,1:13) = [3:1:15]; %Number of stiffeners on strake
 
 %Strake 20
 Feasible_Set(58,1:21) = [10:1:30]; %Thickness
 Feasible_Set(59,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(60,1:13) = [3:1:15]; %Number of stiffeners on strake
 
 %Strake 21
 Feasible_Set(61,1:31) = [10:1:40]; %Thickness
 Feasible_Set(62,1:8) = [15:1:22]; %Stiffener type 
 Feasible_Set(63,1:11) = [3:1:13]; %Number of stiffeners on strake
 
 %Strake 22
 Feasible_Set(64,1:31) = [10:1:40]; %Thickness
 Feasible_Set(65,1:8) = [15:1:22]; %Stiffener type 
 Feasible_Set(66,1:12) = [2:1:13]; %Number of stiffeners on strake
 
 %Strake 23
 Feasible_Set(67,1:21) = [10:1:30]; %Thickness
 Feasible_Set(68,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(69,1:12) = [2:1:13]; %Number of stiffeners on strake
 
 %Strake 24
 Feasible_Set(70,1:21) = [10:1:30]; %Thickness
 Feasible_Set(71,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(72,1:16) = [2:1:17]; %Number of stiffeners on strake
  
 %Strake 25
 Feasible_Set(73,1:21) = [10:1:30]; %Thickness
 Feasible_Set(74,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(75,1:9) = [1:1:9]; %Number of stiffeners on strake
  
 
 %Strake 26
 Feasible_Set(76,1:21) = [10:1:30]; %Thickness
 Feasible_Set(77,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(78,1:9) = [1:1:9]; %Number of stiffeners on strake
 
 %Strake 27
 Feasible_Set(79,1:21) = [10:1:30]; %Thickness
 Feasible_Set(80,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(81,1:12) = [1:1:12]; %Number of stiffeners on strake
 
 %Strake 28
 Feasible_Set(82,1:21) = [10:1:30]; %Thickness
 Feasible_Set(83,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(84,1:17) = [3:1:19]; %Number of stiffeners on strake
  
 
 %Strake 29
 Feasible_Set(85,1:21) = [10:1:30]; %Thickness
 Feasible_Set(86,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(87,1:16) = [2:1:17]; %Number of stiffeners on strake
 
 %Strake 30
 Feasible_Set(88,1:21) = [10:1:30]; %Thickness
 Feasible_Set(89,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(90,1:25) = [6:1:30]; %Number of stiffeners on strake
  
 %Strake 31
 Feasible_Set(91,1:21) = [10:1:30]; %Thickness
 Feasible_Set(92,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(93,1:16) = [2:1:17]; %Number of stiffeners on strake
  
 
 %Strake 32
 Feasible_Set(94,1:21) = [10:1:30]; %Thickness
 Feasible_Set(95,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(96,1:24) = [7:1:30]; %Number of stiffeners on strake
 
 %Strake 33
 Feasible_Set(97,1:21) = [10:1:30]; %Thickness
 Feasible_Set(98,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(99,1:24) = [7:1:30]; %Number of stiffeners on strake
 
 %Strake 34
 Feasible_Set(100,1:21) = [10:1:30]; %Thickness
 Feasible_Set(101,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(102,1:21) = [4:1:24]; %Number of stiffeners on strake
 
 %Strake 35
 Feasible_Set(103,1:21) = [10:1:30]; %Thickness
 Feasible_Set(104,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(105,1:24) = [7:1:30]; %Number of stiffeners on strake
 
 %Strake 36
 Feasible_Set(106,1:21) = [10:1:30]; %Thickness
 Feasible_Set(107,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(108,1:24) = [7:1:30]; %Number of stiffeners on strake
  
 %Strake 37
 Feasible_Set(109,1:21) = [10:1:30]; %Thickness
 Feasible_Set(110,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(111,1:12) = [1:1:12]; %Number of stiffeners on strake
 
 %Strake 38
 Feasible_Set(112,1:21) = [10:1:30]; %Thickness
 Feasible_Set(113,1:13) = [10:1:22]; %Stiffener type 
 Feasible_Set(114,1:9) = [1:1:9]; %Number of stiffeners on strake
 
 %Girder 1%
 Feasible_Set(115,1:21) = [10:1:30];   %Web thickness
 
 %Girder 2%
 Feasible_Set(116,1:21) = [10:1:30];   %Web thickness
 
 %Girder 3%
 Feasible_Set(117,1:21) = [10:1:30];   %Web thickness
 
 %Girder 4%
 Feasible_Set(118,1:21) = [10:1:30];   %Web thickness
 
 %Girder 5%
 Feasible_Set(119,1:21) = [10:1:30];   %Web thickness
 
 %Girder 6%
 Feasible_Set(120,1:11) = [45:1:55];  %Web thickness
 
 %Girder 7%
 Feasible_Set(121,1:21) = [10:1:30];  %Web thickness
 
 %Girder 8%
 Feasible_Set(122,1:21) = [10:1:30];  %Web thickness
 
 %Girder 9%
 Feasible_Set(123,1:21) = [10:1:30];  %Web thickness
 
 %Girder 10%
 Feasible_Set(124,1:21) = [10:1:30];  %Web thickness
 
 %Girder 11%
 Feasible_Set(125,1:21) = [10:1:30];  %Web thickness

 
% Carry out the optimization.
if source == 1
    [best_f,best_x,best_g,history_f,history_x,history_g,iterations,...
        particle,particle_history,t_history] = PSO('particle_fun',continous_variables,Feasible_Set,LowerB,UpperB,Algorithm,[]);
elseif source == 2
    [best_f,best_x,best_g,history_f,history_x,history_g,iterations,...
        particle,particle_history,t_history] = PSO('particle_fun',continous_variables,Feasible_Set,LowerB,UpperB,Algorithm,'initial_feasible_population.txt');
end

%Best feasible particletion
format compact;
disp(' ')
disp(' ')
disp('Results:')
best_f,best_x,best_g
disp(' ')
disp(' ')

