function [check_DL,sigmaf,Mss,CB,E,f1] = Design_loads_func(Webframe_YZ_start,Webframe_YZ_end,Ii_buckling,Ai_buckling,Strakes,za_plate,za_stiff,ZD,zn,ZB,IN,Delta,L,B,T,D,Z_vert,y_plates,z_plates,Csec_size,cum_sum,Stiff_YZ,Csec_YZ_end,Girders,Webframe_ID)

Z_bh_check=-1;
t_bh_check=-1;
Z_sd_check=-1;
t_sd_check=-1;
Z_db_check=-1;
t_lg_check=-1;
t_dbf_check=-1;
Z_ib_check=-1;
t_ib_check=-1;
Z_ls_check=-1;
t_side_check=-1;
Z_bl_check=-1;
t_keel_check=-1;
t_btm_check=-1;
Z_bilge_check=-1;
t0_bh_check=-1;
t0_bh_check1=-1;
t_bh_check=-1;
Z_bh_check=-1;
t0_gir_check=-1;
t0_gir_check1=-1; 
t_gir_check=-1;
Z_gir_check=-1;
sigma_bilge_check=-1;
sigma_b_check=-1;
sigma_bl_check=-1;
sigma_ls_check=-1;
sigma_sg_check=-1;
sigma_ibstf_check=-1;
sigma_ib_check=-1;
sigma_lg_check=-1;
sigma_onbottomfloorsandgirders_check=-1;
sigma_strengthdeckstf_check=-1;
sigma_strengthdeck_check=-1;
sigma_lotbulkheads_check=-1;
sigma_simplegirdersbulkhead_check=-1;
t0_ib_check=-1;
t0_ib_check1=-1;
t0_sd_check=-1;
t0_sd_check1=-1;
t0_bh_check=-1;
t0_bh_check1=-1;
t0_bilge_check=-1;
t0_bilge_check1=-1;
t0_bl_check=-1;
t0_bl_check1=-1;


%DESIGN LOADS%


CB = (Delta/(1.025*L*B*T));             %Block coeffisient 
g0 = 9.81;                              %[m/s^2] Standard acceleration of gravity 
E = 2.06*10^5;                          %[N/mm^2] Modulus of elasticity of the material, steel in this case 
f1 = 1.0 ;                              %Material factor 1.0 NV-NS, 1.08 NV-27, 1.28 NV-32, 1.39 NV-36, 1.47 NV-40. 
V = 15.5;                               %Vessel speed in [knots]. 
p = 200;                                %Design pressure in [kN/m^2] 
rho = 1.025;                            %Density of liquid or stowage rate of dry cargo in [t/m^3]
sigmaf = 235;                           %N/mm2 
wk = 1.0;                               %Section modulus corrosion factor in tanks, see Sec.3 C1004, 1.0 in other compartments...
K = 1;                                  %K = 1.2 for ships without bildge keel, 1 for ships with bildge keel and 0.8 for ships with active roll damping 
kr = 0.39*B;                            %for ships with even transverse distribution of mass
                                        %0.35 B %for tankers in ballast
                                        %0.25 B %for ships loaded with ore between longitudinal bulkheads
GM = 0.07*B ;%0.12*B;                            %for tankers and bulk carriers.            
                                        %0.07 B in general
                                        %0.05 B for container ship with B < 32.2 m
                                        %0.08 B for container ship with B > 40.0 m with interpolation for B in between.
TR = 2*kr/(sqrt(GM));                   %Roll period
c = (1.25-0.025*TR)*K;
phi = 50*c/(B+75);                      %Roll angel%
b = 1;                                  %The largest athwartship distance in m from the load point to the tank corner at the top of tank/ hold most distant from the load point
H = 1;                                  %Height in m of tank
bt = 1;                                 %Breadth in m of top of tank/hold
hp = 1;                                 %Vertical distance in m from the load point to the top of air pipe
deltapdyn = 25;
hs = 1;                                 %Vertical distance in m from the load point to top of tank, excluding smaller hatchways
%p0 = 25;                                %25 in general,15 in ballast holds in dry cargo vessels
Cw = 10.75-((300-L)/100)^(3/2);         %Wave coefficient for 100 < L < 300. 
Cwu = Cw;                               %For unrestricted service 
Msos = -0.065*Cwu*(L^2)*B*(CB+0.7);     %[kNm] stillwater bending moments amidhsips sagging 
Msoh = Cwu*(L^2)*B*(0.1225-0.015*CB);   %[kNm] stillwater bending moments amidhsips hogging

ksm = 1.0;                              %within 0,4 L amidships, br endrast vist en skal ha andre omrde av skipet. 

Mss= Msos*ksm;                          %The rule stillwater bending moments amidships in sagging, dependent on position in the ship 

Msh= Msoh*ksm;                          %The rule stillwater bending moments amidships in hogging, dependent on position in the ship 


alfa = 1.0;                             %Seagoing conditions, change it if it is in ensheltered conditions. 

Mwos = -0.11*alfa*Cw*(L^2)*B*(CB+0.7);  %[kNm] The rule vertical wave bending moments amidships in sagging 

Mwoh = 0.19*alfa*Cw*(L^2)*B*CB;         %[kNm] The rule vertical wave bending moments amidships in hogging 

kwm = 1.0;                              %Position factor in ship, 1,0 between 0,40*L and 0,65*L from A.P, change it if it is outside the this area 

Mws = Mwos*kwm;                         %The rule vertical wave bending moments amidships in sagging, dependent on position in the ship 

Mwh = Mwoh*kwm;                         %The rule vertical wave bending moments amidships in hogging, dependent on position in the ship

Cv = sqrt(L)/50; 
if Cv > 0.2; 
    Cv = 0.2;
else Cv = sqrt(L)/50;
end 

Cv1 = V/sqrt(L); 
if Cv < 0.8; 
    Cv = 0.8 ;
else Cv = V/sqrt(L);
end 

a0 = ((3*Cw)/L)+(Cv*Cv1);               %Acceleration parameter 

kv = 0.7;                               %Between 0.3L and 0.6 L from AP 

av = (0.7*g0*a0)/(CB);                  %Vertical acceleration as given in B600, taken in centre of gravity of tank.


%SECTION 5 LONGITUDINAL STRENGTH

%The midship section modulus about the transverse neutral axis shall not be less than

if L<300
    Cw0 = 10.75-((300-L)/100)^(3/2);
elseif 300<=L && L<=350
    Cw0 = 10.75;
elseif L>350
    Cw0 = 10.75-((L-350)/150)^(3/2);
end

Z0 = (Cw0*(L^2)*B*(CB+0.7))/f1;         %[cm3]

ZB_check = (Z0-ZB)./(Z0+ZB);
ZD_check = (Z0-ZD)./(Z0+ZD);

%The midship section modulus about the vertical neutral axis (centre line) is normally not to be less than

Z0H = (5*(L^(9/4))*(T+0.3*B)*CB)/f1;

Z_vert_check = (Z0H-Z_vert)/(Z0H+Z_vert);

%The midship section moment of inertia about the transverse neutral axis shall not be less than:

I0 = 3*Cw*(L^3)*B*(CB+0.7);

I_check = (I0-IN)./(I0+IN);


%BOTTOM STRUCTURES 

if abs(Mss)>abs(Msh);                                       %Normally to be taken as the largest design still water bending moment in kNm.
Ms =  Mss;                                                  %MS shall not be taken less than 0.5 MSO.
elseif abs(Msh)>abs(Mss);                                   %When actual design moment is not known, Ms may be taken equal to MSO
    Ms = Msh;
end

if abs(Mss)>abs(Msh);                                       %Rule wave bending moment in kNm
Mw =  Mws;
elseif abs(Msh)>abs(Mss); 
    Mw = Mwh;
end


f2b = 5.7*(Ms+Mw)/(ZB);                                     %Stress factor below the neutral axis of the hull girder depending on surplus in midship section modulus and maximum value of the actual still water bending momements.
                                                            %For a fully utilized structure this one will be f2b=1?
f2d = 5.7*(Ms+Mw)/(ZD);

f = D-T;                                                    %Vertical distance from the waterline to the top of the ship's side at transverse section considered, maximum 0.8 CW (m)
if T>f
    kf = f;                                                 %kf = The smallest of T and f
else
    kf = T;
end

ks = 2;                                                     %ks=2 between 0.2 L and 0.7 L from AP
if V/sqrt(L)>1.5
    pl = (ks*Cw + kf)*(0.8 + 0.15*(V/sqrt(L)));
else 
    pl =ks*Cw+kf;
end

pdp = pl + 135*(y_plates/(B+75))-1.2*(T-(z_plates*10^-2));  %If the pressure drop according to Pt.4 Ch.6 Sec.4 K201 is not available, pdyn may normally be taken as 25 kN/m2, for ballast tanks and zero for other tanks.
                                                            %If arrangements for the prevention of overpumping of ballast tanks in accordance with Pt.4 Ch.6 Sec.4 K200 are fitted, pdyn may be taken as zero.

                                                            
% DESIGN LOADS 
% TM = 0.35*T;                                                %Minimum design draught in [m] amidships, normally taken as 0.35 T for dry cargo vessels, other vessel check rules 
% p1 = 10*h0+pdp;                                             %Outer bottom sea pressure 
% p2 = rho*(g0+0.5*av)*hs-10*TM;                              %Outer bottom net pressure in way of cargo tank or deep tank. 
% p3 = rho*g0*hs+p0-10*TM;                                    %Outer bottom net pressure in way of cargo tank or deep tank. 
% p4 = rho*(g0+0.5*av)*hs;                                    %Inner bottom:Dry cargo in cargo holds
% p5 = (10+0.5*av)*hs;                                        %Inner bottom:Ballast in cargo holds
% p6 = 6.7*(hs+(phi*b))-1.2*sqrt(H*phi*bt);                   %Inner bottom:Ballast in cargo holds
% p7 = 0.67*(10*hp + deltapdyn);                              %Inner bottom:Ballast in cargo holds
% p8 = 10*hs+p0;                                              %Inner bottom:Ballast in cargo holds
% p9 = rho*(g0+0.5*av)*hs;                                    %Inner bottom:Liquid cargo in tank above
% p10 = rho*g0*(0.67*(hs+phi*b)-0.12*sqrt(H*phi*bt)^2);       %Inner bottom:Liquid cargo in tank above
% p11 = 0.67*(rho*g0*hp+deltapdyn);                           %Inner bottom:Liquid cargo in tank above
% p12 = rho*g0*hs+p0;                                         %Inner bottom:Liquid cargo in tank above
% p13 = 0.67*(10*hp +deltapdyn);                              %Inner bottom, floors and girders:Pressure on tank boundaries in double bottom
% p14 = 10*hs+p0;                                             %Inner bottom, floors and girders:Pressure on tank boundaries in double bottom
% p15 = 10*T;                                                 %Inner bottom, floors and girders:Minimum pressure 
% pb = 10*(h0+B*phi/2+0.088*CB*(B/2+0.8*Cw));                 %Bildge pressure


L1 = L;                                                     %Not to be taken larger than 300 [m]

if L > 300;
    L1 = 300;
else L1 = L;
end

k_t1 = 0.015*L1 ;
if k_t1 > 5 ;
    k_t1 = 5 ;
else k_t1 = 0.015*L1 ;
end



%KEEL PLATE (ID-number X)


%REQUIREMENTS FOR KEEL PLATING%
for j = 1:Csec_size/2
    
    %LONGITUDINALS, WITHIN 0.4 KEEL%
    if Strakes(1,21,j) == 0;
        for i = 1:Csec_size/2
            if Strakes(1,1,i) == 0
                
                %Rule thickness in [mm] of plating
                t_keel = 7.0+((0.05*L1)/(sqrt(f1)));                         %+tk 

            end
        end
   
    %TRANSVERSEFRAMES,WITHIN 0.4 L KEEL%
    elseif Strakes(1,21,j) == 1;
        for i = 1:Csec_size/2
            if Strakes(1,1,i) == 0% 1
                
                %Rule thickness in [mm] of plating
                t_keel = 7.0+((0.05*L1)/(sqrt(f1)));                         %+tk 

                
                %BUCKLING CHECK OF KEEL PLATING%
                psi_keel = 1;                                                                           % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.

                c_keel = 1.1 ;                                                                          %= 1.21 when stiffeners are angles or T-sections
                                                                                                        %= 1.10 when stiffeners are bulb flats
                                                                                                        %= 1.05 when stiffeners are flat bars
                                                                                                        %= 1.3 when the plating is supported by floors or deep girders.

                                                                                                        
                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                    long(i,1) = Strakes(1,4,i);
                else
                    short(i,1) = Strakes(1,4,i);
                    long(i,1) = Strakes(1,20,i);
                end
                
                k_keel = c_keel*((1+((short(i,1)/Strakes(1,20,i))^2))^2)*(2.1/(psi_keel+1.1));

                
                %The ideal elastic buckling stress may be taken as: 
                sigmael_keel = 0.9*k_keel*E*((t_keel/(1000*short(i,1))).^2);                        %[N/mm^2]
                   

                if sigmael_keel < sigmaf/2; 
                    sigmac_keel = sigmael_keel ;
                elseif sigmael_keel > sigmaf/2;
                    sigmac_keel = sigmaf*(1-((sigmaf)/(4*sigmael_keel)));
                end
                
                
                %The calculated compressive stress in plate panels
                sigma_a_keel = ((Msh+Mwh)/(IN))*(zn(1,1)-za_plate(i,1))*(10^5);
              
                
                %The critical buckling stress calculated
                eta_keel = 0.9;                
                
                if sigmac_keel < (sigma_a_keel/eta_keel);
                    sigmac_keel = (sigma_a_keel/eta_keel);
                elseif sigmac_keel >= (sigma_a_keel/eta_keel);
                    sigmac_keel = sigmac_keel ;
                end                                
            end
        end
    end
end


%BOTTOM AND BILGE PLATING (ID-number 2 for bottom and ID-number 3 for stiffened bilge)


%REQUIREMENTS FOR BOTTOM/BILGE PLATING%
for j = 1:Csec_size/2
    
    %LONGITUDINALS, WITHIN 0.4 BOTTOM/BILGE%
    if Strakes(1,21,j) == 0;
        for i = 1:Csec_size/2
            if Strakes(1,1,i) == 0 || Strakes(1,1,i) == 0
                
                
                sigma_b(i,1) = 120*f1;
                
                
                %BUCKLING CHECK OF BOTTOM/BILGE PLATING%
                psi_btm = 1;                                                                       % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.

                k_btm = 8.4/(psi_btm+1.1);
                
                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                else
                    short(i,1) = Strakes(1,4,i);
                end
                
                %The ideal elastic buckling stress may be taken as 
                sigmael_btm(i,1) = 0.9*k_btm*E*((Strakes(1,3,i)*10/(1000*(short(i,1)))).^2);  %[N/mm^2] Vist oss ombestemme oss for  ta med korrosjonstillegget so skal det ver med i denne formelen her, sj side 157 i pt.3 ch.1.



                if sigmael_btm(i,1) < sigmaf/2;
                    sigmac_btm(i,1) = sigmael_btm(i,1) ;
                elseif sigmael_btm(i,1) > sigmaf/2;
                    sigmac_btm(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_btm(i,1))));
                end
                
                
                %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows:
                eta_btm = 0.9;      
                
                sigma_a_btm(i,1) = ((Msh+Mwh)/(IN))*(zn(1,1)-za_plate(i,1))*(10^5);     % sigma_a = calculated compressive stress in plate panels. With linearly varying stress across the plate panel, shall be taken as the largest stress.
                
                if sigmac_btm(i,1) < (sigma_a_btm(i,1)/eta_btm);
                    sigmac_btm(i,1) = (sigma_a_btm(i,1)/eta_btm);
                elseif sigmac_btm(i,1) >= (sigma_a_btm(i,1)/eta_btm);
                    sigmac_btm(i,1) = sigmac_btm(i,1) ;
                end                
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_btm(i,1) < sigma_b(i,1)
                    sigma(i,1) = sigmac_btm(i,1);
                else
                    sigma(i,1) = sigma_b(i,1);
                end                
                
                
                ka_b(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i))).^2;                        %Correction factor for aspect ratio of plate field bottom
         
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_b(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>= 1.0
                    ka_b(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>0.4 && (Strakes(1,4,i)/Strakes(1,20,i))<1;
                    ka_b(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end
                
                t_btm(i,1) = ((15.8*ka_b(i,1).*Strakes(1,4,i)*sqrt(Strakes(1,22,i)))./sqrt(sigma(i,1)));              %+tk!! rule thickness in [mm] of plating corresponding to lateral pressure
                
                if t_btm(i,1) < (5.0+((0.04*L1)/(sqrt(f1))));                                        %+tk;
                    t_btm(i,1) = (5.0+((0.04*L1)/(sqrt(f1))));                                       %+tk;
                else t_btm(i,1) = ((15.8*ka_b(i,1).*Strakes(1,4,i)*sqrt(Strakes(1,22,i)))/sqrt(sigma(i,1)));          %+tk;
                end
            end
        end
        
    %TRANSVERSEFRAMES,WITHIN 0.4 L BOTTOM/BILGE%
    elseif Strakes(1,21,j) == 1;
        for i = 1:Csec_size/2
            if Strakes(1,1,i) == 0 || Strakes(1,1,i) ==  0 
               
                
                sigma_b(i,1) = 175*f1-120*f2b;
                
                if sigma_b(i,1) < 0
                    sigma_b_check = 1;
                end
                
                
                %BUCKLING CHECK OF BOTTOM/BILGE PLATING%
                psi_btm = 1;                                                                        % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.

                c_btm = 1.1 ;                                                                       %= 1.21 when stiffeners are angles or T-sections
                                                                                                    %= 1.10 when stiffeners are bulb flats
                                                                                                    %= 1.05 when stiffeners are flat bars
                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                    long(i,1) = Strakes(1,4,i);
                else
                    short(i,1) = Strakes(1,4,i);
                    long(i,1) = Strakes(1,20,i);
                end                                                                                                    %= 1.3 when the plating is supported by floors or deep girders.

                k_btm(i,1) = c_btm*((1+((short(i,1)/long(i,1))^2))^2)*(2.1/(psi_btm+1.1));

                
                %The ideal elastic buckling stress may be taken as: 
                sigmael_btm(i,1) = 0.9*k_btm(i,1)*E*((Strakes(1,3,i)*10/(1000*short(i,1))).^2);     %[N/mm^2]
                 

                if sigmael_btm(i,1) < sigmaf/2; 
                    sigmac_btm(i,1) = sigmael_btm(i,1) ;
                elseif sigmael_btm(i,1) > sigmaf/2;
                    sigmac_btm(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_btm(i,1))));
                end
                
                eta_btm = 0.9;

                
                %The calculated compressive stress in plate panels
                sigma_a_btm(i,1) = ((Msh+Mwh)/(IN))*(zn(1,1)-za_plate(i,1))*(10^5);
              
                
                %The critical buckling stress calculated
                if sigmac_btm(i,1) < (sigma_a_btm(i,1)/eta_btm);
                    sigmac_btm(i,1) = (sigma_a_btm(i,1)/eta_btm);
                elseif sigmac_btm(i,1) >= (sigma_a_btm(i,1)/eta_btm);
                    sigmac_btm(i,1) = sigmac_btm(i,1) ;
                end                
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_btm(i,1) < sigma_b(i,1)
                    sigma(i,1) = sigmac_btm(i,1);
                else
                    sigma(i,1) = sigma_b(i,1);
                end                 
                
                
                %Correction factor for aspect ratio of plate field bottom
                ka_b(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i))).^2;                        
         
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_b(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>= 1.0
                    ka_b(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>0.4 && (Strakes(1,4,i)/Strakes(1,20,i))<1;
                    ka_b(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end
                
                t_btm(i,1) = ((15.8*ka_b(i,1).*Strakes(1,4,i)*sqrt(Strakes(1,22,i)))./sqrt(sigma(i,1)));            %+tk!! rule thickness in [mm] of plating corresponding to lateral pressure
                
                if t_btm(i,1) < (5.0+((0.04*L1)/(sqrt(f1))));                                                       %+tk;
                    t_btm(i,1) = (5.0+((0.04*L1)/(sqrt(f1))));                                                      %+tk;
                else t_btm(i,1) = ((15.8*ka_b(i,1).*Strakes(1,4,i)*sqrt(Strakes(1,22,i)))/sqrt(sigma(i,1)));        %+tk;
                end                
            end
        end
    end
end



%REQUIREMENTS FOR BOTTOM/BILGE/KEEL STIFFENERS%
for k = 1:Csec_size/2
    
    %LONGITUDINALS, WITHIN 0.4 BOTTOM/BILGE%
    if Strakes(1,21,k) == 0;
        for i=1:Csec_size/2
      
            %BILGE LONGITUDINALS%
            if Strakes(1,1,i) == 0
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    if (Stiff_YZ(j,2)/100)<zn(1,1)
                        ii = 1;
                        jj = f2b;
                    else
                        ii = 2;
                        jj = f2d;
                    end
                    
                    
                    sigma_bilge(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));
            
                    if sigma_bilge(i,j)<0
                        sigma_bilge_check = -1;
                    end
                    
                    
                    %BUCKLING CHECK OF BILGE LONGITUDINALS%
                    sigmael_stiff_bilge(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i)^2)); %[N/mm^2], %The formula given for sigmael is based on hinged ends and axial force only.%If, in special cases, it is verified that one end can be regarded as fixed, the value of sigmael may be multiplied by 2. If it is verified that both ends can be regarded as fixed, the value of sigmael may be multiplied by 4.
                   
                    sigma_a_stiff_bilge(i,j) = ((Msh+Mwh)/(IN))*(zn(1,1)-za_stiff(j,1))*(10^5); 
 

                    if sigmael_stiff_bilge(i,j) < sigmaf/2;
                        sigmac_stiff_bilge(i,j) = sigmael_stiff_bilge(i,j) ;
                    elseif sigmael_stiff_bilge(i,j) > sigmaf/2;
                        sigmac_stiff_bilge(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_bilge(i,j))));
                    end
                    
                    eta_stiff_bilge = 0.85;

                    if sigmac_stiff_bilge(i,j) < (sigma_a_stiff_bilge(i,j)/eta_stiff_bilge);
                        sigmac_stiff_bilge(i,j) = (sigma_a_stiff_bilge(i,j)/eta_stiff_bilge);
                    elseif sigmac_stiff_bilge(i,j) >= (sigma_a_stiff_bilge(i,j)/eta_stiff_bilge);
                        sigmac_stiff_bilge(i,j) = sigmac_stiff_bilge(i,j) ;
                    end
                    
                    
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_bilge(i,j) < sigma_bilge(i,j)
                        sigma(i,j) = sigmac_stiff_bilge(i,j);
                    else
                        sigma(i,j) = sigma_bilge(i,j);
                    end                    
                    
                    
                    %SECTION MODULUS REQUIREMENTS IN [cm^3] OF BILGE LONGITUDINAL%
                    Z_bilge(i,j) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)));
                 
                    if sigma_bilge < 0
                        sigma_bilge_check = -1;
                    end
                    
                    
                    %The web and flange thickness shall not be less than the larger of:
                    hw_bilge(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                 %web height in [mm]
                    g_bilge = 41;                                                           %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles
                    t1_bilge(i,1) = 4.5 + k_t1 ;                                            % + tk, 
                    t2_bilge(i,1) = 1.5 + ((hw_bilge(i,1)*sqrt(f1))/(g_bilge)) ;            % +tk 
            
                    if t1_bilge(i,1) < t2_bilge(i,1)
                        t0_bilge(i,1) = t2_bilge(i,1);
                    else
                        t0_bilge(i,1) = t1_bilge(i,1);
                    end 
                end
                
            %BOTTOM AND KEEL LONGITUDINALS%
            elseif Strakes(1,1,i) == 0  || Strakes(1,1,i) ==  0
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    
                    if Strakes(1,1,i) == 0
                        b=Strakes(1,2,i)/100;
                        sigma_db = 85*f1*b/B;                                                   %Mean double bottom stress at plate flanges, normally not to be taken less than
                                                                                            %20*f1 for cargo holds in general cargo vessels; 
                                                                                            %50*f1 for holds for ballast 
                                                                                            %85*f1*b/B for tanks for liquid cargo,b is breadth of tank in double bottom;
                    elseif Strakes(1,1,i) ==  0 
                        sigma_db = 0;
                    end
                    
                    sigma_bl(i,j) = (225*f1)-130*f2b-0.7*sigma_db;                               %sigma_bl = 225 f1 ? 130 f2b, for single bottom
        
                    if sigma_bl(i,j)<0
                        sigma_bl_check = 1;
                    end
                    
                    
                    %BUCKLING CHECK OF BOTTOM/KEEL LONGITUDINAL%
                    sigmael_stiff_btm(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i).^2)); %[N/mm^2], the formula given for sigmael is based on hinged ends and axial force only. %If, in special cases, it is verified that one end can be regarded as fixed, the value of sigmael may be multiplied by 2. If it is verified that both ends can be regarded as fixed, the value of sigmael may be multiplied by 4.

                    sigma_a_stiff_btm(i,j) = ((Msh+Mwh)/(IN))*(zn(1,1)-za_stiff(j,1))*(10^5); 

                    %C 100 General 

                    if sigmael_stiff_btm(i,j) < sigmaf/2;
                        sigmac_stiff_btm(i,j) = sigmael_stiff_btm(i,j) ;
                    elseif sigmael_stiff_btm(i,j) > sigmaf/2;
                        sigmac_stiff_btm(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_btm(i,j))));
                    end
                    
                    eta_stiff_btm = 0.85;

                    if sigmac_stiff_btm(i,j) < (sigma_a_stiff_btm(i,j)/eta_stiff_btm);
                        sigmac_stiff_btm(i,j) = (sigma_a_stiff_btm(i,j)/eta_stiff_btm);
                    elseif sigmac_stiff_btm(i,j) >= (sigma_a_stiff_btm(i,j)/eta_stiff_btm);
                        sigmac_stiff_btm(i,j) = sigmac_stiff_btm(i,j) ;
                    end                    
                    
                    
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_btm(i,j) < sigma_bl(i,j)
                        sigma(i,j) = sigmac_stiff_btm(i,j);
                    else
                        sigma(i,j) = sigma_bl(i,j);
                    end               
                
                
                    %SECTION MODULUS REQUIREMENTS IN [cm^3] OF BOTTOM/KEEL LONGITUDINAL%
                    Z_bl(i,j) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)));
                    %p = p1 to p3 (when relevant) as given in table B1.

                    
                    %The web and flange thickness shall not be less than the larger of:
                    hw_bl(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                    %web height in [mm]
                    g_bl = 41;                                                              %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles
                    t1_bl(i,1) = 4.5 + k_t1 ;                                               % +tk,
                    t2_bl(i,1) = 1.5 + ((hw_bl(i,1)*sqrt(f1))/(g_bl)) ;                     % +tk
        
                    if t1_bl(i,1) < t2_bl(i,1)
                        t0_bl(i,1) = t2_bl(i,1);
                    else
                        t0_bl(i,1) = t1_bl(i,1);
                    end
                end
            end
        end
        
    %LONGITUDINALSWHENTRANSVERSEFRAMES,WITHIN 0.4 L BOTTOM/BILGE%STIFFENERS%
    elseif Strakes(1,21,k) == 1;
        for i=1:Csec_size/2
      
            %BILGE LONGITUDINALS%
            if Strakes(1,1,i) == 0% 3
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    if (Stiff_YZ(j,2)/100)<zn(1,1)
                        ii = 1;
                        jj = f2b;
                    else
                        ii = 2;
                        jj = f2d;
                    end
                    
                    
                    sigma_bilge(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));
            
                    if sigma_bilge(i,j)<0
                        sigma_bilge_check = -1;
                    end
                    
                    
                    %BUCKLING CHECK OF BILGE LONGITUDINALS%
                    sigmael_stiff_bilge(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i)^2)); %[N/mm^2], %The formula given for sigmael is based on hinged ends and axial force only.%If, in special cases, it is verified that one end can be regarded as fixed, the value of sigmael may be multiplied by 2. If it is verified that both ends can be regarded as fixed, the value of sigmael may be multiplied by 4.
                    
                    sigma_a_stiff_bilge(i,j) = ((Msh+Mwh)/(IN))*(zn(1,1)-za_stiff(j,1))*(10^5); 
 

                    if sigmael_stiff_bilge(i,j) < sigmaf/2;
                        sigmac_stiff_bilge(i,j) = sigmael_stiff_bilge(j,1) ;
                    elseif sigmael_stiff_bilge(i,j) > sigmaf/2;
                        sigmac_stiff_bilge(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_bilge(i,j))));
                    end
                    
                    eta_stiff_bilge = 0.85;

                    if sigmac_stiff_bilge(i,j) < (sigma_a_stiff_bilge(i,j)/eta_stiff_bilge);
                        sigmac_stiff_bilge(i,j) = (sigma_a_stiff_bilge(i,j)/eta_stiff_bilge);
                    elseif sigmac_stiff_bilge(i,j) >= (sigma_a_stiff_bilge(i,j)/eta_stiff_bilge);
                        sigmac_stiff_bilge(i,j) = sigmac_stiff_bilge(i,j) ;
                    end
                    
                    
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_bilge(i,j) < sigma_bilge(i,j)
                        sigma(i,j) = sigmac_stiff_bilge(i,j);
                    else
                        sigma(i,j) = sigma_bilge(i,j);
                    end                    
                    
                    
                    %SECTION MODULUS REQUIREMENTS IN [cm^3] OF BILGE LONGITUDINAL%
                    Z_bilge(i,j) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)));
                    
                    
                    %The web and flange thickness shall not be less than the larger of:                    
                    hw_bilge(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                 %web height in [mm]
                    g_bilge = 41;                                                           %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles
                    t1_bilge(i,1) = 4.5 + k_t1 ;                                            % + tk, 
                    t2_bilge(i,1) = 1.5 + ((hw_bilge(i,1)*sqrt(f1))/(g_bilge)) ;            % +tk 
            
                    if t1_bilge(i,1) < t2_bilge(i,1)
                        t0_bilge(i,1) = t2_bilge(i,1);
                    else
                        t0_bilge(i,1) = t1_bilge(i,1);
                    end   
                end
                
            %BOTTOM AND KEEL LONGITUDINALS%
            elseif Strakes(1,1,i) == 0  || Strakes(1,1,i) == 0
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                       
                    if Strakes(1,1,i) == 0% 1
                        b=Strakes(1,2,i)/100;
                        sigma_db = 85*f1*b/B;                                            %Mean double bottom stress at plate flanges, normally not to be taken less than
                                                                                         %20*f1 for cargo holds in general cargo vessels; 
                                                                                         %50*f1 for holds for ballast 
                                                                                            %85*f1*b/B for tanks for liquid cargo,b is breadth of tank in double bottom;
                    elseif Strakes(1,1,i) == 0% 2
                        sigma_db = 0;
                    end                                                            

                    sigma_bl(i,j) = (225*f1)-130*f2b-0.7*sigma_db;                       %sigma_bl = 225 f1 ? 130 f2b, for single bottom
        
                    if sigma_bl(i,j)<0
                        sigma_bl_check = -1;
                    end
                    
                    
                    %BUCKLING CHECK OF BOTTOM/KEEL LONGITUDINAL%     
                    sigmael_stiff_btm(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i)^2)); %[N/mm^2], the formula given for sigmael is based on hinged ends and axial force only. %If, in special cases, it is verified that one end can be regarded as fixed, the value of sigmael may be multiplied by 2. If it is verified that both ends can be regarded as fixed, the value of sigmael may be multiplied by 4.

                    sigma_a_stiff_btm(i,j) = ((Msh+Mwh)/(IN))*(zn(1,1)-za_stiff(j,1))*(10^5); 

                    %C 100 General 

                    if sigmael_stiff_btm(i,j) < sigmaf/2;
                        sigmac_stiff_btm(i,j) = sigmael_stiff_btm(i,j) ;
                    elseif sigmael_stiff_btm(i,j) > sigmaf/2;
                        sigmac_stiff_btm(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_btm(i,j))));
                    end
                    
                    eta_stiff_btm = 0.85;

                    if sigmac_stiff_btm(i,j) < (sigma_a_stiff_btm(i,j)/eta_stiff_btm);
                        sigmac_stiff_btm(i,j) = (sigma_a_stiff_btm(i,j)/eta_stiff_btm);
                    elseif sigmac_stiff_btm(i,j) >= (sigma_a_stiff_btm(i,j)/eta_stiff_btm);
                        sigmac_stiff_btm(i,j) = sigmac_stiff_btm(i,j) ;
                    end                    
                    
                
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_btm(i,j) < sigma_bl(i,j)
                        sigma(i,j) = sigmac_stiff_btm(i,j);
                    else
                        sigma(i,j) = sigma_bl(i,j);
                    end                
                
                
                    %SECTION MODULUS REQUIREMENTS IN [cm^3] OF BOTTOM/KEEL LONGITUDINAL%
                    Z_bl(i,j) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)));
                    %p = p1 to p3 (when relevant) as given in table B1.

                    
                    %The web and flange thickness shall not be less than the larger of: 
                    hw_bl(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;            %web height in [mm]
                    g_bl = 41;                                                      %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles
                    t1_bl(i,1) = 4.5 + k_t1 ;                                       % + tk,
                    t2_bl(i,1) = 1.5 + ((hw_bl(i,1)*sqrt(f1))/(g_bl)) ;             % +tk
        
                    if t1_bl(i,1) < t2_bl(i,1)
                        t0_bl(i,1) = t2_bl(i,1);
                    else
                        t0_bl(i,1) = t1_bl(i,1);
                    end
                end
            end
        end
    end
end



%LONGITUDINAL AND TRANSVERSE CROSS SECTION REQUIREMENTS TO FRAMES%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 0% x
        sigma_db_gir = 50*f1;                                                   %Mean double bottom stress at plate flanges, normally not to be taken less than
                                                                                %20*f1 for cargo holds in general cargo vessels; 
                                                                                %50*f1 for holds for ballast 
                                                                                %85*f1*b/B for tanks for liquid cargo,b is breadth of tank in double bottom; 

        sigma_bgir = (225*f1)-130*f2b-0.7*sigma_db_gir;
        
        %Section modulus requirement in [cm^3] of bottom and inner bottom frames.
        Z_bgir(i,1) = (0.63*((Strakes(1,20,i).^2))*Strakes(1,4,i)*Strakes(1,22,i)*wk/(f1));
        %p = p1 to p15 (when relevant) as given in table B1.
    end
end
 

%BOTTOM/BILGE/KEELCHECKVALUES%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 0  || Strakes(1,1,i) == 0
        t_btm_check(i,1) = (t_btm(i,1)-Strakes(1,3,i)*10)./(t_btm(i,1)+Strakes(1,3,i)*10);
    end
end




for i=1:Csec_size/2
    if Strakes(1,1,i) ==  0
        t_keel_check(i,1) = (t_keel(i,1)-Strakes(1,3,i)*10)./(t_keel(i,1)+Strakes(1,3,i)*10);
    end
end



for i=1:Csec_size/2
    if Strakes(1,1,i) ==  0 || Strakes(1,1,i) == 0
        for j = cum_sum(i,1)+1:cum_sum(i+1,1)
            Z_bl_check(i,j) = (Z_bl(i,j)-Strakes(1,23,i))./(Z_bl(i,j)+Strakes(1,23,i));
        end
    end
end



for i=1:Csec_size/2
    if Strakes(1,1,i) == 0
        for j = cum_sum(i,1)+1:cum_sum(i+1,1)        
            Z_bilge_check(i,j) = (Z_bilge(i,j)-Strakes(1,23,i))./(Z_bilge(i,j)+Strakes(1,23,i));  
        end
    end
end



for i=1:Csec_size/2
    if Strakes(1,1,i) == 0
         t0_bilge_check(i,1) = (t0_bilge(i,1)-Strakes(1,12,i)*20)./(t0_bilge(i,1)+Strakes(1,12,i)*20);
         t0_bilge_check1(i,1) = (t0_bilge(i,1)-Strakes(1,13,i)*10)./(t0_bilge(i,1)+Strakes(1,13,i)*10);
    end
end


 
for i=1:Csec_size/2
    if Strakes(1,1,i) == 0% 2
         t0_bl_check(i,1) = (t0_bl(i,1)-Strakes(1,12,i)*20)./(t0_bl(i,1)+Strakes(1,12,i)*20);
         t0_bl_check1(i,1) = (t0_bl(i,1)-Strakes(1,13,i)*10)./(t0_bl(i,1)+Strakes(1,13,i)*10);
    end
end



%SIDE STRUCTURES (ID-number 10,16,15)%

%REQUIREMENTS FOR SIDE STRUCTURE PLATING%
for j = 1:Csec_size/2
    
    %LONGITUDINALY STIFFENED WITHIN 0.4L%
    if Strakes(1,21,j) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 13 || Strakes(1,1,i) ==   20  || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 18
                
                sigma_s(i,1) = 140*f1;

                
                %BUCKLING CHECK OF SIDE PLATING%
                if zn(1,1)>=za_plate(i,1)
                    Ma = Msh+Mwh;
                    nn = 1;
                else
                    Ma = abs(Mss+Mws);
                    nn = 2;
                end                
                
                eta_side = 1.0; 
        
                psi_side = 1.0;                                                                      % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
        
                k_side = 8.4/(psi_side+1.1);

                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                else
                    short(i,1) = Strakes(1,4,i);
                end                
                
                
                %The ideal elastic buckling stress% 
                sigmael_side(i,1) = 0.9*k_side*E*((Strakes(1,3,i)*10/(1000*short(i,1)))^2); %[N/mm^2] Vist oss ombestemme oss for  ta med korrosjonstillegget so skal det ver med i denne formelen her, sj side 157 i pt.3 ch.1.  


                if sigmael_side(i,1) < sigmaf/2;  
                    sigmac_side(i,1) = sigmael_side(i,1);
                elseif sigmael_side(i,1) > sigmaf/2;
                    sigmac_side(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_side(i,1))));
                end
                
                
                %The critical buckling stress%
                sigma_a_side(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5);

                if sigma_a_side(i,1) < 30*f1 ;
                    sigma_a_side(i,1) = 30*f1 ;
                elseif sigma_a_side(i,1) >= 30*f1; 
                    sigma_a_side(i,1) = sigma_a_side(i,1);
                end
                
                
                if sigmac_side(i,1) < (sigma_a_side(i,1)/eta_side)
                    sigmac_side(i,1) = (sigma_a_side(i,1)/eta_side);
                elseif sigmac_side(i,1) >= (sigma_a_side(i,1)/eta_side)
                    sigmac_side(i,1) = sigmac_side(i,1);
                end                
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_side(i,1) < sigma_s(i,1)
                    sigma(i,1) = sigmac_side(i,1);
                else
                    sigma(i,1) = sigma_s(i,1);
                end                
                
                
                %Correction factor for aspect ratio of plate field%
                ka_s(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i))).^2;
                
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_s(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i)) >= 1.0
                    ka_s(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i)) > 0.4 && (Strakes(1,4,i)/Strakes(1,20,i)) < 1;
                    ka_s(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end
                
                %Thickness requirement%
                t_side(i,1) = ((15.8*ka_s(i,1).*Strakes(1,4,i).*sqrt(Strakes(1,22,i)))/sqrt(sigma(i,1)));
                %p is between p1-p8 whichever is relevant in table B1 in section 7.
        
                if Csec_YZ_end(i,2)/100 < T+4.6
                    k_s(i,1) = 0.04;
                elseif Csec_YZ_end(i,2)/100 < T+4.6+2.3
                    k_s(i,1) = 0.04 - 0.01;
                elseif Csec_YZ_end(i,2)/100 < T+4.6+2.3*2
                    k_s(i,1) = 0.04 - 0.01*2;
                end
                
                if t_side(i,1) < (5.0+((k_s(i,1)*L1)/(sqrt(f1))));                                              %+tk;
                    t_side(i,1) = (5.0+((k_s(i,1)*L1)/(sqrt(f1))));                                             %+tk; 
                else
                    t_side(i,1) = t_side(i,1);                                                                 %+tk;
                end
            end
        end
    
    %TRANSVERSLY STIFFENED WITHIN 0.4L%    
    elseif Strakes(1,21,j) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 13 || Strakes(1,1,i) ==   18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20
                
                sigma_s(i,1) = 120*f1;

                
                %BUCKLING CHECK OF SIDE PLATING%
                psi_side = 1;                                                                                           % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
                
                c_side = 1.1 ;                                                                                          %= 1.21 when stiffeners are angles or T-sections
                                                                                                                        %= 1.10 when stiffeners are bulb flats
                                                                                                                        %= 1.05 when stiffeners are flat bars
                                                                                                                        %= 1.3 when the plating is supported by floors or deep girders.

                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                    long(i,1) = Strakes(1,4,i);
                else
                    short(i,1) = Strakes(1,4,i);
                    long(i,1) = Strakes(1,20,i);
                end                
                                                                                                                        
                k_side(i,1) = c_side*((1+((short(i,1)./long(i,1)).^2)).^2)*(2.1/(psi_side+1.1));

                
                %The ideal elastic buckling stress may be taken as% 
                sigmael_side(i,1) = 0.9*k_side(i,1)*E*((Strakes(1,3,i)*10/(1000*short(i,1))).^2); %[N/mm^2] 


                if sigmael_side(i,1) < sigmaf/2; 
                    sigmac_side(i,1) = sigmael_side(i,1) ;
                elseif sigmael_side(i,1) > sigmaf/2;
                    sigmac_side(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_side(i,1))));
                end
                
                eta_side(i,1) = 0.9 ;

                if zn(1,1)>=za_plate(i,1)
                    Ma = Msh+Mwh;
                    nn = 1;
                else
                    Ma = abs(Mss+Mws);
                    nn = 2;
                end                
                
                
                %The calculated compressive stress in plate panels%
                sigma_a_side(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5); 
                
                if sigma_a_side(i,1) < 30*f1 ;
                    sigma_a_side(i,1) = 30*f1 ;
                elseif sigma_a_side(i,1) >= 30*f1; 
                    sigma_a_side(i,1) = sigma_a_side(i,1);
                end
                
                
                %The critical buckling stress%
                if sigmac_side(i,1) < (sigma_a_side(i,1)/eta_side);
                    sigmac_side(i,1) = (sigma_a_side(i,1)/eta_side);
                elseif sigmac_side(i,1) >= (sigma_a_side(i,1)/eta_side);
                    sigmac_side(i,1) = sigmac_side(i,1) ;
                end                
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_side(i,1) < sigma_s(i,1)
                    sigma(i,1) = sigmac_side(i,1);
                else
                    sigma(i,1) = sigma_s(i,1);
                end                  
                
                
                %Correction factor for aspect ratio of plate field%
                ka_s(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i))).^2;
                
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_s(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i)) >= 1.0
                    ka_s(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i)) > 0.4 && (Strakes(1,4,i)/Strakes(1,20,i)) < 1;
                    ka_s(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end
                
               
                %Thickness requirement%
                t_side(i,1) = ((15.8*ka_s(i,1).*Strakes(1,4,i).*sqrt(Strakes(1,22,i)))/sqrt(sigma(i,1)));
                %p is between p1-p8 whichever is relevant in table B1 in section 7.
        
                if Csec_YZ_end(i,2)/100 < T+4.6
                    k_s(i,1) = 0.04;
                elseif Csec_YZ_end(i,2)/100 < T+4.6+2.3
                    k_s(i,1) = 0.04 - 0.01;
                elseif Csec_YZ_end(i,2)/100 < T+4.6+2.3*2
                    k_s(i,1) = 0.04 - 0.01*2;
                end
                
                if t_side(i,1) < (5.0+((k_s(i,1)*L1)/(sqrt(f1))));                                                      %+tk;
                    t_side(i,1) = (5.0+((k_s(i,1)*L1)/(sqrt(f1))));                                                     %+tk; 
                else t_side(i,1) = ((15.8*ka_s(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i)))/sqrt(sigma(i,1)));                             %+tk;
                end
            end
        end
    end
end



%REQUIREMENTS FOR SIDE STRUCTURE STIFFENERS%
for k = 1:Csec_size/2

    %LONGITUDINALS, WITHIN 0.4 SIDESTRUCTURE
    if Strakes(1,21,k) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 13 || Strakes(1,1,i) ==   18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    if (Stiff_YZ(j,2)/100)<zn(1,1)
                        ii = 1;
                        jj = f2b;
                    else
                        ii = 2;
                        jj = f2d;
                    end

                    %Allowable stress within 0.4*L amidships
                    sigma_ls(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));

                    if sigma_ls(i,j) > 130*f1;
                        sigma_ls(i,j) = 130*f1;
                    else sigma_ls(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));
                    end

                    sigma_ls(1,1)=0;

                    if sigma_ls(i,j)<0
                        sigma_ls_check = 1;
                    end

                    
                    %BUCKLING CHECK OF SIDE LONGITUDINAL%
                    eta_stiff_ls = 0.85;
                    
                    %The ideal elastic buckling stress may be taken as%
                    sigmael_stiff_ls(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i)^2));   %[N/mm^2]
 
            
                    if sigmael_stiff_ls(i,j) < sigmaf/2; 
                        sigmac_stiff_ls(i,j) = sigmael_stiff_ls(i,j) ;
                    elseif sigmael_stiff_ls(i,j) > sigmaf/2;
                        sigmac_stiff_ls(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_ls(i,j)))); 
                    end
                    

                    if zn(1,1)>=(Stiff_YZ(j,2)/100)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                    
                    
                    %The calculated compressive stress in plate stiffeners%
                    sigma_a_stiff_ls(i,j) = ((Ma)/(IN))*(zn(1,nn)-za_stiff(j,1))*(10^5);
             
                    if sigma_a_stiff_ls(i,j) < 30*f1 ;
                        sigma_a_stiff_ls(i,j) = 30*f1 ;
                    elseif sigma_a_stiff_ls(i,j) >= 30*f1; 
                        sigma_a_stiff_ls(i,j) = sigma_a_stiff_ls(i,j);
                    end                    
                    

                    %The critical buckling stress%
                    if sigmac_stiff_ls(i,j) < (sigma_a_stiff_ls(i,j)/eta_stiff_ls);
                        sigmac_stiff_ls(i,j) = (sigma_a_stiff_ls(i,j)/eta_stiff_ls);
                    elseif sigmac_stiff_ls(i,j) >= (sigma_a_stiff_ls(i,j)/eta_stiff_ls);
                        sigmac_stiff_ls(i,j) = sigmac_stiff_ls(i,j);
                    end                    
                    
                    
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_ls(i,j) < sigma_ls(i,j)
                        sigma(i,j) = sigmac_stiff_ls(i,j);
                    else
                        sigma(i,j) = sigma_ls(i,j);
                    end                   
                    
                   
                    %Section modulus requirement of side longitudinals.
                    Z_ls(i,j) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)));                     %[cm^3]
                    %p = p1 to p8 (whichever is relevant) as given in table B1.

                    if  Z_ls(i,j) < 15;                                                                                         %[cm^3]
                        Z_ls(i,j) = 15 ;                                                                                        %[cm^3]
                    else
                        Z_ls(i,j) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)));                 %[cm^3]
                    end
                end
            end
        end
    
    %TRANSEVERSESTIFFENERSWITHIN 0.4*L SIDESTRUCTURE%   
    elseif Strakes(1,21,k) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 13 || Strakes(1,1,i) ==   18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    if (Stiff_YZ(j,2)/100)<zn(1,1)
                        ii = 1;
                        jj = f2b;
                    else
                        ii = 2;
                        jj = f2d;
                    end

                    %Allowable stress within 0.4*L amidships%
                    sigma_ls(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));

                    if sigma_ls(i,j) > 160*f1;
                        sigma_ls(i,j) = 160*f1;
                    else sigma_ls(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));
                    end

                    sigma_ls(1,1)=0;

                    if sigma_ls(i,j)<0
                        sigma_ls_check = 1;
                    end

                    
                    %BUCKLING CHECK OF SIDE LONGITUDINAL%
                    eta_stiff_ls = 0.85;

                    %The calculated compressive stress in plate stiffeners%
                    sigma_a_stiff_ls(i,j) = sigmaf;

                    %The critical buckling stress%
                    if sigmac_stiff_ls(i,j) < (sigma_a_stiff_ls(i,j)/eta_stiff_ls);
                        sigmac_stiff_ls(i,j) = (sigma_a_stiff_ls(i,j)/eta_stiff_ls);
                    elseif sigmac_stiff_ls(i,j) >= (sigma_a_stiff_ls(i,j)/eta_stiff_ls);
                        sigmac_stiff_ls(i,j) = sigmac_stiff_ls(i,j);
                    end                    
                    
                    
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_ls(i,j) < sigma_ls(i,j)
                        sigma(i,j) = sigmac_stiff_ls(i,j);
                    else
                        sigma(i,j) = sigma_ls(i,j);
                    end                    
                    
                    
                    %SECTIONMODULUSREQUIREMENTSOFSIDELONGITUDINALS%
                    Z_ls(i,j) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)));             %[cm^3]            
                    %p = p1 to p8 (whichever is relevant) as given in table B1.

                    if  Z_ls(i,j) < 15;                                                                                 %[cm^3]
                        Z_ls(i,j) = 15 ;                                                                                %[cm^3]
                    else
                        Z_ls(i,j) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)));         %[cm^3]
                    end
                end
            end
        end
    end
end


%SIDESTRUCTURECHECKVALUES%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 13 || Strakes(1,1,i) ==   18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20
        t_side_check(i,1) = (t_side(i,1)-Strakes(1,3,i)*10)./(t_side(i,1)+Strakes(1,3,i)*10);
    end
end



 
 for i=1:Csec_size/2
     for j = cum_sum(i,1)+1:cum_sum(i+1,1)
         if Strakes(1,1,i) == 13 || Strakes(1,1,i) ==   18 || Strakes(1,1,i) == 19 || Strakes(1,1,i) == 20
             Z_ls_check(i,j) = (Z_ls(i,j)-Strakes(1,23,i))./(Z_ls(i,j)+Strakes(1,23,i));  
         end
     end
 end
 
Z_ls_check(Z_ls==0)=[];
Z_ls(Z_ls==0)=[];
 
 
%C400 MAIN FRAMES
for i=1:Csec_size/2
    if Strakes(1,1,i) == 0
        C = 0.37;                                                                                           %C = 0.37 when external pressure (p1-p2) is used, C = 0.43 when internal pressure (p3-p8) is used 
        
        %Full length of main frameincluding brackets%
        l_mf = 2;                                                                                           %[m]
        
        %Stiffener spacing%
        sf = 0.6;                                                                                           %[m]

        %Section modulus requirement%
        Z_mf = (C*(l_mf^2)*sf*Strakes(1,22,i)*wk)/f1;                                                                     %[cm^3]
        %p = p1-p8 whichever is relevant 
        %lf = corresponding to full length of frame including brackets 
    end
end


%C500 TWEEN DECK FRAMES AND VERTICAL PEAK FRAMES
for i=1:Csec_size/2
    if Strakes(1,1,i) == 0
        k_tdf = 4.0;                                                                                        %ktdf = 4.0 for tween deck frames, 6.5 for peak frames.         
        
        %Full length of tween deck frame including brackets%
        l_tf = 2;                                                                                           %[m]

        %Section modulus requirement for tween deck frame first equation%
        Z_tdf1 = 0.55*(l_tf^2)*s*Strakes(1,22,i)*wk/f1;                                                                   %[cm^3]                                                    
        
        %Section modulus requirement for tween deck frame second equation%
        Z_tdf2 = k_tdf*sqrt(L/f1);                                                                          %[cm^3]                                                            

        if Z_tdf1 > Z_tdf2;
            Z_tdf = Z_tdf2;
        elseif Z_tdf2 > Z_tdf1;
            Z_tdf = Z_tdf1;
        end 
    end
end


%D. GIRDERS
for i=1:Csec_size/2
    if Strakes(1,1,i) == 0
        k_girder = 0.01*L1;                                                                                 %Thickness of web plates, flanges brackets and stiffeners of girders shall not be less than. 
                                                                                                            %in general 0.02*L1 for girder webs, flanges and brackets in cargo oil tanks and ballast tanks in cargo area. 0.03*l1 (maximum 6.0) for girder webs, flanges and brackets in peaks.
        t_girder = 5.0+(k_girder/sqrt(f1));% +tk [mm]                                                       %The thickness of web plates, flanges, brackets and stiffeners of girders                                                                                    %shall not be less than:
    end
end


%D200 Simple girders
for i=1:Csec_size/2     
    if Strakes(1,1,i) == 0
        for j = cum_sum(i,1)+1:cum_sum(i+1,1)       
            S = 2.0; 
            
            if (Stiff_YZ(j,2)/100)<zn(1,1)                                                                  %Must be changed for correct reference to girders      
                ii = 1;
                jj = f2b;
            else
                ii = 2;
                jj = f2d;
            end
            
            sigma_sg(j,1) = 190*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));                              %Maximum 160*f1 for continous longitudinal girders within 0.4 amidships. 160*f1 for other girders.

            if sigma_sg(j,1) > 160*f1 
                sigma_sg(j,1) = 160*f1;
            else sigma_sg(j,1) = 190*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));
            end
            
            sigma_sg(1,1)=0;
            
            if sigma_sg(j,1)<0
                sigma_sg_check = 1;
            end
            
            %Section modulus requirement for simple girders
            Z_sg(j,1) = (100*Ssg^2*b*Strakes(1,22,i)*wk)/sigma_sg(j,1);                                                   %[cm^3]
        end
    end
end



%INNER BOTTOM PLATING (ID-number 7 & 8)%

%REQUIREMENTS FOR INNERBOTTOM PLATING%
for j = 1:Csec_size/2
    
    %LONGITUDINALY STIFFENED WITHIN 0.4L%
    if Strakes(1,21,j) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
                
                sigma_ib(i,1) = (140*f1);                                                                       %when longitudinal frames, within 0.4*L, change it if it to 160*f1 within 0.1*L from the perpendiculars, 220*f1 for flooded condition.
                
                
                %BUCKLING CHECK OF LONGITUDINALY STIFFENED INNER BOTTOM PLATING%
                if zn(1,1)>=za_plate(i,1)
                    Ma = Msh+Mwh;
                    nn = 1;
                else
                    Ma = abs(Mss+Mws);
                    nn = 2;
                end
                
                psi_ib = 1;                                                                            % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
                
                k_ib = 8.4/(psi_ib+1.1);

                
                %The ideal elastic buckling stress may be taken as 
                sigmael_ib(i,1) = 0.9*k_ib*E*((Strakes(1,3,i)*10/(1000*Strakes(:,4,i))).^2);              %[N/mm^2] Vist oss ombestemme oss for  ta med korrosjonstillegget so skal det ver med i denne formelen her, sj side 157 i pt.3 ch.1.  

                if sigmael_ib(i,1) < sigmaf/2;
                    sigmac_ib(i,1) = sigmael_ib(i,1);
                elseif sigmael_ib(i,1) > sigmaf/2;
                    sigmac_ib(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_ib(i,1))));
                end
                
                
                %The calculated compressive stress in plate stiffeners%
                sigma_a_ib(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5);
                
                eta_ib = 0.9;                
                
                %The critical buckling stress calculated
                if sigmac_ib(i,1) < (sigma_a_ib(i,1)/eta_ib);
                    sigmac_ib(i,1) = (sigma_a_ib(i,1)/eta_ib);
                elseif sigmac_ib(i,1) >= (sigma_a_ib(i,1)/eta_ib);
                    sigmac_ib(i,1) = sigmac_ib(i,1) ;
                end
                

                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_ib(i,1) < sigma_ib(i,1)
                    sigma(i,1) = sigmac_ib(i,1);
                else
                    sigma(i,1) = sigma_ib(i,1);
                end                
                
                
                %Correction factor for aspect ratio of plate field innter bottom
                ka_i(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i))).^2;            
            
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_i(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>= 1.0
                    ka_i(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>0.4 && (Strakes(1,4,i)/Strakes(1,20,i))<1;
                    ka_i(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end

                %Thickness requirement%.
                t00_ib = 5.0;                                                                               %7.0 in holds below dry cargo hatchway opening if ceiling is not fitted. 6.0 elsewhere in holds if ceiling is not fitted 5.0 in general if ceiling is fitted. 5.0 in void spaces, machinery spaces and tanks.
                
                t_ib(i,1) = (15.8*ka_i(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)));
            
                if t_ib(i,1) < (t00_ib+(0.03*L1/(sqrt(f1))));
                    t_ib(i,1) = (t00_ib+(0.03*L1/(sqrt(f1))));
                else t_ib(i,1) = (15.8*ka_i(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)));
                end
            end
        end
    

    %TRANSVERSLY STIFFENED WITHIN 0.4L%
    elseif Strakes(1,21,j) == 1;
        for i=1:Csec_size/2
            
            if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
                sigma_ib(i,1) = (200*f1-110*f2b);                                                                %maximum 140*f1 when transverse frames within 0.4*L, change it if it to 160*f1 within 0.1*L from the perpendiculars, 220*f1 for flooded condition.
                
                if sigma_ib(i,1) > 140*f1 ;
                    sigma_ib(i,1) = 140*f1 ;
                else sigma_ib(i,1) = (200*f1-110*f2b);
                end
              
                if sigma_ib(i,1)<0
                    sigma_ib_check = 1;
                end
              
                t00_ib = 5.0;                                                                               %7.0 in holds below dry cargo hatchway opening if ceiling is not fitted. 6.0 elsewhere in holds if ceiling is not fitted 5.0 in general if ceiling is fitted. 5.0 in void spaces, machinery spaces and tanks.

                %Correction factor for aspect ratio of plate field innter bottom
                ka_i(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i))).^2;            
            
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_i(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>= 1.0
                    ka_i(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>0.4 && (Strakes(1,4,i)/Strakes(1,20,i))<1;
                    ka_i(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end                
                
                
                %BUCKLING CHECK OF LONGITUDINALY STIFFENED INNER BOTTOM PLATING%
                if zn(1,1)>=za_plate(i,1)
                    Ma = Msh+Mwh;
                    nn = 1;
                else
                    Ma = abs(Mss+Mws);
                    nn = 2;
                end
                
                psi_ib = 1;                                                                                            % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
              
                c_ib = 1.1 ;                                                                                           %=1.21 when stiffeners are angles or T-sections
                                                                                                                            %= 1.10 when stiffeners are bulb flats
                                                                                                                            %= 1.05 when stiffeners are flat bars
                                                                                                                            %= 1.3 when the plating is supported by floors or deep girders.
                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                    long(i,1) = Strakes(1,4,i);
                else
                    short(i,1) = Strakes(1,4,i);
                    long(i,1) = Strakes(1,20,i);
                end 
                                                                                                                            
                k_ib(i,1) = c_ib*((1+((short(i,1)/long(i,1)).^2)).^2)*(2.1/(psi_ib+1.1));

                %The ideal elastic buckling stress may be taken as
                sigmael_ib(i,1) = 0.9*k_ib(i,1)*E*((Strakes(1,3,i)*10/(1000*short(i,1))).^2);                         %[N/mm^2] 

                if sigmael_ib(i,1) < sigmaf/2;
                    sigmac_ib(i,1) = sigmael_ib(i,1);
                elseif sigmael_ib(i,1) > sigmaf/2;
                    sigmac_ib(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_ib(i,1))));
                end
              
                eta_ib = 0.9;

                %The calculated compressive stress in plate panels.
                sigma_a_ib(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5); 
              

                %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows:
                if sigmac_ib(i,1) < (sigma_a_ib(i,1)/eta_ib)
                    sigmac_ib(i,1) = (sigma_a_ib(i,1)/eta_ib);
                elseif sigmac_ib(i,1) >= (sigma_a_ib(i,1)/eta_ib)
                    sigmac_ib(i,1) = sigmac_ib(i,1);
                end                 
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_ib(i,1) < sigma_ib(i,1)
                    sigma(i,1) = sigmac_ib(i,1);
                else
                    sigma(i,1) = sigma_ib(i,1);
                end
                
                
                %Thickness requirement%
                t_ib(i,1) = (15.8*ka_i(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)));
            
                if  t_ib(i,1) < (t00_ib+(0.03*L1/(sqrt(f1))));
                    t_ib(i,1) = (t00_ib+(0.03*L1/(sqrt(f1))));
                else
                    t_ib(i,1) = (15.8*ka_i(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)));
                end
            end
        end
    end
end



%REQUIREMENTS FOR INNER BOTTOM STIFFENERS%
for k = 1:Csec_size/2
    
    %LONGITUDINALS, WITHIN 0.4 INNER BOTTOMSTRUCTURE
    if Strakes(1,21,k) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                
                    %SECTION MODULUS REQUIREMENTS IN [cm^3] OF INNER BOTTOM LONGITUDINALS%
                    %sigma_db_ibstf = %50*f1;                                                                     %Mean double bottom stress at plate flanges, normally not to be taken less than: = 20 f1 for cargo holds in general cargo vessels ;50 f1 for holds for ballast ;85 f1 b/B for tanks for liquid cargo
                     b=Strakes(1,2,i)/100;
                     sigma_db_ibstf = 85*f1*b/B;                                            %Mean double bottom stress at plate flanges, normally not to be taken less than
                                                                                         %20*f1 for cargo holds in general cargo vessels; 
                                                                                         %50*f1 for holds for ballast 
                                                                                            %85*f1*b/B for tanks for liquid cargo,b is breadth of tank in double bottom;

                    
                    sigma_ibstf(i,j) = 225*f1 - 100*f2b - 0.7*sigma_db_ibstf ;                                       %within 0.4*L (maximum 160*f1),
                    if sigma_ibstf(i,j) > 160*f1;
                        sigma_ibstf(i,j) = 160*f1;
                    else sigma_ibstf(i,j) = 225*f1 - 100*f2b - 0.7*sigma_db_ibstf;
                    end
                
                    if sigma_ibstf(i,j)<0
                        sigma_ibstf_check = 1;
                    end
                    
                    
                    %BUCKLING CHECK OF INNER BOTTOM LONGITUDINALS%
                    sigmael_stiff_ib(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i)^2)); %[N/mm^2], the formula given for sigmael is based on hinged ends and axial force only. %If, in special cases, it is verified that one end can be regarded as fixed, the value of sigmael may be multiplied by 2. If it is verified that both ends can be regarded as fixed, the value of sigmael may be multiplied by 4.

                    sigma_a_stiff_ib(i,j) = ((Msh+Mwh)/(IN))*(zn(1,1)-za_stiff(j,1))*(10^5); 


                    if sigmael_stiff_ib(i,j) < sigmaf/2;
                        sigmac_stiff_ib(i,j) = sigmael_stiff_ib(i,j) ;
                    elseif sigmael_stiff_ib(i,j) > sigmaf/2;
                        sigmac_stiff_ib(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_ib(i,j))));
                    end
                    
                    eta_stiff_ib = 0.85;

                    if sigmac_stiff_ib(i,j) < (sigma_a_stiff_ib(i,j)/eta_stiff_ib);
                        sigmac_stiff_ib(i,j) = (sigma_a_stiff_ib(i,j)/eta_stiff_ib);
                    elseif sigmac_stiff_ib(i,j) >= (sigma_a_stiff_ib(i,j)/eta_stiff_ib);
                        sigmac_stiff_ib(i,j) = sigmac_stiff_ib(i,j);
                    end
                    
                    
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_ib(i,j) < sigma_ibstf(i,j)
                        sigma(i,j) = sigmac_stiff_ib(i,j);
                    else
                        sigma(i,j) = sigma_ibstf(i,j);
                    end                
                
                
                    %Section modulus requirement for inner bottom longitudinals.
                    Z_ib(i,j) = (83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j));                
            
                    
                    %The thickness of web and flange shall not be less than the larger of t1 and t2 
                    hw_ib(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                                            %web height in [mm]
                    
                    g_ib = 41;                                                                                      %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles
                    
                    t1_ib(i,1) = 4.5 + k_t1;                                                                        % +tk, 
                    
                    t2_ib(i,1) = 1.5 + ((hw_ib(i,1)*sqrt(f1))/(g_ib));% +tk 
            
                    if t1_ib(i,1) < t2_ib(i,1)
                        t0_ib(i,1) = t2_ib(i,1);
                    else
                        t0_ib(i,1) = t1_ib(i,1);
                    end
                end
            end
        end
        
    %TRANSVERSLY STIFFENED WITHIN 0.4L%
    elseif Strakes(1,21,j) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8

                %Mean double bottom stress at plate flanges, normally not to be taken less than
                 b=Strakes(1,2,i)/100;
                 sigma_db_ibstf = 85*f1*b/B;                                            %Mean double bottom stress at plate flanges, normally not to be taken less than
                                                                                         %20*f1 for cargo holds in general cargo vessels; 
                                                                                         %50*f1 for holds for ballast 
                                                                                         %85*f1*b/B for tanks for liquid cargo,b is breadth of tank in double bottom;

                %sigma_db_ibstf = 50*f1;                                         
                                                                                                        
                sigma_ibstf(i,1) = (225*f1)-130*f2b-0.7*sigma_db_ibstf;                                      %sigma_bl = 225 f1 ? 130 f2b, for single bottom
        
                if sigma_ibstf(i,1)<0
                    sigma_ibstf_check = -1;
                end

                
                %BUCKLING CHECK OF TRANSEVERSEINNER BOTTOM LONGITUDINALS%
                eta_stiff_ib = 0.85; 

                sigma_a_stiff_ib(i,1) = sigmaf ; 

                if sigmac_stiff_ib(i,1) < (sigma_a_stiff_ib(i,1)/eta_stiff_ib);
                    sigmac_stiff_ib(i,1) = (sigma_a_stiff_ib(i,1)/eta_stiff_ib);
                elseif sigmac_stiff_ib(i,1) >= (sigma_a_stiff_ib(i,1)/eta_stiff_ib);
                    sigmac_stiff_ib(i,1) = sigmac_stiff_ib(i,1);
                end                
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_stiff_ib(i,1) < sigma_ibstf(i,1)
                    sigma(i,1) = sigmac_stiff_ib(i,1);
                else
                    sigma(i,1) = sigma_ibstf(i,1);
                end
                
                
                %SECTION MODULUS REQUIREMENTS IN [cm^3] OF BOTTOM/KEEL LONGITUDINAL%
                Z_ib(i,1) = ((83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,1)));
                %p = p1 to p3 (when relevant) as given in table B1.

                
                %The web and flange thickness shall not be less than the larger of: 
                hw_ib(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                                    %web height in [mm]
                
                g_ib = 41;                                                                              %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles
                
                t1_ib(i,1) = 4.5 + k_t1 ;                                                               % +tk,
                
                t2_ib(i,1) = 1.5 + ((hw_ib(i,1)*sqrt(f1))/(g_ib)) ;                                     % +tk
        
                if t1_ib(i,1) < t2_ib(i,1)
                    t0_ib(i,1) = t2_ib(i,1);
                else
                    t0_ib(i,1) = t1_ib(i,1);
                end
            end
        end
    end
end


%INNERBOTTOMCHECKVALUES%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
        t_ib_check(i,1) = (t_ib(i,1)-Strakes(1,3,i)*10)./(t_ib(i,1)+Strakes(1,3,i)*10);
    end
end

t_ib_check(t_ib==0)=[];
t_ib(t_ib==0)=[];

for i=1:Csec_size/2
    if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
        for j = cum_sum(i,1)+1:cum_sum(i+1,1)
            Z_ib_check(i,j) = (Z_ib(i,j)-Strakes(1,23,i))./(Z_ib(i,j)+Strakes(1,23,i));
        end
    end
end

for i=1:Csec_size/2
    if Strakes(1,1,i) == 7 || Strakes(1,1,i) == 8
        t0_ib_check(i,1) = (t0_ib(i,1)-Strakes(1,12,i)*20)./(t0_ib(i,1)+Strakes(1,12,i)*20);
        t0_ib_check1(i,1) = (t0_ib(i,1)-Strakes(1,13,i)*10)./(t0_ib(i,1)+Strakes(1,13,i)*10);
    end
end
 
t0_ib_check(t0_ib==0)=[]; 
t0_ib_check1(t0_ib==0)=[];
t0_ib(t0_ib==0)=[];
Z_ib_check(Z_ib==0)=[];
Z_ib(Z_ib==0)=[];



%PLATINGINDOUBLEBOTTOMFLOORSANDLONGITUDINALGIRDERS (ID-number 4,5,6)%
for j = 1:Csec_size/2
    if Strakes(1,21,j) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6
        
                %For centre girder up to 2 m above keel plate.
                if Strakes(1,1,i) == 4
                    k_db(i,1) = 0.04*L1;
                    
                %For other girders and remaining part of center girder. 
                elseif Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6
                    k_db(i,1) = 0.02*L1;
                    
                %For sea chest boundaries (including top and partial bulkheads).
                elseif Strakes(1,1,i) == 0
                    k_db(i,1) = 0.05*L1;                                                    
                end
                
                
                %Correction factor for aspect ratio of plate field double bottom
                ka_db(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i))).^2;               
        
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_db(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i)) >= 1.0
                    ka_db(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>0.4 && (Strakes(1,4,i)/Strakes(1,20,i))<1;
                    ka_db(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end
                
                
                %For sea chest boundaries (including top and partial bulkheads).
                if Strakes(1,1,i) == 0
                    sigma_dbf(i,1) = 120*f1;
                    
                    %BUCKLING CHECK OF LONGITUDINALY STIFFENED INNER BOTTOM PLATING%
                    if zn(1,1)>=za_plate(i,1)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                    
                    psi_dbf = 1;                                                                            % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
                
                    k_dbf = 8.4/(psi_dbf+1.1);

                
                    %The ideal elastic buckling stress may be taken as 
                    sigmael_dbf(i,1) = 0.9*k_dbf*E*((Strakes(1,3,i)*10/(1000*Strakes(:,4,i))).^2);              %[N/mm^2] Vist oss ombestemme oss for  ta med korrosjonstillegget so skal det ver med i denne formelen her, sj side 157 i pt.3 ch.1.  

                    if sigmael_dbf(i,1) < sigmaf/2;
                        sigmac_dbf(i,1) = sigmael_dbf(i,1);
                    elseif sigmael_dbf(i,1) > sigmaf/2;
                        sigmac_dbf(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_dbf(i,1))));
                    end
                    
                    
                    %The calculated compressive stress in plate stiffeners%
                    sigma_a_dbf(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5);
                
                    eta_dbf = 0.9;                
                
                    %The critical buckling stress calculated
                    if sigmac_dbf(i,1) < (sigma_a_dbf(i,1)/eta_dbf);
                        sigmac_dbf(i,1) = (sigma_a_dbf(i,1)/eta_dbf);
                    elseif sigmac_dbf(i,1) >= (sigma_a_dbf(i,1)/eta_dbf);
                        sigmac_dbf(i,1) = sigmac_dbf(i,1);
                    end
                    
                    
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_dbf(i,1) < sigma_dbf(i,1)
                        sigma(i,1) = sigmac_dbf(i,1);
                    else
                        sigma(i,1) = sigma_dbf(i,1);
                    end                     
                    
                    %Thickness requirement for double bottom floors forming boundaries of double bottom tanks
                    t_dbf(i,1) = (15.8*ka_db(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)));   
        
                    if t_dbf(i,1) < 6.0+(k_db(i,1)/sqrt(f1));
                        t_dbf(i,1) = 6.0+(k_db(i,1)/sqrt(f1));
                    else
                        t_dbf(i,1) = t_dbf(i,1);
                    end    
                end
                
                
                %For centre girder up to 2 m above keel plate (ID-number 4 ), for other girders and remaining part of center girder (ID-number 5 & 6).
                if Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6
                    sigma_lg(i,1) = 130*f1;                                                                          %160*f1 if the location is within 0.1*L 

                    %BUCKLING CHECK OF LONGITUDINALY STIFFENED INNER BOTTOM PLATING%
                    if zn(1,1)>=za_plate(i,1)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                
                    psi_lg = 1;                                                                            % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
                
                    k_lg = 8.4/(psi_lg+1.1);

                
                    %The ideal elastic buckling stress may be taken as 
                    sigmael_lg(i,1) = 0.9*k_lg*E*((Strakes(1,3,i)*10/(1000*Strakes(:,4,i))).^2);              %[N/mm^2] Vist oss ombestemme oss for  ta med korrosjonstillegget so skal det ver med i denne formelen her, sj side 157 i pt.3 ch.1.  

                    if sigmael_lg(i,1) < sigmaf/2;
                        sigmac_lg(i,1) = sigmael_lg(i,1);
                    elseif sigmael_lg(i,1) > sigmaf/2;
                        sigmac_lg(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_lg(i,1))));
                    end
                
                
                    %The calculated compressive stress in plate stiffeners%
                    sigma_a_lg(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5);
                
                    eta_lg = 0.9;                
                
                    %The critical buckling stress calculated
                    if sigmac_lg(i,1) < (sigma_a_lg(i,1)/eta_lg);
                        sigmac_lg(i,1) = (sigma_a_lg(i,1)/eta_lg);
                    elseif sigmac_lg(i,1) >= (sigma_a_lg(i,1)/eta_lg);
                        sigmac_lg(i,1) = sigmac_lg(i,1) ;
                    end
                

                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_lg(i,1) < sigma_lg(i,1)
                        sigma(i,1) = sigmac_lg(i,1);
                    else
                        sigma(i,1) = sigma_lg(i,1);
                    end                     
                    
                    %Thickness requirement for longitudinal girders forming boundaries of double bottom tanks
                    t_lg(i,1) = (15.8*ka_db(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)));     

                    if t_lg(i,1) < 6.0+(k_db(i,1)/sqrt(f1));
                        t_lg(i,1) = 6.0+(k_db(i,1)/sqrt(f1));
                    else
                        t_lg(i,1) = t_lg(i,1);
                    end
                end 
            end
        end
    elseif Strakes(1,21,j) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6

                %For centre girder up to 2 m above keel plate.
                if Strakes(1,1,i) == 4
                    k_db(i,1) = 0.04*L1;
                    
                %For other girders and remaining part of center girder.
                elseif Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6
                    k_db(i,1) = 0.02*L1;
                    
                %For sea chest boundaries (including top and partial bulkheads).
                elseif Strakes(1,1,i) == 0
                    k_db(i,1) = 0.05*L1;                                                    
                end
                
                
                %Correction factor for aspect ratio of plate field double bottom
                ka_db(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i))).^2;
        
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_db(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i)) >= 1.0
                    ka_db(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>0.4 && (Strakes(1,4,i)/Strakes(1,20,i))<1;
                    ka_db(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end
                
        
                %For sea chest boundaries (including top and partial bulkheads).
                if Strakes(1,1,i) == 0
                    sigma_dbf(i,1) = 120*f1;
                    
                    %BUCKLING CHECK OF TRANSVERSLY STIFFENED INNER BOTTOM PLATING%
                    if zn(1,1)>=za_plate(i,1)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                
                    psi_dbf = 1;                                                                                            % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
              
                    c_dbf = 1.1 ;                                                                                           %=1.21 when stiffeners are angles or T-sections
                                                                                                                            %= 1.10 when stiffeners are bulb flats
                                                                                                                            %= 1.05 when stiffeners are flat bars
                                                                                                                            %= 1.3 when the plating is supported by floors or deep girders.
                    if Strakes(1,20,i)<Strakes(1,4,i)
                        short(i,1) = Strakes(1,20,i);
                        long(i,1) = Strakes(1,4,i);
                    else
                        short(i,1) = Strakes(1,4,i);
                        long(i,1) = Strakes(1,20,i);
                    end 
                                                                                                                            
                    k_dbf(i,1) = c_dbf*((1+((short(i,1)/long(i,1)).^2)).^2)*(2.1/(psi_dbf+1.1));

                    %The ideal elastic buckling stress may be taken as
                    sigmael_dbf(i,1) = 0.9*k_dbf(i,1)*E*((Strakes(1,3,i)*10/(1000*short(i,1))).^2);                         %[N/mm^2] 

                    if sigmael_dbf(i,1) < sigmaf/2;
                        sigmac_dbf(i,1) = sigmael_dbf(i,1);
                    elseif sigmael_dbf(i,1) > sigmaf/2;
                        sigmac_dbf(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_dbf(i,1))));
                    end
              
                    eta_dbf = 0.9;

                    %The calculated compressive stress in plate panels.
                    sigma_a_dbf(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5); 
              

                    %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows:
                    if sigmac_dbf(i,1) < (sigma_a_dbf(i,1)/eta_dbf)
                        sigmac_dbf(i,1) = (sigma_a_dbf(i,1)/eta_dbf);
                    elseif sigmac_dbf(i,1) >= (sigma_a_dbf(i,1)/eta_dbf)
                        sigmac_dbf(i,1) = sigmac_dbf(i,1);
                    end                 
                
                
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_dbf(i,1) < sigma_dbf(i,1)
                        sigma(i,1) = sigmac_dbf(i,1);
                    else
                        sigma(i,1) = sigma_dbf(i,1);
                    end                    
                    
                    %Thickness requirement for double bottom floors forming boundaries of double bottom tanks 
                    t_dbf(i,1) = (15.8*ka_db(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)));
        
                    if t_dbf(i,1) < 6.0+(k_db(i,1)/sqrt(f1));
                        t_dbf(i,1) = 6.0+(k_db(i,1)/sqrt(f1));
                    else t_dbf(i,1) = t_dbf(i,1);
                    end    
                end
                
                
                %For centre girder up to 2 m above keel plate (ID-number 11), for other girders and remaining part of center girder (ID-number 12).
                if Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6
                    sigma_lg(i,1) = 190*f1-120*f2b;                                          %within 0.4*L,160*f1 if the location is within 0.1*L
                
                    if sigma_lg(i,1) > 130*f1;
                        sigma_lg(i,1) = 130*f1;
                    else sigma_lg(i,1) = 190*f1-120*f2b;
                    end
                    
                    if sigma_lg(i,1)<0
                        sigma_lg_check = 1;
                    end
                    
                    
                    %BUCKLING CHECK OF TRANSVERSLY STIFFENED INNER BOTTOM PLATING%
                    if zn(1,1)>=za_plate(i,1)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                
                    psi_lg = 1;                                                                                            % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
              
                    c_lg = 1.1 ;                                                                                           %=1.21 when stiffeners are angles or T-sections
                                                                                                                            %= 1.10 when stiffeners are bulb flats
                                                                                                                            %= 1.05 when stiffeners are flat bars
                                                                                                                            %= 1.3 when the plating is supported by floors or deep girders.
                    if Strakes(1,20,i)<Strakes(1,4,i)
                        short(i,1) = Strakes(1,20,i);
                        long(i,1) = Strakes(1,4,i);
                    else
                        short(i,1) = Strakes(1,4,i);
                        long(i,1) = Strakes(1,20,i);
                    end 
                                                                                                                            
                    k_lg(i,1) = c_lg*((1+((short(i,1)/long(i,1)).^2)).^2)*(2.1/(psi_lg+1.1));

                    %The ideal elastic buckling stress may be taken as
                    sigmael_lg(i,1) = 0.9*k_lg(i,1)*E*((Strakes(1,3,i)*10/(1000*short(i,1))).^2);                         %[N/mm^2] 

                    if sigmael_lg(i,1) < sigmaf/2;
                        sigmac_lg(i,1) = sigmael_lg(i,1);
                    elseif sigmael_lg(i,1) > sigmaf/2;
                        sigmac_lg(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_lg(i,1))));
                    end
              
                    eta_lg = 0.9;

                    %The calculated compressive stress in plate panels.
                    sigma_a_lg(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5); 
              

                    %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows:
                    if sigmac_lg(i,1) < (sigma_a_lg(i,1)/eta_lg)
                        sigmac_lg(i,1) = (sigma_a_lg(i,1)/eta_lg);
                    elseif sigmac_lg(i,1) >= (sigma_a_lg(i,1)/eta_lg)
                        sigmac_lg(i,1) = sigmac_lg(i,1);
                    end                 
                
                
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_lg(i,1) < sigma_lg(i,1)
                        sigma(i,1) = sigmac_lg(i,1);
                    else
                        sigma(i,1) = sigma_lg(i,1);
                    end                    
                    
                    %Thickness requirement for longitudinal girders forming boundaries of double bottom tanks
                    t_lg(i,1) = (15.8*ka_db(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)));
    
                    if t_lg(i,1) < 6.0+(k_db(i,1)/sqrt(f1));
                        t_lg(i,1) = 6.0+(k_db(i,1)/sqrt(f1));
                    else
                        t_lg(i,1) = t_lg(i,1);
                    end
                end
            end
        end        
    end
end
 

%REQUIREMENTS FOR DOUBLEBOTTOMFLOORSANDGIRDER STIFFENERS%
for k=1:Csec_size/2
    if Strakes(1,21,k) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 6
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    
                    sigma_onbottomfloorsandgirders(i,j) = 225*f1-110*f2b;                                                            %maximum 160*f1 for longitudinal stiffeners within 0.4*L, 160*f1 for longitudinal stiffeners within 0.1*L from perpendiculars. Between specified regions of longitudinal stifferners the sigma value can be varied linearly.
                                                                                                                            %220*f1 in flooded condition.
            
                    if sigma_onbottomfloorsandgirders(i,j) > 160*f1;                                                               %blei jvla lange sigma variabelen her jah :P
                        sigma_onbottomfloorsandgirders(i,j) = 160*f1 ;
                    else
                        sigma_onbottomfloorsandgirders(i,j) = 225*f1-110*f2b;
                    end
                    
                    if sigma_onbottomfloorsandgirders(i,j)<0
                        sigma_onbottomfloorsandgirders_check = 1;
                    end
                    
                    %BUCKLINGCHECK%
                    if zn(1,1) >= (Stiff_YZ(j,2)/100)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                    
                    sigmael_stiff__onbottomfloorsandgirders(i,j) = (0.001*E*Ii_buckling(j,1))/(Ai_buckling(j,1)*Strakes(1,20,i)^2);   %[N/mm^2]
 

                    if sigmael_stiff__onbottomfloorsandgirders(i,j) < sigmaf/2;
                        sigmac_stiff__onbottomfloorsandgirders(i,j) = sigmael_stiff__onbottomfloorsandgirders(i,j);
                    elseif sigmael_stiff__onbottomfloorsandgirders(i,j) > sigmaf/2;
                        sigmac_stiff__onbottomfloorsandgirders(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff__onbottomfloorsandgirders(i,j))));
                    end
                    
                    
                    eta_stiff__onbottomfloorsandgirders = 0.85;

                    sigma_a_stiff__onbottomfloorsandgirders(i,j) = ((Ma)/(IN))*(zn(1,nn)-za_stiff(j,1))*(10^5);                     

                   
                    %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows:
                    if sigmac_stiff__onbottomfloorsandgirders(i,j) < (sigma_a_stiff__onbottomfloorsandgirders(i,j)/eta_stiff__onbottomfloorsandgirders);
                        sigmac_stiff__onbottomfloorsandgirders(i,j) = (sigma_a_stiff__onbottomfloorsandgirders(i,j)/eta_stiff__onbottomfloorsandgirders);
                    elseif sigmac_stiff__onbottomfloorsandgirders(i,j) >= (sigma_a_stiff__onbottomfloorsandgirders(i,j)/eta_stiff__onbottomfloorsandgirders);
                        sigmac_stiff__onbottomfloorsandgirders(i,j) = sigmac_stiff__onbottomfloorsandgirders(i,j);
                    end
                    
                    if sigmac_stiff__onbottomfloorsandgirders(i,j) < sigma_onbottomfloorsandgirders(i,j)
                        sigma(i,j) = sigmac_stiff__onbottomfloorsandgirders(i,j);
                    else
                        sigma(i,j) = sigma_onbottomfloorsandgirders(i,j);
                    end
                    
                    
                    Z_db(i,j) = (83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)); %[cm^3] Requirement for stiffeners and floors and longitudinal girders forming boundary of double bottom tanks is in general given by.
                end
            end
        end
        
    elseif Strakes(1,21,k) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 6
                sigma_onbottomfloorsandgirders(i,1) = 160*f1; 

                %BUCKLINGCHECKFORTRANSEVERSESTIFFENERS%
                eta_stiff_onbottomfloorsandgirders(i,1) = 0.85;

                sigma_a_stiff_onbottomfloorsandgirders(i,1) = sigmaf ;
                       
                if sigmac_stiff_onbottomfloorsandgirders(i,1) < (sigma_a_stiff_onbottomfloorsandgirders(i,1)/eta_stiff_onbottomfloorsandgirders);
                    sigmac_stiff_onbottomfloorsandgirders(i,1) = (sigma_a_stiff_onbottomfloorsandgirders(i,1)/eta_stiff_onbottomfloorsandgirders);
                elseif sigmac_stiff_onbottomfloorsandgirders(i,1) >= (sigma_a_stiff_onbottomfloorsandgirders(i,1)/eta_stiff_onbottomfloorsandgirders);
                    sigmac_stiff_onbottomfloorsandgirders(i,1) = sigmac_stiff_onbottomfloorsandgirders(i,1) ;
                end
                
                if sigmac_stiff_onbottomfloorsandgirders(i,1) < sigma_onbottomfloorsandgirders(i,1)
                    sigma(i,1) = sigmac_stiff_onbottomfloorsandgirders(i,1);
                else
                    sigma(i,1) = sigma_onbottomfloorsandgirders(i,1);
                end                 
                
                Z_db(i,1) = (100*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,1)); %[cm^3]
            end
        end
    end
end 

%DOUBLEBOTTOMFLOORSANDGIRDERCHECKVALUES%

for i=1:Csec_size/2
    if Strakes(1,1,i) == 0
        t_dbf_check(i,1) = (t_dbf(i,1)-Strakes(1,3,i)*10)./(t_dbf(i,1)+Strakes(1,3,i)*10);  
    end
end

for i=1:Csec_size/2
    if Strakes(1,1,i) == 5 || Strakes(1,1,i) == 4 || Strakes(1,1,i) == 6
        t_lg_check(i,1) = (t_lg(i,1)-Strakes(1,3,i)*10)./(t_lg(i,1)+Strakes(1,3,i)*10);   
    end    
end

for i=1:Csec_size/2
    if Strakes(1,1,i) == 0
        t_dbf_check(t_dbf==0)=[];
        t_dbf(t_dbf==0)=[];
    end
end

t_lg_check(t_lg==0)=[];
t_lg(t_lg==0)=[];

for i=1:Csec_size/2
    if Strakes(1,1,i) == 4 || Strakes(1,1,i) == 5 || Strakes(1,1,i) == 6
        for j = cum_sum(i,1)+1:cum_sum(i+1,1)
        Z_db_check(i,j) = (Z_db(i,j)-Strakes(1,23,i))./(Z_db(i,j)+Strakes(1,23,i));    
        end
    end
end
 
Z_db_check(Z_db==0)=[];
Z_db(Z_db==0)=[];
 


%DECK STRUCTURES 
%STRENGTH DECK PLATING (ID-number 14 and 15 )
for j=1:Csec_size/2
    if Strakes(1,21,j) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 14 || Strakes(1,1,i) == 15
         
                %The correction factor for aspect ratio of plate field
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_sd(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>= 1.0
                    ka_sd(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>0.4 && (Strakes(1,4,i)/Strakes(1,20,i))<1;
                    ka_sd(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end
                
                
                %The nominal allowable bending stress in N/mm2 due to lateral pressure
                sigma_strengthdeck(i,1) = 120*f1;                                                   %Within 0.4*L, 160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly.
                
                
                %BUCKLING CHECK OF LONGITUDINALY STIFFENED STRENGTH DECK PLATING%
                if zn(1,1)>=za_plate(i,1)
                    Ma = Msh+Mwh;
                    nn = 1;
                else
                    Ma = abs(Mss+Mws);
                    nn = 2;
                end
                    
                
                psi_sd = 1;                                                                        % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.         
                
                kl_sd = 8.4/(psi_sd+1.1);

                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                else
                    short(i,1) = Strakes(1,4,i);
                end
                
                %The ideal elastic buckling stress may be taken as 
                sigmael_sd(i,1) = 0.9*kl_sd*E*((Strakes(1,3,i)*10/(1000*(short(i,1)))).^2);        %[N/mm^2] Vist oss ombestemme oss for  ta med korrosjonstillegget so skal det ver med i denne formelen her, sj side 157 i pt.3 ch.1.  

 

                if sigmael_sd(i,1) < sigmaf/2;  
                    sigmac_sd(i,1) = sigmael_sd(i,1) ;
                elseif sigmael_sd(i,1) > sigmaf/2;
                    sigmac_sd(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_sd(i,1))));
                end
                
                eta_sd = 1.0;

                sigma_a_sd(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5); 

                
                if sigmac_sd(i,1) < (sigma_a_sd(i,1)/eta_sd);
                    sigmac_sd(i,1) = (sigma_a_sd(i,1)/eta_sd);
                elseif sigmac_sd(i,1) >= (sigma_a_sd(i,1)/eta_sd);
                    sigmac_sd(i,1) = sigmac_sd(i,1) ;
                end

                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_sd(i,1) < sigma_strengthdeck(i,1)
                    sigma(i,1) = sigmac_sd(i,1);
                else
                    sigma(i,1) = sigma_strengthdeck(i,1);
                end
                
                %Thickness requirement%
                t_sd(i,1) = ((15.8*ka_sd(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i)))/(sqrt(sigma(i,1))));
            end
        end
        
    elseif Strakes(1,21,j) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 14 || Strakes(1,1,i) == 15
                
                %The nominal allowable bending stress in N/mm2 due to lateral pressure
                sigma_strengthdeck(i,1) = 175*f1-120*f2d;
                if sigma_strengthdeck(i,1) > 120*f1;                             %Within 0.4*L, 160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                    sigma_strengthdeck(i,1) = 120*f1;                            %Within 0.4*L,160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                else sigma_strengthdeck(i,1) = 175*f1-120*f2d;                   %Within 0.4*L,160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                end
                
                if sigma_strengthdeck(i,1)<0
                    sigma_strengthdeck_check = 1;
                end
                
                
                %BUCKLINGCHECKFORPLATINGWITHTRANSVERSESTIFFENERS%
                if zn(1,1)>=za_plate(i,1)
                    Ma = Msh+Mwh;
                    nn = 1;
                else
                    Ma = abs(Mss+Mws);
                    nn = 2;
                end

                psi_sd = 1;                                                                         % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
                
                c_sd = 1.1;                                                                         %=1.21 when stiffeners are angles or T-sections 
                                                                                                    %= 1.10 when stiffeners are bulb flats
                                                                                                    %= 1.05 when stiffeners are flat bars
                                                                                                    %= 1.3 when the plating is supported by floors or deep girders.

                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                    long(i,1) = Strakes(1,4,i);
                else
                    short(i,1) = Strakes(1,4,i);
                    long(i,1) = Strakes(1,20,i);
                end                                                                                                    
                                                                                                    
                kl_sd(i,1) = c_sd*((1+((short(i,1)/long(i,1)).^2)).^2)*(2.1/(psi_sd+1.1));

                
                %The ideal elastic buckling stress may be taken as 
                sigmael_sd(i,1) = 0.9*kl_sd(i,1)*E*((Strakes(1,3,i)*10/(1000*(short(i,1)))^2)); %[N/mm^2] 

                if sigmael_sd(i,1) < sigmaf/2;
                    sigmac_sd(i,1) = sigmael_sd(i,1) ;
                elseif sigmael > sigmaf/2;
                    sigmac_sd(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_sd(i,1))));
                end
                
                
                %The calculated compressive stress in plate panels. With linearly varying stress across the plate panel, shall be taken as the largest stress.
                sigma_a_sd(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5); 

                
                %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows:
                eta_sd = 1.0;                
                
                if sigmac_sd(i,1) < (sigma_a_sd(i,1)/eta_sd)
                    sigmac_sd(i,1) = (sigma_a_sd(i,1)/eta_sd);
                elseif sigmac_sd(i,1) >= (sigma_a_sd(i,1)/eta_sd)
                    sigmac_sd(i,1) = sigmac_sd(i,1);
                end
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_sd(i,1) < sigma_strengthdeck(i,1)
                    sigma(i,1) = sigmac_sd(i,1);
                else
                    sigma(i,1) = sigma_strengthdeck(i,1);
                end
                
                
                %Thickness requirement%
                t00_sd = 5.5;                                                                           %5.5 for unsheathed weather and cargo decks, 5.0 for accomodation decks and for wheater and cargo decks sheathed with wood or an approved composition.

                k_sd = 0.02;                                                                            %0.02 in vessels with single continuous deck, 0.01 in vessels with two continuous decks above 0.7 D from the baseline, 0.01 as minimum for weather decks forward of 0.2 L from F.P, 0 in vessels with more than two continuous decks above 0.7 D from the baseline          
    
                t_sd(i,1) = ((15.8*ka_sd(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i)))/(sqrt(sigma(i,1))));                
                
                if t_sd(i,1) < t00_sd+((k_sd*L1)/sqrt(f1));
                    t_sd(i,1) = t00_sd+((k_sd*L1)/sqrt(f1));
                else t_sd(i,1) = t_sd(i,1);
                end               
            end
        end
    end
end


%STRENGTH DECK STIFFENERS (ID-number 14,15)%
for k=1:Csec_size/2
    
    %LONGITUDINAL STIFFENERS STRENGTH DECK%
    if Strakes(1,21,k) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 14 || Strakes(1,1,i) == 15
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    
                    %The allowable stress in stiffener within 0.4*L midship
                    
                    %sigma_strengthdeckstf(i,j) = 225*f1-130*f2d;                                                           %allowable stress in stiffener within 0.4*L midship given in table C1, formula from C1 is shown in the given formula. 160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly.
         
                    %if sigma_strengthdeckstf(i,j) > 160*f1;
                    %    sigma_strengthdeckstf(i,j) = 160*f1;
                    %else sigma_strengthdeckstf(i,j) = 225*f1-130*f2d;
                    %end
                    
                    sigma_strengthdeckstf(i,j) = 160*f1;                    %Bruker 160*f1 siden dekket er vre del av tanken
                    
                    if sigma_strengthdeckstf(i,j)<0
                        sigma_strengthdeckstf_check = 1;
                    end
                    
                    
                    %BUCKLING CHECK OF STRENGTH DECK LONGITUDINALS%
                    sigmael_stiff_sd(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i)^2));       %[N/mm^2] %The formula given for sigmael is based on hinged ends and axial force only. If, in special cases, it is verified that one end can be regarded as fixed, the value of ? el may be multiplied by 2. If it is verified that both ends can be regarded as fixed, the value of sigmael may be multiplied by 4.

                    if zn(1,1)>=(Stiff_YZ(j,2)/100)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                    
                    %C 100 General 

                    if sigmael_stiff_sd(i,j) < sigmaf/2; 
                        sigmac_stiff_sd(i,j) = sigmael_stiff_sd(j,1) ;
                    elseif sigmael_stiff_sd(i,j) > sigmaf/2;
                        sigmac_stiff_sd(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_sd(i,j)))); 
                    end
                    
                    eta_stiff_sd = 0.85;
                    
                    sigma_a_stiff_sd(i,j) = ((Ma)/(IN))*(zn(1,nn)-za_stiff(j,1))*(10^5);
                    
                    if sigmac_stiff_sd(i,j) < (sigma_a_stiff_sd(i,j)/eta_stiff_sd);
                        sigmac_stiff_sd(i,j) = (sigma_a_stiff_sd(i,j)/eta_stiff_sd);
                    elseif sigmac_stiff_sd(i,j) >= (sigma_a_stiff_sd(i,j)/eta_stiff_sd);
                        sigmac_stiff_sd(i,j) = sigmac_stiff_sd(i,j) ;
                    end
                
                
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_sd(i,j) < sigma_strengthdeckstf(i,j)
                        sigma(i,j) = sigmac_stiff_sd(i,j);
                    else
                        sigma(i,j) = sigma_strengthdeckstf(i,j);
                    end
                
                    
                    %Section modulus requirement in [cm^3] for longitudinal stiffener at strength deck.
                    Z_sd(i,j) = 83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/(sigma(i,j));               
                    
                    
                    %The web and flange thickness shall not be less than the larger of:        
                    k_sd = 0.01*L1 ;                                                                                        %in general, 0.015*L1 in peaks(extent is shown in Sec1.B) and for boundaries of cargo oil tanks and ballast tanks in cargo area. 0.5 for accomodation decks above strength deck.
                                                                                                                        %wk = corrosion factor, ignored in these claculations, so wk=1 
                    g_sd = 41 ;                                                                                             %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles 
                
                    hw_sd(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                                                    %web height in [mm]
                
                    t1_sd(i,1) = 4.5 + k_sd ;                                                                               % + tk, 
        
                    t2_sd(i,1) = 1.5 + ((hw_sd(i,1)*sqrt(f1))/(g_sd)) ;                                                     % +tk 
        
                    if t1_sd(i,1) < t2_sd(i,1)
                        t0_sd(i,1) = t2_sd(i,1);
                    else
                       t0_sd(i,1) = t1_sd(i,1);
                    end
                end
            end
        end
        
    %TRANSVERSE STIFFENERS STRENGTH DECK%
    elseif Strakes(1,21,k) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 14 || Strakes(1,1,i) == 15
                
                %The nominal allowable bending stress in N/mm2 due to lateral pressure
                sigma_strengthdeck(i,1) = 175*f1-120*f2d;
                if sigma_strengthdeck(i,1) > 120*f1;                                                         %Within 0.4*L, 160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                    sigma_strengthdeck(i,1) = 120*f1;                                                        %Within 0.4*L,160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                else sigma_strengthdeck(i,1) = 175*f1-120*f2d;                                               %Within 0.4*L,160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                end
                
                if sigma_strengthdeck(i,1)<0
                    sigma_strengthdeck_check = 1;
                end
                
                %BUCKLING CHECK OF STRENGTH DECK STIFFENERS%
                eta_stiff_sd = 0.85; 

                sigma_a_stiff_sd(i,1) = sigmaf ; 

                if sigmac_stiff_sd(i,1) < (sigma_a_stiff_sd(i,1)/eta_stiff_sd);
                    sigmac_stiff_sd(i,1) = (sigma_a_stiff_sd(i,1)/eta_stiff_sd);
                elseif sigmac_stiff_sd(i,1) >= (sigma_a_stiff_sd(i,1)/eta_stiff_sd);
                    sigmac_stiff_sd(i,1) = sigmac_stiff_sd(i,1);
                end
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_stiff_sd(i,1) < sigma_strengthdeck(i,1)
                    sigma(i,1) = sigmac_stiff_sd(i,j);
                else
                    sigma(i,1) = sigma_strengthdeck(i,1);
                end  
                
                
                %Section modulus requirement in [cm^3] for Transverse beams.
                Z_sd(i,1) = 0.63*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/f1;
             
                if Z_sd(i,1) < 15
                    Z_sd(i,1) = 15; 
                else
                    Z_sd(i,1) = 0.63*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/f1;
                end
            end
        end
    end
end
                

%STRENGTHDECKCHECKVALUES%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 14 || Strakes(1,1,i) == 15
        t_sd_check(i,1) = (t_sd(i,1)-Strakes(1,3,i)*10)./(t_sd(i,1)+Strakes(1,3,i)*10);
    end
end


for i=1:Csec_size/2
    if Strakes(1,1,i) == 14 || Strakes(1,1,i) == 15
        for j = cum_sum(i,1)+1:cum_sum(i+1,1)
            Z_sd_check(i,j) = (Z_sd(i,j)-Strakes(1,23,i))./(Z_sd(i,j)+Strakes(1,23,i));
        end
    end
end
 
 
for i=1:Csec_size/2
    if Strakes(1,1,i) == 14 || Strakes(1,1,i) == 15
        t0_sd_check(i,1) = (t0_sd(i,1)-Strakes(1,12,i)*20)./(t0_sd(i,1)+Strakes(1,12,i)*20);
        t0_sd_check1(i,1) = (t0_sd(i,1)-Strakes(1,13,i)*10)./(t0_sd(i,1)+Strakes(1,13,i)*10);
    end
end


%TWEEN DECK PLATING (ID-number 16 )
for j=1:Csec_size/2
    if Strakes(1,21,j) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 16
         
              %Thickness requirement%
               t00_td = 5.5;                                                                           %5.5 for unsheathed weather and cargo decks, 5.0 for accomodation decks and for wheater and cargo decks sheathed with wood or an approved composition.

               k_td = 0.00;                                                                            %0.02 in vessels with single continuous deck, 0.01 in vessels with two continuous decks above 0.7 D from the baseline, 0.01 as minimum for weather decks forward of 0.2 L from F.P, 0 in vessels with more than two continuous decks above 0.7 D from the baseline          

               t_td(i,1) = t00_td+((k_td*L1)/sqrt(f1));
               
            end
        end
        
    elseif Strakes(1,21,j) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 16
                
            
                %Thickness requirement%
                t00_td = 5.5;                                                                           %5.5 for unsheathed weather and cargo decks, 5.0 for accomodation decks and for wheater and cargo decks sheathed with wood or an approved composition.

                k_td = 0.00;                                                                            %0.01 for 'tween deck above 0.7 D in vessels with two continuous decks above 0.7 D from the baseline and first tier of superstructure or deckhouse in vessels with single continuous deck when more than 50% of 0.4 L amidships is covered 0.01 for forecastle decks forward of 0.2 L from F.P., 0 for other decks.
                
                t_td(i,1) = t00_td+((k_td*L1)/sqrt(f1));
              
                           
            end
        end
    end
end


%TWEEN DECK STIFFENERS (ID-number 16)%
for k=1:Csec_size/2
    
    %LONGITUDINAL STIFFENERS TWEEN DECK%
    if Strakes(1,21,k) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 16
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    
                    %The allowable stress in stiffener within 0.4*L midship
                    
                    sigma_tweendeckstf(i,j) = 225*f1-130*f2d;                                                           %allowable stress in stiffener within 0.4*L midship given in table C1, formula from C1 is shown in the given formula. 160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly.
         
                    if sigma_tweendeckstf(i,j) > 160*f1;
                       sigma_tweendeckstf(i,j) = 160*f1;
                    else sigma_tweendeckstf(i,j) = 225*f1-130*f2d;
                    end
                    
                    %sigma_tweendeckstf(i,j) = 160*f1;                    %Bruker 160*f1 siden dekket er vre del av tanken
                    
                    if sigma_tweendeckstf(i,j)<0
                       sigma_tweendeckstf_check = 1;
                    end
                    
                    
                    %BUCKLING CHECK OF TWEEN DECK LONGITUDINALS%
                    sigmael_stiff_td(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i)^2));       %[N/mm^2] %The formula given for sigmael is based on hinged ends and axial force only. If, in special cases, it is verified that one end can be regarded as fixed, the value of ? el may be multiplied by 2. If it is verified that both ends can be regarded as fixed, the value of sigmael may be multiplied by 4.

                    if zn(1,1)>=(Stiff_YZ(j,2)/100)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                    
                    %C 100 General 

                    if sigmael_stiff_td(i,j) < sigmaf/2; 
                        sigmac_stiff_td(i,j) = sigmael_stiff_td(j,1) ;
                    elseif sigmael_stiff_td(i,j) > sigmaf/2;
                        sigmac_stiff_td(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_td(i,j)))); 
                    end
                    
                    eta_stiff_td = 0.85;
                    
                    sigmael_stiff_td(i,j) = ((Ma)/(IN))*(zn(1,nn)-za_stiff(j,1))*(10^5);
                    
                    if sigmac_stiff_td(i,j) < (sigmael_stiff_td(i,j)/eta_stiff_td);
                        sigmac_stiff_td(i,j) = (sigmael_stiff_td(i,j)/eta_stiff_td);
                    elseif sigmac_stiff_td(i,j) >= (sigmael_stiff_td(i,j)/eta_stiff_td);
                        sigmac_stiff_td(i,j) = sigmac_stiff_td(i,j) ;
                    end
                
                
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_td(i,j) < sigma_tweendeckstf(i,j)
                        sigma(i,j) = sigmac_stiff_td(i,j);
                    else
                        sigma(i,j) = sigma_tweendeckstf(i,j);
                    end
                
                    
                    %Section modulus requirement in [cm^3] for longitudinal stiffener at strength deck.
                    Z_td(i,j) = 83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/(sigma(i,j));               
                    
                    
                    %The web and flange thickness shall not be less than the larger of:        
                    k_td = 0.01*L1 ;                                                                                        %in general, 0.015*L1 in peaks(extent is shown in Sec1.B) and for boundaries of cargo oil tanks and ballast tanks in cargo area. 0.5 for accomodation decks above strength deck.
                                                                                                                        %wk = corrosion factor, ignored in these claculations, so wk=1 
                    g_td = 41 ;                                                                                             %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles 
                
                    hw_td(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                                                    %web height in [mm]
                
                    t1_td(i,1) = 4.5 + k_td ;                                                                               % + tk, 
        
                    t2_td(i,1) = 1.5 + ((hw_td(i,1)*sqrt(f1))/(g_td)) ;                                                     % +tk 
        
                    if t1_td(i,1) < t2_td(i,1)
                        t0_td(i,1) = t2_td(i,1);
                    else
                       t0_td(i,1) = t1_td(i,1);
                    end
                end
            end
        end
        
    %TRANSVERSE STIFFENERS TWEEN DECK%
    elseif Strakes(1,21,k) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 16
                
                %The nominal allowable bending stress in N/mm2 due to lateral pressure
                sigma_tweendeck(i,1) = 175*f1-120*f2d;
                if sigma_tweendeck(i,1) > 120*f1;                                                         %Within 0.4*L, 160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                    sigma_tweendeck(i,1) = 120*f1;                                                        %Within 0.4*L,160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                else sigma_tweendeck(i,1) = 175*f1-120*f2d;                                               %Within 0.4*L,160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                end
                
                if sigma_tweendeck(i,1)<0
                    sigma_tweendeck_check = 1;
                end
                
                %BUCKLING CHECK OF TWEEN DECK STIFFENERS%
                eta_stiff_td = 0.85; 

                sigmael_stiff_td(i,1) = sigmaf ; 

                if sigmac_stiff_td(i,1) < (sigmael_stiff_td(i,1)/eta_stiff_td);
                    sigmac_stiff_td(i,1) = (sigmael_stiff_td(i,1)/eta_stiff_td);
                elseif sigmac_stiff_td(i,1) >= (sigmael_stiff_td(i,1)/eta_stiff_td);
                    sigmac_stiff_td(i,1) = sigmac_stiff_td(i,1);
                end
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_stiff_td(i,1) < sigma_tweendeck(i,1)
                    sigma(i,1) = sigmac_stiff_td(i,j);
                else
                    sigma(i,1) = sigma_tweendeck(i,1);
                end  
                
                
                %Section modulus requirement in [cm^3] for Transverse beams.
                Z_td(i,1) = 0.63*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/f1;
             
                if Z_td(i,1) < 15
                    Z_td(i,1) = 15; 
                else
                    Z_td(i,1) = 0.63*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/f1;
                end
            end
        end
    end
end
                

%TWEENDECKCHECKVALUES%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 16
        t_td_check(i,1) = (t_td(i,1)-Strakes(1,3,i)*10)./(t_td(i,1)+Strakes(1,3,i)*10);
    end
end


for i=1:Csec_size/2
    if Strakes(1,1,i) == 16
        for j = cum_sum(i,1)+1:cum_sum(i+1,1)
            Z_td_check(i,j) = (Z_td(i,j)-Strakes(1,23,i))./(Z_td(i,j)+Strakes(1,23,i));
        end
    end
end
 
 
for i=1:Csec_size/2
    if Strakes(1,1,i) == 16
        t0_td_check(i,1) = (t0_td(i,1)-Strakes(1,12,i)*20)./(t0_td(i,1)+Strakes(1,12,i)*20);
        t0_td_check1(i,1) = (t0_td(i,1)-Strakes(1,13,i)*10)./(t0_td(i,1)+Strakes(1,13,i)*10);
    end
end






%SEC.8. D.GIRDERS

%SIMPLE GIRDERS (ID-number 9,10 og 17)
for k=1:Csec_size/2
    
    %LONGITUDINAL GIRDERS%
    if Strakes(1,21,k) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 10 || Strakes(1,1,i) == 17
    
                %sigma_simplegirdersstrengthdeck = 190*f1-(130*f2d*((zn-za)/zn)); %allowable stress within 0.4 midships, 160*f1 within 0.1*L from perpediculars.

                %if sigma_simplegirdersstrengthdeck > 160*f1 ;
                %    sigma_simplegirdersstrengthdeck = 160*f1 ;
                %else sigma_simplegirdersstrengthdeck = 190*f1-(130*f2d*((zn-za)/zn));
                %end
                
                %b = loading breadth in [m]
                
                % The section modulus requirement for simple girders in [cm^3].
                %Z_gir = 100*(S^2)*b*p*wk/(sigma_simplegirdersstrengthdeck) ; 

                

                
                %The thickness of web plates, flanges, brackets and stiffeners of girders shall not be less than the thickness requirement t1 under 
                k_gir = 0.02*L1 ;                                                       %0.01*L1 in general, 0.02*L1 for girder webs, flanges and brackets in cargo oil tanks and ballast tanks in cargo area, 0.03*L(maximum 6.0) for girder webs, flanges and brackets in peaks. 

                t1_gir = 5.0+(k_gir/sqrt(f1));

                
                %The thickness of girder web plates is in addition not to be less than 
                t_gir(i,1) = 12*Strakes(1,4,i);                                             %+tk 
                
                
                if t1_gir < t_gir(i,1)
                    t_gir(i,1) = t_gir(i,1);
                else
                    t_gir(i,1) = t1_gir;
                end
                
                %The web area requirement in the end of the girders(after deduction of cut outs) shall not be less than
                %p =                                                                    %as given in D201 

                %b =                                                                    %as given in D201

                %h =                                                                    %girder height in m                
                
                
                %Aends = (0.07*S*b*p/(f1))+(10*h*tk); 

                
                %At midspan the girder area shall not be less than
                %Amidspan = Aends*0.5;
            end
        end
    
                
    %TRANSVERSE GIRDERS%
    elseif Strakes(1,21,k) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 10 || Strakes(1,1,i) == 17

    
                %Allowable stress for transverse girders.
        
                %sigma_simplegirdersstrengthdeck = 160*f1;                                
    
                
                % The section modulus requirement for simple girders in [cm^3]. 
                %b = loading breadth in [m]                 
                
                %Z_gir = 100*(S^2)*b*p*wk/(sigma_simplegirdersstrengthdeck) ;            

                
                %The thickness of web plates, flanges, brackets and stiffeners of girders shall not be less than the thickness requirement t1 under 
                k_gir = 0.02*L1 ;                                                       %0.01*L1 in general, 0.02*L1 for girder webs, flanges and brackets in cargo oil tanks and ballast tanks in cargo area, 0.03*L(maximum 6.0) for girder webs, flanges and brackets in peaks. 

                t1_gir = 5.0+(k_gir/sqrt(f1));

                
                %The thickness of girder web plates is in addition not to be less than 
                t_gir(i,1) = 12*Strakes(1,4,i);                                             %+tk 


                if t1_gir < t_gir(i,1)
                    t_gir(i,1) = t_gir(i,1);
                else
                    t_gir(i,1) = t1_gir;
                end
                
                %The web area requirement in the end of the girders(after deduction of cut outs) shall not be less than
                %p =                                                                    %as given in D201 

                %b =                                                                    %as given in D201

                %h =                                                                    %girder height in m                
                
                
                %Aends = (0.07*S*b*p/(f1))+(10*h*tk); 

                
                %At midspan the girder area shall not be less than
                %Amidspan = Aends*0.5 ;
            end
        end
    end
end



%GIRDER STIFFENERS (ID-number 9,10,17)%
for k=1:Csec_size/2
    
    %GIRDER LONGITUDINAL STIFFENERS%
    if Strakes(1,21,k) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 10 || Strakes(1,1,i) == 17
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    
                    if (Stiff_YZ(j,2)/100)<zn(1,1)
                        jj = f2b;
                        ii = 1;
                    else
                        jj = f2d;
                        ii = 2;
                    end
                    
                    %The allowable stress in stiffener within 0.4*L midship
                    sigma_gir(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));                                                           %allowable stress in stiffener within 0.4*L midship given in table C1, formula from C1 is shown in the given formula. 160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly.
         
                    if sigma_gir(i,j) > 160*f1;
                        sigma_gir(i,j) = 160*f1;
                    else sigma_gir(i,j) = 225*f1-130*jj;
                    end
                    
                    if sigma_gir(i,j)<0
                        sigma_gir_check = 1;
                    end
                    
                    
                    %BUCKLING CHECK OF STRENGTH DECK LONGITUDINALS%
                    sigmael_stiff_gir(i,j) = 0.001*E*(Ii_buckling(j,1)/(Ai_buckling(j,1)*Strakes(1,20,i)^2));       %[N/mm^2] %The formula given for sigmael is based on hinged ends and axial force only. If, in special cases, it is verified that one end can be regarded as fixed, the value of ? el may be multiplied by 2. If it is verified that both ends can be regarded as fixed, the value of sigmael may be multiplied by 4.

                    if zn(1,1)>=(Stiff_YZ(j,2)/100)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end
                    
                    %C 100 General 

                    if sigmael_stiff_gir(i,j) < sigmaf/2; 
                        sigmac_stiff_gir(i,j) = sigmael_stiff_gir(j,1) ;
                    elseif sigmael_stiff_gir(i,j) > sigmaf/2;
                        sigmac_stiff_gir(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_gir(i,j)))); 
                    end
                    
                    eta_stiff_gir = 0.85;
                    
                    sigma_a_stiff_gir(i,j) = ((Ma)/(IN))*(zn(1,nn)-za_stiff(j,1))*(10^5);
                    
                    if sigmac_stiff_gir(i,j) < (sigma_a_stiff_gir(i,j)/eta_stiff_gir);
                        sigmac_stiff_gir(i,j) = (sigma_a_stiff_gir(i,j)/eta_stiff_gir);
                    elseif sigmac_stiff_gir(i,j) >= (sigma_a_stiff_gir(i,j)/eta_stiff_gir);
                        sigmac_stiff_gir(i,j) = sigmac_stiff_gir(i,j) ;
                    end
                
                
                    %Evaluating between stress due to lateral pressure and buckling stress.
                    if sigmac_stiff_gir(i,j) < sigma_gir(i,j)
                        sigma(i,j) = sigmac_stiff_gir(i,j);
                    else
                        sigma(i,j) = sigma_gir(i,j);
                    end
                    
                    
                    %Section modulus requirement in [cm^3] for longitudinal stiffener at strength deck.
                    Z_gir(i,j) = 83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/(sigma(i,j));
                    
                    
                    %The web and flange thickness shall not be less than the larger of: 
                    k_gir = 0.01*L1 ;                                                                                        %in general, 0.015*L1 in peaks(extent is shown in Sec1.B) and for boundaries of cargo oil tanks and ballast tanks in cargo area. 0.5 for accomodation decks above strength deck.
                                                                                                                        %wk = corrosion factor, ignored in these claculations, so wk=1 
                    g_gir = 41 ;                                                                                             %75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles 
                
                    hw_gir(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                                                    %web height in [mm]
                
                    t1_gir(i,1) = 4.5 + k_gir ;                                                                               % + tk, 
        
                    t2_gir(i,1) = 1.5 + ((hw_gir(i,1)*sqrt(f1))/(g_gir)) ;                                                     % +tk 
        
                    if t1_gir(i,1) < t2_gir(i,1)
                        t0_gir(i,1) = t2_gir(i,1);
                    else
                       t0_gir(i,1) = t1_gir(i,1);
                    end
                end
            end
        end
        
    %GIRDER TRANSVERSE STIFFENERS%
    elseif Strakes(1,21,k) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 10 || Strakes(1,1,i) == 17
                
                
                %The nominal allowable bending stress in N/mm2 due to lateral pressure
                sigma_gir(i,1) = 175*f1-120*f2d;
                if sigma_gir(i,1) > 120*f1;                                                         %Within 0.4*L, 160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                    sigma_gir(i,1) = 120*f1;                                                        %Within 0.4*L,160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                else sigma_gir(i,1) = 175*f1-120*f2d;                                               %Within 0.4*L,160*f1 within 0.1*L from the perpendiculars and within line of large deck openings, Between specified regions the sigma-value may be varied linerarly. 
                end
                
                if sigma_gir(i,1)<0
                    sigma_gir_check = 1;
                end
                
                %BUCKLING CHECK OF GIRDER STIFFENERS%
                eta_stiff_gir = 0.85; 

                sigma_a_stiff_gir(i,1) = sigmaf ; 

                if sigmac_stiff_gir(i,1) < (sigma_a_stiff_gir(i,1)/eta_stiff_gir);
                    sigmac_stiff_gir(i,1) = (sigma_a_stiff_gir(i,1)/eta_stiff_gir);
                elseif sigmac_stiff_gir(i,1) >= (sigma_a_stiff_gir(i,1)/eta_stiff_gir);
                    sigmac_stiff_gir(i,1) = sigmac_stiff_gir(i,1);
                end
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_stiff_gir(i,1) < sigma_gir(i,1)
                    sigma(i,1) = sigmac_stiff_gir(i,j);
                else
                    sigma(i,1) = sigma_gir(i,1);
                end  
                
                
                %Section modulus requirement in [cm^3] for Transverse beams.
                Z_gir(i,1) = 0.63*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/f1;
             
                if Z_gir(i,1) < 15
                    Z_gir(i,1) = 15; 
                else
                    Z_gir(i,1) = 0.63*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk/f1;
                end                
            end
        end
    end
end


%StringerCHECKVALUES%
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 10 || Strakes(1,1,i) == 17
        t_gir_check(i,1) = (t_gir(i,1)-Strakes(1,3,i)*10)./(t_gir(i,1)+Strakes(1,3,i)*10);
    end
end


for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 10 || Strakes(1,1,i) == 17
        for j = cum_sum(i,1)+1:cum_sum(i+1,1)
            Z_gir_check(i,j) = (Z_gir(i,j)-Strakes(1,23,i))./(Z_gir(i,j)+Strakes(1,23,i));
        end
    end
end
 
 
for i=1:Csec_size/2
    if Strakes(1,1,i) == 9 || Strakes(1,1,i) == 10 || Strakes(1,1,i) == 17
        t0_gir_check(i,1) = (t0_gir(i,1)-Strakes(1,12,i)*20)./(t0_gir(i,1)+Strakes(1,12,i)*20);
        t0_gir_check1(i,1) = (t0_gir(i,1)-Strakes(1,13,i)*10)./(t0_gir(i,1)+Strakes(1,13,i)*10);
    end
end






%C306 Thickness of bilge plate.

%The requirement for the bilge plate will be that the thickness of the bilge plate shall not be less than the largest thickness of the adjacent bottom and side plates. 
for i=1:Csec_size/2
    if Strakes(1,1,i) == 0 || Strakes(1,1,i) == 0 || Strakes(1,1,i) == 0
        if t_btm(2,1) > t_side(8,1)                                     %i must be chosen as the same number as the plate
            t_btm(3,1) = t_btm(2,1);
        else t_btm(3,1) = t_side(8,1);
        end
    end
end

%C200 section 7. Sheer strake at strength deck
for i=1:Csec_size/2
    if Strakes(1,1,i) == 0 || Strakes(1,1,i) == 0 || Strakes(1,1,i) == 0
        t1 = t_side(9,1);

        if t_sd(11,1) < t_side(9,1);                                    %i must be chosen as the same number as the plate
            t2 = t_side(9,1);
        else
            t2 = t_sd(11,1);
        end
        
        %The thickness shall not be less than
        t_side(10,1) = ((t1 + t2)/2);
    end
end



% Pt.3 Ch.1 Sec.9 BULKHEAD STRUCTURES 
 

%C 100 BULKHEAD PLATING, ID-number  

for j = 1:Csec_size/2
    if Strakes(1,21,j) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) ==  0 || Strakes(1,1,i) ==  0
                sigma_bulkheadpl(i,1) = 160*f1;                 %160*f1 for longitudinally stiffened longitudinal bulkhead plating at neutral axis irrespective of ship length
                                                                %140 f1 for transversely stiffened longitudinal bulkhead plating at neutral axis within 0.4 L amidships, may however be taken as 160 f1 when p6 or p7 are used.
                                                                %Above and below the neutral axis the ?-values shall be reduced linearly to the values for the deck and bottom plating, assuming the same stiffening direction and material factor as for the plating considered
                                                                %160 f1 for longitudinal bulkheads outside 0.05 L from F.P. and 0.1 L from A.P. and for transverse bulkheads in general
                                                                %220 f1 for watertight bulkheads except the collision bulkhead, when p1 is applied.
                                                                %Between specified regions the ?-value may be varied linearly.

                                                                
                %BUCKLING CHECK OF LONGITUDINALY STIFFENED STRENGTH DECK PLATING%
                if zn(1,1)>=za_plate(i,1)
                    Ma = Msh+Mwh;
                    nn = 1;
                else
                    Ma = abs(Mss+Mws);
                    nn = 2;
                end 
                
                eta_bh = 1.0;
                
                psi_bh = 1.0;                                                              % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.

                k_bh = 8.4/(psi_bh+1.1);

                 
                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                else
                    short(i,1) = Strakes(1,4,i);
                end                
                
                %The ideal elastic buckling stress may be taken as
                sigmael_bh(i,1) = 0.9*k_bh*E*((Strakes(1,3,i)*10/(1000*short(i,1)))^2);   %[N/mm^2] Vist oss ombestemme oss for  ta med korrosjonstillegget so skal det ver med i denne formelen her, sj side 157 i pt.3 ch.1.  

                if sigmael_bh(i,1) < sigmaf/2; 
                    sigmac_bh(i,1) = sigmael_bh(i,1) ;
                elseif sigmael_bh(i,1) > sigmaf/2;
                    sigmac_bh(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_bh(i,1))));
                end
                

                sigma_a_bh(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5); 

                if sigma_a_bh(i,1) < 30*f1;
                    sigma_a_bh(i,1) = 30*f1 ;
                elseif sigma_a_bh(i,1) >= 30*f1; 
                    sigma_a_bh(i,1) = sigma_a_bh(i,1);
                end
                
                
                %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows:                
                if sigmac_bh(i,1) < (sigma_a_bh(i,1)/eta_bh)
                    sigmac_bh(i,1) = (sigma_a_bh(i,1)/eta_bh);
                elseif sigmac_bh(i,1) >= (sigma_a_bh(i,1)/eta_bh)
                    sigmac_bh(i,1) = sigmac_bh(i,1);
                end 
                
                
                %Evaluating between stress due to lateral pressure and buckling stress.
                if sigmac_bh(i,1) < sigma_bulkheadpl(i,1)
                    sigma(i,1) = sigmac_bh(i,1);
                else
                    sigma(i,1) = sigma_bulkheadpl(i,1);
                end  
                
                
                %The correction factor for aspect ratio of plate field
                if (Strakes(1,4,i)/Strakes(1,20,i)) <=  0.4;
                    ka_bh(i,1) = 1;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>= 1.0
                    ka_bh(i,1) = 0.72;
                elseif (Strakes(1,4,i)/Strakes(1,20,i))>0.4 && (Strakes(1,4,i)/Strakes(1,20,i))<1;
                    ka_bh(i,1) = (1.1-0.25*(Strakes(1,4,i)./Strakes(1,20,i)))^2;
                end
                
                
                %Thickness requirement corresponding to lateral pressure
                t_bh(i,1) = 15.8*ka_bh(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)) ;         %[mm] 


                %The thickness shall not be less than:
                k_bh = 0.01;                                                                                % = 0.03 for longitudinal bulkheads except double skin bulkheads in way of cargo oil tanks and ballast tanks in liquid cargo tank areas
                                                                                                            % = 0.02 in peak tanks and for transverse and double skin longitudinal bulkheads in way of cargo oil tanks and ballast tanks in liquid cargo tank areas                                                                                            % = 0.01 for other bulkheads.
                         
                if t_bh(i,1) < 5.0+(k_bh*L1/(sqrt(f1)));                                                    %+tk
                   t_bh(i,1) = 5.0+(k_bh*L1/(sqrt(f1)));                                                    %+tk
                else
                    t_bh(i,1) = 15.8*ka_bh(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1));
                end

                
                %Longitudinal bulkheads within the cargo area shall not have a thickness less than:
                if t_bh(i,1) < (1000*Strakes(1,4,i))/(120-(3*sqrt(L1))) ;                                   %+tk
                    t_bh(i,1) =  (1000*Strakes(1,4,i))/(120-(3*sqrt(L1))) ;                                 %+tk
                else
                    t_bh(i,1) = 15.8*ka_bh(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1));
                end
            end
        end
        
        
    elseif Strakes(1,21,j) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) ==  0 || Strakes(1,1,i) ==  0
                sigma_bulkheadpl(i,1) = 160*f1;                                                                 %Between specified regions the ?-value may be varied linearly.                                                    %Above and below the neutral axis the ?-values shall be reduced linearly to the values for the deck and bottom plating, assuming the same stiffening direction and material factor as for the plating considered
                                                                                                                %160 f1 for longitudinal bulkheads outside 0.05 L from F.P. and 0.1 L from A.P. and for transverse bulkheads in general
                                                                                                                %220 f1 for watertight bulkheads except the collision bulkhead, when p1 is applied.
                
                                                                                                    
                %BUCKLING CHECK OF TRANSVERSLY STIFFENED STRENGTH DECK PLATING%
                if zn(1,1)>=za_plate(i,1)
                    Ma = Msh+Mwh;
                    nn = 1;
                else
                    Ma = abs(Mss+Mws);
                    nn = 2;
                end                
                
                psi_bh = 1;                                                                                     % 0<=psi<=1 psi is the ratio between the smaller and the larger compressive stress assuming linerar variation, see Fig.1.
                
                eta_bh = 0.9 ;

                c_bh = 1.1 ;                                                                                    %=1.21 when stiffeners are angles or T-sections 
                                                                                                                %= 1.10 when stiffeners are bulb flats
                                                                                                                %= 1.05 when stiffeners are flat bars
                                                                                                                %= 1.3 when the plating is supported by floors or deep girders.

                if Strakes(1,20,i)<Strakes(1,4,i)
                    short(i,1) = Strakes(1,20,i);
                    long(i,1) = Strakes(1,4,i);
                else
                    short(i,1) = Strakes(1,4,i);
                    long(i,1) = Strakes(1,20,i);
                end                                                                                                               
                                                                                                                
                k_bh(i,1) = c_bh*((1+((short(i,1)/long(i,1)).^2)).^2)*(2.1/(psi_bh+1.1)); 

                
                %The ideal elastic buckling stress may be taken as 
                sigmael_bh(i,1) = 0.9*k_bh(i,1)*E*((Strakes(1,3,i)*10/(1000*short(i,1))).^2);               %[N/mm^2] Vist oss ombestemme oss for  ta med korrosjonstillegget so skal det ver med i denne formelen her, sj side 157 i pt.3 ch.1.  

                if sigmael_bh(i,1) < sigmaf/2;
                    sigmac_bh(i,1) = sigmael_bh(i,1);
                elseif sigmael_bh(i,1) > sigmaf/2;
                    sigmac_bh(i,1) = sigmaf*(1-((sigmaf)/(4*sigmael_bh(i,1))));
                end
                
                
                %The calculated compressive stress in plate panels
                sigma_a_bh(i,1) = ((Ma)/(IN))*(zn(1,nn)-za_plate(i,1))*(10^5);
                
                if sigma_a_bh(i,1) < 30*f1;
                    sigma_a_bh(i,1) = 30*f1;
                elseif sigma_a_bh(i,1) >= 30*f1;
                    sigma_a_bh(i,1) = ((Msh+Mwh)/(IN))*(zn-za)*(10^5);
                end
                
                
                %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows
                if sigmac_bh(i,1) < (sigma_a_bh(i,1)/eta_bh);
                    sigmac_bh(i,1) = (sigma_a_bh(i,1)/eta_bh);
                elseif sigmac_bh(i,1) >= (sigma_a_bh(i,1)/eta_bh);
                    sigmac_bh(i,1) = sigmac_bh(i,1);
                end
                
                
                if sigmac_bh(i,1) < sigma_bulkheadpl(i,1)
                    sigma(i,1) = sigmac_stiff_bh(i,j);
                else
                    sigma(i,1) = sigma_bulkheadpl(i,1);
                end                                                                                         
             
                %Thickness requirement corresponding to lateral pressure                                                                            
                t_bh(i,1) = 15.8*ka_bh(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)) ;         %[mm] 

               
                %The thickness shall not be less than:
                k_bh = 0.03;                                                                                %= 0.03 for longitudinal bulkheads except double skin bulkheads in way of cargo oil tanks and ballast tanks in liquid cargo tank areas%
                                                                                                            %= 0.02 in peak tanks and for transverse and double skin longitudinal bulkheads in way of cargo oil tanks and ballast tanks in liquid cargo tank areas%
                                                                                                            %= 0.01 for other bulkheads.%
                
                if t_bh(i,1) < 5.0+(k_bh*L1/(sqrt(f1)));                                                    %+tk
                    t_bh(i,1) = 5.0+(k_bh*L1/(sqrt(f1)));                                                   %+tk
                else t_bh(i,1) = 15.8*ka_bh(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1));
                end
                
                
                %Longitudinal bulkheads within the cargo area shall not have a thickness less than:
                if t_bh(i,1) < (1000*Strakes(1,4,i))/(120-(3*sqrt(L1))) ;                                   %+tk
                    t_bh(i,1) =  (1000*Strakes(1,4,i))/(120-(3*sqrt(L1))) ;                                 %+tk 
                else t_bh(i,1) = 15.8*ka_bh(i,1)*Strakes(1,4,i)*sqrt(Strakes(1,22,i))/sqrt(sigma(i,1)); 
                end 
            end
        end
    end
end


%C200 Longitudinals on bulkheads
for k = 1:Csec_size/2
    if Strakes(1,21,k) == 0;

        for i=1:Csec_size/2
            if Strakes(1,1,i) ==  0 || Strakes(1,1,i) ==  0
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    if (Stiff_YZ(j,2)/100)<zn(1,1)
                        ii = 1;
                        jj = f2b;
                    else
                        ii = 2;
                        jj = f2d;
                    end
                    
                    % Allowable stress within 0.4*L midhsips%
                    sigma_lotbulkheads(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));                    %Allowable stress within 0.4*L midhsips, 160*f1 within 0.1*L from perpendiculars.

                    if sigma_lotbulkheads(i,j) > 160*f1;
                        sigma_lotbulkheads(i,j) = 160*f1;
                    else sigma_lotbulkheads(i,j) = 225*f1-130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii));
                    end
                    
                    if (Stiff_YZ(j,2)/100)>zn(1,1)                              %Slushing krav, side 130 i regelverket
                        sigma_lotbulkheads(i,j) = 160*f1;
                    end
                        
                    sigma_lotbulkheads(1,1)=0;
                    
                    if sigma_lotbulkheads(i,j)<0
                        sigma_lotbulkheads_check = 1;
                    end
                    
                    %BUCKLINGCHECK%
                    if zn(1,1) >= (Stiff_YZ(j,2)/100)
                        Ma = Msh+Mwh;
                        nn = 1;
                    else
                        Ma = abs(Mss+Mws);
                        nn = 2;
                    end

                    sigmael_stiff_bh(i,j) = (0.001*E*Ii_buckling(j,1))/(Ai_buckling(j,1)*Strakes(1,20,i)^2);   %[N/mm^2]
 

                    if sigmael_stiff_bh(i,j) < sigmaf/2;
                        sigmac_stiff_bh(i,j) = sigmael_stiff_bh(i,j) ;
                    elseif sigmael_stiff_bh(i,j) > sigmaf/2;
                        sigmac_stiff_bh(i,j) = sigmaf*(1-((sigmaf)/(4*sigmael_stiff_bh(i,j))));
                    end
                    
                    
                    eta_stiff_bh = 0.85;

                    sigma_a_stiff_bh(i,j) = ((Ma)/(IN))*(zn(1,nn)-za_stiff(j,1))*(10^5);                     

                    
                    %The critical buckling stress calculated in 201 shall be related to the actual compressive stresses as follows:
                    if sigmac_stiff_bh(i,j) < (sigma_a_stiff_bh(i,j)/eta_stiff_bh);
                        sigmac_stiff_bh(i,j) = (sigma_a_stiff_bh(i,j)/eta_stiff_bh);
                    elseif sigmac_stiff_bh(i,j) >= (sigma_a_stiff_bh(i,j)/eta_stiff_bh);
                        sigmac_stiff_bh(i,j) = sigmac_stiff_bh(i,j);
                    end 
                    
                    if sigmac_stiff_bh(i,j) < sigma_lotbulkheads(i,j)
                        sigma(i,j) = sigmac_stiff_bh(i,j);
                    else
                        sigma(i,j) = sigma_lotbulkheads(i,j);
                    end
                    
                    %Section modulus requirement for stiffeners and corrugations is given by.
                    Z_bh(i,j) = (83*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma(i,j)); 
            
                    k_bh = 0.01*L1;                                                                                 %k_bh = 0.01*L1 in general, 0.015*L1 in peaks(extent is shown in Sec1.B) and for boundaries of cargo oil tanks and ballast tanks in cargo area. 0.5 for accomodation decks above strength deck.  
   
                    g_bh = 41;                                                                                      %g_bh = 75 for flanged profile webs, 41 for bulb profiles, 22 for flat bar profiles 
            
                    hw_bh(i,1) = (Strakes(1,11,i)-Strakes(1,12,i)*2)*10;                                            %web height in [mm]
            
                    t1_bh(i,1) = 4.5 + k_bh ;                                                                       % + tk, 
   
                    t2_bh(i,1) = 1.5 + ((hw_bh(i,1)*sqrt(f1))/(g_bh));                                              % +tk
            
                    if t1_bh(i,1) < t2_bh(i,1)
                        t0_bh(i,1) = t2_bh(i,1);
                    else
                        t0_bh(i,1) = t1_bh(i,1);
                    end
                end
            end
        end
    
    %C300 VERTICAL AND TRANSVERSE STIFFNERS ON TANK, WASH, DRY BULK CARGO, COLLISION AND WATERTIGHT BULKHEADS
    elseif Strakes(1,21,k) == 1;
        for i=1:Csec_size/2
            if Strakes(1,1,i) ==  0 || Strakes(1,1,i) ==  0

                sigma_trvbulkheads = 220*f1 ;                           %= 160*f1 for tank, cargo and collision bulkheads (see also 105)
                                                                        %= 220*f1 for watertight bulkheads (see also 105)
                        
                m = 10;                                                 %= 7.5 for vertical stiffeners simply supported at one or both ends
                                                                        %= 10 for transverse stiffeners and vertical stiffeners which may be considered fixed at both ends
           
                %BUCKLINGCHECKFORTRANSEVERSESTIFFENERS%
                eta_stiff_bh = 0.85;

                sigma_a_stiff_bh(i,1) = sigmaf ;
                       
                if sigmac_stiff_bh(i,1) < (sigma_a_stiff_bh(i,1)/eta_stiff_bh);
                    sigmac_stiff_bh(i,1) = (sigma_a_stiff_bh(i,1)/eta_stiff_bh);
                elseif sigmac_stiff_bh(i,1) >= (sigma_a_stiff_bh(i,1)/eta_stiff_bh);
                    sigmac_stiff_bh(i,1) = sigmac_stiff_bh(i,1) ;
                end
                
                Z_bh(i,1) = ((1000*(Strakes(1,20,i).^2)*Strakes(1,4,i)*Strakes(1,22,i)*wk)/(sigma_trvbulkheads*m));
            end
        end
    end
end


for i=1:Csec_size/2
    if Strakes(1,1,i) ==  0 || Strakes(1,1,i) ==  0
        t_bh_check(i,1) = (t_bh(i,1)-Strakes(1,3,i)*10)./(t_bh(i,1)+Strakes(1,3,i)*10);
    end
end

 for i=1:Csec_size/2
     for j = cum_sum(i,1)+1:cum_sum(i+1,1)
         if Strakes(1,1,i) ==  0 || Strakes(1,1,i) ==  0
             Z_bh_check(i,j) = (Z_bh(i,j)-Strakes(1,23,i))./(Z_bh(i,j)+Strakes(1,23,i));
             t0_bh_check(i,1) = (t0_bh(i,1)-Strakes(1,12,i)*20)./(t0_bh(i,1)+Strakes(1,12,i)*20);
             t0_bh_check1(i,1) = (t0_bh(i,1)-Strakes(1,13,i)*10)./(t0_bh(i,1)+Strakes(1,13,i)*10);
         end
     end
 end
%{
t_keel_check(t_keel==0)=[];
Z_bl_check(Z_bl==0)=[];
Z_bl(Z_bl==0)=[];
Z_bilge_check(Z_bilge==0)=[];
Z_bilge(Z_bilge==0)=[];
t0_bilge_check(t0_bilge==0)=[]; 
t0_bilge_check1(t0_bilge==0)=[];
t0_bilge(t0_bilge==0)=[];
t0_bl_check(t0_bl==0)=[]; 
t0_bl_check1(t0_bl==0)=[];
t0_bl(t0_bl==0)=[]; 


 t0_bh_check(t0_bh==0)=[];
t0_bh_check1(t0_bh==0)=[];
t0_bh(t0_bh==0)=[]; 

t_bh_check(t_bh==0)=[];
t_bh(t_bh==0)=[];
Z_bh_check(Z_bh==0)=[];
Z_bh(Z_bh==0)=[];
%}
t0_gir_check(t0_gir==0)=[];
t0_gir_check1(t0_gir==0)=[];
t0_gir(t0_gir==0)=[]; 
t_gir_check(t_gir==0)=[];
t_gir(t_gir==0)=[];
Z_gir_check(Z_gir==0)=[];
Z_gir(Z_gir==0)=[];

%{
t_btm_check(t_btm==0)=[];
t_btm(t_btm==0)=[];
%}

t_side_check(t_side==0)=[];
t_side(t_side==0)=[];

t0_sd_check(t0_sd==0)=[];
t0_sd_check1(t0_sd==0)=[];
t0_sd(t0_sd==0)=[]; 
t_sd_check(t_sd==0)=[];
t_sd(t_sd==0)=[];
Z_sd_check(Z_sd==0)=[];
Z_sd(Z_sd==0)=[];

t0_td_check(t0_td==0)=[];
t0_td_check1(t0_td==0)=[];
t0_td(t0_td==0)=[]; 
t_td_check(t_td==0)=[];
t_td(t_td==0)=[];
Z_td_check(Z_td==0)=[];
Z_td(Z_td==0)=[];


% D. GIRDERS ON BULKHEADS, ID-number X 

% D 100 GENERAL 

for j = 1:Csec_size/2
    if Strakes(1,21,j) == 0;
        for i=1:Csec_size/2
            if Strakes(1,1,i) == 0
                for j = cum_sum(i,1)+1:cum_sum(i+1,1)
                    if (Stiff_YZ(j,2)/100)<zn(1,1)
                        ii = 1;
                        jj = f2b;
                    else
                        ii = 2;
                        jj = f2d;
                    end
                    
                    sigma_simplegirdersbulkhead = 190*f1-(130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii)));          %allowable stress within 0.4 midships, 160*f1 within 0.1*L from perpediculars.
                                                                                                                % The allowable stress may be increased by 60 f1 (40 f1 for longitudinal girders within 0.4 L amidships) for watertight bulkheads, except the collision bulkhead, when p1 is applied.
                                                                                                                % Between specified regions the ?-value may be varied linearly. For longitudinal girders ? = 160 f1 may be used in any case in combination with heeled condition pressures p6 and p7.

                    if sigma_simplegirdersbulkhead > 160*f1;
                        sigma_simplegirdersbulkhead = 160*f1;
                    else sigma_simplegirdersbulkhead = 190*f1-(130*jj*((zn(1,ii)-za_stiff(j,1))/zn(1,ii)));
                    end
                    
                    sigma_simplegirdersbulkhead(1,1)=0;
                    
                    if sigma_simplegirdersbulkhead(i,j)<0
                        sigma_simplegirdersbulkhead_check = 1;
                    end
                    

                    %b = loading breadth in [m] 
             
                    %The section modulus requirement for simple girders in [cm^3]. 
                    Z_gbh = 100*(S^2)*b*Strakes(1,22,i)*wk/(sigma_simplegirdersbulkhead);
                
                    
                    %The web area requirement in the end of the girders(after deduction of cut outs) shall not be less than

                    k_str = 0.06;                               %= 0.06 for stringers and upper end of vertical girders
                                                    %= 0.08 for lower end of vertical girders
        
                    c = 1.0;                                    %= 0.75 for watertight bulkheads, except the collision bulkhead, when p1 is applied
                                                    %= 1.0 in all other cases
                    %p =                                         %as given in D201 

                    %b =                                         %as given in D201

                    %h =                                         %girder height in m 
                                                   
                    Aends = (c*k_str*S*b*p/(f1))+(10*h*tk); 


                    %At midspan the girder area shall not be less than 
                    Amidspan = Aends*0.5 ;                
                end
            end
        end
        
    elseif Strakes(1,21,j) == 1;
    
        %Allowable stress for transverse girders.
        sigma_simplegirdersbulkhead = 160*f1;                                   %Between specified regions the ?-value may be varied linearly. For longitudinal girders ? = 160 f1 may be used in any case in combination with heeled condition pressures p6 and p7.                                 
    
        %b = loading breadth in [m]    
    
        %The section modulus requirement for simple girders in [cm^3]
        Z_gbh = 100*(S^2)*b*Strakes(1,22,i)*wk/(sigma_simplegirdersbulkhead);
          
    
        %The web area requirement in the end of the girders(after deduction of cut outs) shall not be less than

        k_str = 0.06;                               %= 0.06 for stringers and upper end of vertical girders
                                                    %= 0.08 for lower end of vertical girders
        
        c = 1.0;                                    %= 0.75 for watertight bulkheads, except the collision bulkhead, when p1 is applied
                                                    %= 1.0 in all other cases
        %p =                                         %as given in D201 

        %b =                                         %as given in D201

        %h =                                         %girder height in m 
                                                   
        Aends = (c*k_str*S*b*p/(f1))+(10*h*tk); 


        %At midspan the girder area shall not be less than 
        Amidspan = Aends*0.5 ;
    end
end

sigma(sigma==0)=[];


%Strength deck girder (Transverse) 

% k = 0.02*L1; %0.01*L1 in general; 0.02*L1 for girder webs, flanges and brackets in cargo oil tanks and ballast tanks in cargo area; 0.03*L1 for girder webs, flanges and brakcets in peaks. 
% 
% t_girweb_rule(i,1) = 5.0+(k/sqrt(f1)) ;%+ tk   
% 
% if t_girweb_rule(i,1) < 12*Strakes(1,4,i); % + tk, Here is it assumed that the stiffener spacing is the same as the stiffening of the web. 
%    t_girweb_rule(i,1) = 12*Strakes(1,4,i);
% else 
%     t_girweb_rule(i,1) = 5.0+(k/sqrt(f1));
% end 
% 
% 
% t_girflange_rule(i,1) = 5.0+(k/sqrt(f1)) ;%+ tk 
% 
% sigma_gir_sd = 160*f1; % 190*f1-130*f2d*(zn-za/zn), maximum 160*f1 for continuous longitudinal girders within 0.4 L amidships; 160 f1 for transverse girders and longitudinal girders within 0.1 L from perpendiculars; Between specified regions the ?-value may be varied linearly. For longitudinal girders ? = 160 f1 may be used in any case in combination with heeled condition pressures p9 and p11.
% 
% 
% Z_gir_sd(i,1) = 100*((Strakes(1,2,i)/100)*Strakes(1,20,i)*Strakes(1,22,i)*wk/(sigma_gir_sd)) ; %antatt at Csec_width er i [cm] og m omregnast til [m], antatt at loading breadth er lik stiverlengden. 
% 
% A_gir_sd(i,1) = (0.07*((Strakes(1,2,i)/100)*Strakes(1,20,i)*Strakes(1,22,i))/(f1)); % +10*h*tk Web area requirement (after deduction of cut outs) at the girder ends is given by.  
%  
% 
% A_gir_sd_check(i,1) =  A_gir_sd(i,1) - (t_girweb*h_girweb)/A_gir_sd(i,1)+(t_girweb*h_girweb);
% 
% Z_gir_sd_check(i,1) =  Z_gir_sd(i,1) - Z_gir(i,1)/Z_gir_sd(i,1) + Z_gir(i,1); 
% 
% t_girweb_sd_check(i,1) = (t_girweb_sd(i,1)-(t_girweb(i,1)*10))./(t_girweb_sd(i,1)+(t_girweb(i,1)*10));
% 
% t_girflange_sd_check(i,1) = (t_girflange_sd(i,1)-(t_girflange(i,1)*10))./(t_girflange_sd(i,1)+(t_girflange(i,1)*10));
% 
% 
% A_gir_sd_check(A_gir_sd==0)=[];
% A_gir_sd(A_gir_sd==0)=[];
% 
% Z_gir_sd_check(Z_gir_sd==0)=[];
% Z_gir_sd(Z_gir_sd==0)=[];
% 
% t_girweb_sd_check(t_girweb_sd==0)=[];
% t_girweb_sd(t_girweb_sd==0)=[];
% 
% t_girflange_sd_check(t_girflange_sd==0)=[];
% t_girflange_sd(t_girflange_sd==0)=[];
% 
% 
% 
% 
%Bulkhead girder (Transverse)
%Girders = [1(Webframe ID) 2(Web height) 3(Web thickness) 4(Section modulus) 5(Flange thickness) 6(Web area) 7(Girder span)]

k_web_gir = 0.02*L1; %0.01*L1 in general; 0.02*L1 for girder webs, flanges and brackets in cargo oil tanks and ballast tanks in cargo area; 0.03*L1 for girder webs, flanges and brakcets in peaks. 
sigma_gir_bh = 160*f1; % 190*f1-130*f2*(zn-za/zn), minimum 160*f1 for continuous longitudinal girders within 0.4 L amidships; 160 f1 for transverse girders and longitudinal girders within 0.1 L from perpendiculars; Between specified regions the ?-value may be varied linearly. For longitudinal girders ? = 160 f1 may be used in any case in combination with heeled condition pressures p9 and p11.

for i=1:size(Webframe_ID,1)
    if Webframe_ID(i,1) == 1 || Webframe_ID(i,1) == 2 || Webframe_ID(i,1) == 3 || Webframe_ID(i,1) == 4
        for j=1:size(Girders,3)
        for k=1:Csec_size/2
            t_girweb_bh(j,k) = 5.0+(k_web_gir/sqrt(f1)); %+ tk
        end
    end 
    end
end

for k=1:Csec_size/2

for i=1:size(Webframe_ID,1)
    
    if Webframe_YZ_start(i,2) == Webframe_YZ_end(i,2) && (Webframe_YZ_start(i,2) == 0 || Webframe_YZ_start(i,2) == D*100)
       %{
        if Webframe_ID(i,1) == 1
            for j=1:size(Girders,3)
                if Girders(1,1,j) == 1
                    if t_girweb_bh(j,k) < 12*Strakes(1,4,k); %+ tk, Here is it assumed that the stiffener spacing is the same as the stiffening of the web
                        t_girweb_bh(j,k) = 12*Strakes(1,4,k);
                    else
                        t_girweb_bh(j,k) = 5.0+(k_web_gir/sqrt(f1));
                    end
                    Z_gir_bh(j,1) = 100*(((Girders(1,7,j)/100)^2)*Strakes(1,20,1)*Strakes(1,22,k)*wk/(sigma_gir_bh)) ; %antatt at Csec_width er i [cm] og m omregnast til [m], antatt at loading breadth er lik stiverlengden.

                    A_gir_bh(j,1) = (0.07*((Girders(1,7,j)/100)*Strakes(1,20,1)*Strakes(1,22,k))/(f1)); % +10*h*tk Web area requirement (after deduction of cut outs) at the girder ends is given by.  
                end
            end
            %}
    %{
        elseif Webframe_ID(i,1) == 2
            for j=1:size(Girders,3)
                if Girders(1,1,j) == 2
                    if t_girweb_bh(j,k) < 12*Strakes(1,4,k); %+ tk, Here is it assumed that the stiffener spacing is the same as the stiffening of the web
                        t_girweb_bh(j,k) = 12*Strakes(1,4,k);
                    else
                        t_girweb_bh(j,k) = 5.0+(k_web_gir/sqrt(f1));
                    end
                end
            end
        end
        %}
    %{
    elseif Webframe_YZ_start(i,1) == Webframe_YZ_end(i,1) && Webframe_YZ_start(i,1) == B/2*100
                if Webframe_ID(i,1) == 3
                    for j=1:size(Girders,3)
                        if Girders(1,1,j) == 3
                            if t_girweb_bh(j,k) < 12*Strakes(1,4,k); %+ tk, Here is it assumed that the stiffener spacing is the same as the stiffening of the web
                                t_girweb_bh(j,k) = 12*Strakes(1,4,k);
                            else
                                t_girweb_bh(j,k) = 5.0+(k_web_gir/sqrt(f1));
                            end
                            Z_gir_bh(j,1) = 100*(((Girders(1,7,j)/100)^2)*Strakes(1,20,1)*Strakes(1,22,k)*wk/(sigma_gir_bh)) ; %antatt at Csec_width er i [cm] og m omregnast til [m], antatt at loading breadth er lik stiverlengden.

                            A_gir_bh(j,1) = (0.07*((Girders(1,7,j)/100)*Strakes(1,20,1)*Strakes(1,22,k))/(f1)); % +10*h*tk Web area requirement (after deduction of cut outs) at the girder ends is given by.  
                        end
                    end
                    %}
                if Webframe_ID(i,1) == 4
                    for j=1:size(Girders,3)
                        if Girders(1,1,j) == 4
                            if t_girweb_bh(j,k) < 12*Strakes(1,4,k); %+ tk, Here is it assumed that the stiffener spacing is the same as the stiffening of the web
                                t_girweb_bh(j,k) = 12*Strakes(1,4,k);
                            else
                                t_girweb_bh(j,k) = 5.0+(k_web_gir/sqrt(f1));
                            end
                            Z_gir_bh(j,1) = 100*(((Girders(1,7,j)/100)^2)*Strakes(1,20,1)*Strakes(1,22,k)*wk/(sigma_gir_bh)) ; %antatt at Csec_width er i [cm] og m omregnast til [m], antatt at loading breadth er lik stiverlengden.

                            A_gir_bh(j,1) = (0.07*((Girders(1,7,j)/100)*Strakes(1,20,1)*Strakes(1,22,k))/(f1)); % +10*h*tk Web area requirement (after deduction of cut outs) at the girder ends is given by.                            
                        end
                    end
                end
    end
end
end 
%t_girflange_bh(i,1) = 5.0+(k_web_gir/sqrt(f1)) ;%+ tk 


for i=1:size(Girders,3)
    A_gir_bh_check(i,1) =  (A_gir_bh(i,1) - Girders(1,6,i))/(A_gir_bh(i,1) + Girders(1,6,i));

    Z_gir_bh_check(i,1) =  (Z_gir_bh(i,1) - Girders(1,4,i))/(Z_gir_bh(i,1) + Girders(1,4,i)); 
for k=1:Csec_size/2
    t_girweb_bh_check(i,k) = (t_girweb_bh(i,1)-(Girders(1,3,i)*10))./(t_girweb_bh(i,1) + (Girders(1,3,i)*10));
end
end 
%t_girflange_bh_check(i,1) = (t_girflange_bh(i,1)-(t_girflange(i,1)*10))./(t_girflange_bh(i,1)+(t_girflange(i,1)*10));

A_gir_bh_check(A_gir_bh==0)=[];
A_gir_bh(A_gir_bh==0)=[];

Z_gir_bh_check(Z_gir_bh==0)=[];
Z_gir_bh(Z_gir_bh==0)=[];

t_girweb_bh_check(t_girweb_bh==0)=[];
t_girweb_bh(t_girweb_bh==0)=[];

%t_girflange_bh_check(t_girflange_bh==0)=[];
%t_girflange_bh(t_girflange_bh==0)=[];

sigma(sigma==0)=[];

check_DL = [max(t_girweb_bh_check),max(Z_gir_bh_check),max(A_gir_bh_check),max(ZD_check),max(ZB_check),max(Z_vert_check),max(I_check),max(Z_bh_check),max(t_bh_check),max(Z_sd_check),max(t_sd_check),max(Z_db_check),max(t_lg_check),max(t_dbf_check),max(Z_ib_check),max(t_ib_check),max(Z_ls_check),max(t_side_check),max(Z_bl_check),max(t_keel_check),max(t_btm_check),max(Z_bilge_check),max(sigma_bilge_check),max(sigma_b_check),max(sigma_bl_check),max(sigma_ls_check),max(sigma_sg_check),max(sigma_ibstf_check),max(sigma_ib_check),max(sigma_lg_check),max(sigma_onbottomfloorsandgirders_check),max(sigma_strengthdeckstf_check),max(sigma_strengthdeck_check),max(sigma_lotbulkheads_check),max(sigma_simplegirdersbulkhead_check),max(t0_ib_check),max(t0_ib_check1),max(t0_sd_check),max(t0_sd_check1),max(t0_bh_check),max(t0_bh_check1),max(t0_bilge_check),max(t0_bilge_check1),max(t0_bl_check),max(t0_bl_check1),max(t0_gir_check),max(t0_gir_check1),max(t_gir_check),max(Z_gir_check)];

